package onthestage.es.onthestage;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.graphics.Bitmap;
import android.net.Uri;
import android.support.v4.view.ViewPager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.ProgressBar;
import android.widget.TextView;

import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import onthestage.es.onthestage.Service.GetAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.adapters.ArtistaPagerAdapter;
import onthestage.es.onthestage.fragments.ArtistaFragment;
import onthestage.es.onthestage.model.Artista;
import onthestage.es.onthestage.utils.AppData;

public class ArtistaInfo extends AppCompatActivity implements ArtistaFragment.OnFragmentInteractionListener {
    final static int MAX_RETRIES = 4;
    static int RETRIES = MAX_RETRIES;

    Artista artista = null;
    int mId = -1;

    @BindView(R.id.artista_pager)
    ViewPager viewPager;

    ArtistaPagerAdapter aristaPagerAdapter;


    @BindView(R.id.progressBar)
    ProgressBar progressBar;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_artista_info);

        ButterKnife.bind(this);

        if (savedInstanceState == null) {

            //Viene desde ARTISTAS PREMIUM
            if(getIntent().hasExtra(AppData.ARG_ITEM_ID)){
                mId = getIntent().getIntExtra(AppData.ARG_ITEM_ID,-1);
                AppData.ARTISTA = AppData.ARTISTAS_PREMIUM.get(mId);
                artista = AppData.ARTISTA.duplicar();
                ArtistaFragment fragment = ArtistaFragment.newInstance();

                AppData.context = this;

                //Primera Fila Cabecera nombre
                TextView tvTipoEvento = (TextView) findViewById(R.id.artista_tipoevento);
                String tipo_evento = artista.getTipo_espectaculo().getDescripcion();
                int idEvento = artista.getTipo_espectaculo().getId();
                if(idEvento>100){
                    tipo_evento = getString(R.string.live_music);
                }
                tvTipoEvento.setText(tipo_evento+": ");

                TextView tvNartista = (TextView) findViewById(R.id.artista_nartista);
                tvNartista.setText(artista.getNarnista());


                //Bottom Side
                getSupportFragmentManager().beginTransaction()
                        .add(R.id.artista_detail_container, fragment)
                        .commit();

                //Top Side


                List<String> fotos = new ArrayList<String>(artista.fotosToStringArray());
                aristaPagerAdapter = new ArtistaPagerAdapter(getSupportFragmentManager(),fotos);
                viewPager.setAdapter(aristaPagerAdapter);
                progressBar.setVisibility(View.GONE);
            }else if(getIntent().hasExtra(AppData.ARG_ITEM_ID_OTROS)){
                mId = getIntent().getIntExtra(AppData.ARG_ITEM_ID_OTROS,-1);
                getArtista();
            }




        }
    }

    @Override
    public void onFragmentInteraction(Uri uri) {

    }

    private void getArtista() {

        GetAsync ga = new GetAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject data) {
                if(data != null) {
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            Gson gson = new Gson();
                            JSONArray jsonArray = data.getJSONArray("DATA");
                            for (int i = 0; i < jsonArray.length(); i++) {
                                JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                                JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                                artista = gson.fromJson(element, Artista.class);
                            }

                            AppData.ARTISTA = artista.duplicar();

                            //Primera Fila Cabecera nombre
                            TextView tvTipoEvento = (TextView) findViewById(R.id.artista_tipoevento);
                            String tipo_evento = artista.getTipo_espectaculo().getDescripcion();
                            int idEvento = artista.getTipo_espectaculo().getId();
                            if(idEvento>100){
                                tipo_evento = getString(R.string.live_music);
                            }
                            tvTipoEvento.setText(tipo_evento+": ");

                            TextView tvNartista = (TextView) findViewById(R.id.artista_nartista);
                            tvNartista.setText(artista.getNarnista());

                            //Fin cabecera nombre


                            List<String> fotos = new ArrayList<String>(artista.fotosToStringArray());
                            aristaPagerAdapter = new ArtistaPagerAdapter(getSupportFragmentManager(),fotos);
                            viewPager.setAdapter(aristaPagerAdapter);
                            progressBar.setVisibility(View.GONE);

                            RETRIES = MAX_RETRIES;

                            //Parte inferior
                            ArtistaFragment fragment = ArtistaFragment.newInstance();

                            getSupportFragmentManager().beginTransaction()
                                    .add(R.id.artista_detail_container, fragment)
                                    .commit();

                        }else{
                            if(RETRIES>0){
                                RETRIES--;
                                getArtista();
                            }
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                }else{
                    if(RETRIES>0){
                        RETRIES--;
                        getArtista();
                    }
                }
            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        },AppData.CURRENT_USER.getToken());

        ga.execute("artista/"+mId);
    }

    @Override
    protected void onResume() {
        super.onResume();
        AppData.context = this;
    }

    @Override
    protected void onStop() {
        super.onStop();
        AppData.context = this;
    }
}
