package onthestage.es.onthestage;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.media.MediaScannerConnection;
import android.net.Uri;
import android.os.Build;
import android.os.Environment;
import android.os.StrictMode;
import android.provider.MediaStore;
import android.provider.Settings;
import android.support.annotation.NonNull;
import android.support.annotation.RequiresApi;
import android.support.constraint.ConstraintLayout;
import android.support.design.widget.Snackbar;
import android.support.design.widget.TextInputLayout;
import android.support.v4.widget.NestedScrollView;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.File;
import java.io.FileOutputStream;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import de.hdodenhof.circleimageview.CircleImageView;
import onthestage.es.onthestage.Service.PostAsyncWithFiles;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.utils.AppData;

import static android.Manifest.permission.CAMERA;
import static android.Manifest.permission.WRITE_EXTERNAL_STORAGE;

public class EditProfileActivity extends AppCompatActivity {

    private final String MEDIA_DIRECTORY = "ONTHESTAGE/temp";
    private final int PERIMISSIONS = 100;
    private final int PHOTO_INTENT = 200;
    private final int GALLERY_INTENT = 300;

    private final int RESULT_OTS = 3333;

    private boolean fotoCambiada = false;

    private String mPath;

    Calendar mCalendar;
    DatePickerDialog.OnDateSetListener date;

    boolean doingSignUp = false;

    //final Activity activity = this;
    @BindView(R.id.clsignup)
    NestedScrollView clSignUp;

    @BindView(R.id.fotoPerfil)
    CircleImageView ivFoto;

    @BindView(R.id.txtNombre)
    TextView tvNombre;

    @BindView(R.id.txtApelldos)
    TextView tvApellidos;

    @BindView(R.id.txtEmail)
    TextView tvEmail;

    @BindView(R.id.txtOldPass)
    TextView tvOldPass;

    @BindView(R.id.txtPass)
    TextView tvPass;

    @BindView(R.id.txtPass2)
    TextView tvPass2;

    @BindView(R.id.txtFnac)
    TextView tvFnac;

    @BindView(R.id.impNombre)
    TextInputLayout impNombre;
    @BindView(R.id.impEmail)
    TextInputLayout impEmail;
    @BindView(R.id.impApellidos)
    TextInputLayout impApellidos;
    @BindView(R.id.impOldPass)
    TextInputLayout impOldPass;
    @BindView(R.id.impPass)
    TextInputLayout impPass;
    @BindView(R.id.impPass2)
    TextInputLayout impPass2;
    @BindView(R.id.impFnac)
    TextInputLayout impFnac;

    @OnClick(R.id.fotoPerfil)
    public void getFoto(){
        if((!doingSignUp) && myRequestStoragePermission()){
            showOptions();
        }
    }

    @OnClick(R.id.txtFnac)
    public void getDate(){
        new DatePickerDialog(EditProfileActivity.this, date, mCalendar
                .get(Calendar.YEAR), mCalendar.get(Calendar.MONTH),
                mCalendar.get(Calendar.DAY_OF_MONTH)).show();
    }


    @BindView(R.id.progressBarLogin)
    ProgressBar pbWaiting;

    @BindView(R.id.ots_logup_btn)
    Button btnModificar;

    @OnClick(R.id.ots_logup_btn)
    public void enviar(Button button) {
        if(checkForm()){
            pbWaiting.setVisibility(View.VISIBLE);
            final String nombre = tvNombre.getText().toString();
            final String apellidos = tvApellidos.getText().toString();
            final String email = tvEmail.getText().toString();
            final String password = tvPass.getText().toString();
            final String oldpassword = tvOldPass.getText().toString();
            final String fnac = tvFnac.getText().toString();
            String foto="";
            if(fotoCambiada){
                convertPicture();
                foto=mPath;
            }

            //Todo: Save Picture in web
            Map<String, String> postData = new HashMap<>();
            postData.put("token",AppData.CURRENT_USER.getToken());
            postData.put("oldpassword", oldpassword);
            postData.put("email", email);
            postData.put("nombre", nombre);
            postData.put("apellidos", apellidos);
            if(password != null && !password.equals("")){
                postData.put("password", password);
            }
            if(fnac != null && !fnac.equals("")){
                postData.put("fnac", fnac);
            }


            PostAsyncWithFiles task = new PostAsyncWithFiles(new TaskDelegateService() {
                @Override
                public void taskServiceCompleted(JSONObject result) {

                }

                @Override
                public boolean taskServicePost(JSONObject data) {
                    pbWaiting.setVisibility(View.GONE);
                    doingSignUp = false;
                    enableViews();
                    if (data != null) {
                        try {
                            String status = (String) data.get("STATUS");
                            if (status.equals("OK")) {
                                //User updated
                                if(nombre != null && !nombre.equals(""))
                                    AppData.CURRENT_USER.setNombre(nombre);

                                if(apellidos != null && !apellidos.equals(""))
                                    AppData.CURRENT_USER.setApellidos(apellidos);

                                if(email != null && !email.equals(""))
                                    AppData.CURRENT_USER.setEmail(email);

                                if(fotoCambiada){
                                    AppData.CURRENT_USER.saveFotoPerfilBmp(EditProfileActivity.this,BitmapFactory.decodeFile(mPath));
                                }

                                AppData.CURRENT_USER.save();
                                Snackbar.make(btnModificar,getResources().getString(R.string.updated_done),Snackbar.LENGTH_SHORT).show();

                            }else{
                                String error = "Error:\n"+(String) data.get("ERROR");
                                Toast.makeText(EditProfileActivity.this,error, Toast.LENGTH_LONG ).show();
                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                        return false;
                    }else{
                        Toast.makeText(EditProfileActivity.this,getResources().getString(R.string.signuperrormessage), Toast.LENGTH_LONG ).show();
                        return false;
                    }
                }

                @Override
                public void taskGetImage(Bitmap bm) {

                }
            }, postData);
            task.execute("user/modify", foto);

            doingSignUp = true;
            disableViews();
        }

    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_edit_profile);

        ButterKnife.bind(this);


        impOldPass.setVisibility(View.VISIBLE);

        tvNombre.setText(AppData.CURRENT_USER.getNombre());
        tvApellidos.setText(AppData.CURRENT_USER.getApellidos());
        tvEmail.setText(AppData.CURRENT_USER.getEmail());
        Bitmap bmp = AppData.CURRENT_USER.getFotoPerfilBmp(this);
        if(bmp != null){
            ivFoto.setImageBitmap(bmp);
        }

        btnModificar.setText(R.string.modificar);

        /*Calendar*/
        mCalendar = Calendar.getInstance();
        mCalendar.set(Calendar.getInstance().get(Calendar.YEAR)-12,0,1);

        /*DatePicker*/
        date = new DatePickerDialog.OnDateSetListener() {
            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear,
                                  int dayOfMonth) {
                mCalendar.set(Calendar.YEAR, year);
                mCalendar.set(Calendar.MONTH, monthOfYear);
                mCalendar.set(Calendar.DAY_OF_MONTH, dayOfMonth);
                updateFecha();
            }

        };


    }

    /*
     * Actualiza la fecha del DatePicker en el textView
     * */
    private void updateFecha() {
        String myFormat = "dd/MM/yyyy"; //In which you need put here
        SimpleDateFormat sdf = new SimpleDateFormat(myFormat, Locale.US);

        tvFnac.setText(sdf.format(mCalendar.getTime()));
    }

    private boolean checkForm(){

        impNombre.setErrorEnabled(false);

        impApellidos.setErrorEnabled(false);
        impEmail.setErrorEnabled(false);
        impPass2.setErrorEnabled(false);;
        impPass.setErrorEnabled(false);
        impFnac.setErrorEnabled(false);
        boolean isValid = true;
        if(tvNombre.getText().toString().equals("")){
            impNombre.setError(getResources().getString(R.string.wrong_name));
            return false;
        }
        if(tvApellidos.getText().toString().equals("")){
            impApellidos.setError(getResources().getString(R.string.wrong_apellidos));
            return false;
        }
        if(!UserSignUp.isEmailValid(tvEmail.getText().toString())){
            impEmail.setError(getResources().getString(R.string.wrong_email));
            return false;
        }
        if(tvOldPass.getText().toString().equals("")){
            impOldPass.setError(getResources().getString(R.string.warning_change_pass));
            return false;
        }
        if(!tvPass.getText().toString().equals(tvPass2.getText().toString()) && !tvPass.getText().toString().equals("")){
            impPass2.setError(getResources().getString(R.string.no_match_passwords));
            return false;
        }
        return isValid;
    }

    /*
     * Muestra las opciones en las que abrir una imagen
     */
    private void showOptions(){
        final CharSequence[] option = {getResources().getString(R.string.fromcam),getResources().getString(R.string.fromgallery),getResources().getString(R.string.cancel)};
        final AlertDialog.Builder builder = new AlertDialog.Builder(EditProfileActivity.this);
        builder.setTitle(getResources().getString(R.string.títulodialogo));
        builder.setItems(option, new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) { //int witch 0 = first option
                switch (which){
                    case 0: //Take foto
                        openCamera();
                        break;
                    case 1:
                        openGallery();
                        break;
                    default:
                        dialog.dismiss();

                }
            }
        });
        builder.show();
    }


    /**
     * Acción para abrir la cámara
     */
    private void openCamera() {
        File file = new File(Environment.getExternalStorageDirectory(),MEDIA_DIRECTORY);
        boolean directoryExists = file.exists();
        if(!directoryExists){
            directoryExists = file.mkdirs();
        }
        if(directoryExists){
            Long timestamp = System.currentTimeMillis() / 1000;
            String imgName = "tmp.jpg";

            mPath = Environment.getExternalStorageDirectory()+ File.separator + MEDIA_DIRECTORY
                    + File.separator + imgName;

            File newFile = new File(mPath);

            //Para compatibilidad con Android N 7.0+
            StrictMode.VmPolicy.Builder builder = new StrictMode.VmPolicy.Builder();
            StrictMode.setVmPolicy(builder.build());

            Intent intent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
            intent.putExtra(MediaStore.EXTRA_SCREEN_ORIENTATION, ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
            intent.putExtra(MediaStore.EXTRA_OUTPUT, Uri.fromFile(newFile));
            startActivityForResult(intent, PHOTO_INTENT);
        }


    }

    /*
     * Acción para abrir la galería
     * */
    private void openGallery() {
        Intent getIntent = new Intent(Intent.ACTION_GET_CONTENT);
        getIntent.setType("image/*");

        Intent pickIntent = new Intent(Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
        pickIntent.setType("image/*");

        Intent chooserIntent = Intent.createChooser(getIntent, getResources().getString(R.string.select_image_app));
        chooserIntent.putExtra(Intent.EXTRA_INITIAL_INTENTS, new Intent[] {pickIntent});

        startActivityForResult(chooserIntent, GALLERY_INTENT);

    }

    /*
     * Comprobación de permisos de escritura storage y cámara
     * */
    private boolean myRequestStoragePermission(){
        if(Build.VERSION.SDK_INT < Build.VERSION_CODES.M){ //Versions under 6 (marshMallow get permissions from manifest
            return true;
        }

        if((checkSelfPermission(WRITE_EXTERNAL_STORAGE) == PackageManager.PERMISSION_GRANTED) &&
                (checkSelfPermission(CAMERA)== PackageManager.PERMISSION_GRANTED)){
            return true;
        }

        if((shouldShowRequestPermissionRationale(WRITE_EXTERNAL_STORAGE)) || (shouldShowRequestPermissionRationale(CAMERA))){
            Snackbar.make(clSignUp,getResources().getString(R.string.writestoregepermission),
                    Snackbar.LENGTH_INDEFINITE).setAction(android.R.string.ok, new View.OnClickListener() {
                @RequiresApi(api = Build.VERSION_CODES.M)
                @Override
                public void onClick(View v) {
                    requestPermissions(new String[] {WRITE_EXTERNAL_STORAGE,CAMERA}, PERIMISSIONS);
                }
            }).show();
        }else{
            requestPermissions(new String[] {WRITE_EXTERNAL_STORAGE,CAMERA}, PERIMISSIONS);
        }

        return false;

    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if(requestCode == PERIMISSIONS){
            if(grantResults.length == 2 && grantResults[0]==PackageManager.PERMISSION_GRANTED
                    && grantResults[1]==PackageManager.PERMISSION_GRANTED) {//Has two elementos STORAGE AND CAMERA
                Toast.makeText(EditProfileActivity.this,getResources().getString(R.string.accepted_permission),Toast.LENGTH_SHORT).show();

            }else{
                showExplanation();
            }
        }
    }

    /*
     * Coge el bmp del imageView y lo convierte en jpg en un directorio
     * */
    private void convertPicture() {


        File mFile = new File(Environment.getExternalStorageDirectory(),MEDIA_DIRECTORY);
        boolean directoryExists = mFile.exists();
        if(!directoryExists){
            directoryExists = mFile.mkdirs();
        }
        File file = null;
        if(directoryExists) {
            String imgName = "tmp.jpg";

            mPath = Environment.getExternalStorageDirectory() + File.separator + MEDIA_DIRECTORY
                    + File.separator + imgName;

            file = new File(mPath);
            if(file.exists()){
                file.delete();
            }
        }

        //byteArray = new byte[(int) file.length()];

        try {

            //convert array of bytes into file
            FileOutputStream fileOuputStream = new FileOutputStream(file);

            Bitmap bmp =((BitmapDrawable)ivFoto.getDrawable()).getBitmap();
            bmp.compress(Bitmap.CompressFormat.JPEG, 80, fileOuputStream);

            fileOuputStream.flush();
            fileOuputStream.close();

            MediaScannerConnection.scanFile(this, new String[]{mPath}, null, new MediaScannerConnection.OnScanCompletedListener() {
                @Override
                public void onScanCompleted(String path, Uri uri) {
                    Log.i("ExternaStorage", "Scanned " + path +":");
                    Log.i("ExternaStorage", "-> Uri =: " +uri);
                }
            });
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    private void enableViews(){
        tvFnac.setEnabled(true);
        tvNombre.setEnabled(true);
        tvApellidos.setEnabled(true);
        tvEmail.setEnabled(true);
        tvPass.setEnabled(true);
        tvOldPass.setEnabled(true);
        tvPass2.setEnabled(true);
    }

    private void disableViews() {
        tvFnac.setEnabled(false);
        tvNombre.setEnabled(false);
        tvApellidos.setEnabled(false);
        tvEmail.setEnabled(false);
        tvPass2.setEnabled(false);
        tvPass.setEnabled(false);
        tvOldPass.setEnabled(false);
    }

    private void showExplanation() {
        final AlertDialog.Builder builder = new AlertDialog.Builder(EditProfileActivity.this);
        builder.setTitle(getResources().getString(R.string.denied_permissions));
        builder.setMessage(getResources().getString(R.string.permissions));
        builder.setNegativeButton(getResources().getString(android.R.string.cancel), new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
                //finish();

            }
        });
        builder.setPositiveButton(getResources().getString(R.string.accepted_permission), new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                Intent intent = new Intent();
                intent.setAction(Settings.ACTION_APPLICATION_DETAILS_SETTINGS);
                Uri uri = Uri.fromParts("package",getPackageName(),null);
                intent.setData(uri);
                startActivity(intent);
            }
        });

        builder.show();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if(resultCode == RESULT_OK){
            fotoCambiada = true;
            switch (requestCode){
                case PHOTO_INTENT:
                    MediaScannerConnection.scanFile(EditProfileActivity.this, new String[]{mPath}, null, new MediaScannerConnection.OnScanCompletedListener() {
                        @Override
                        public void onScanCompleted(String path, Uri uri) {
                            Log.i("ExternaStorage", "Scanned " + path +":");
                            Log.i("ExternaStorage", "-> Uri =: " +uri);
                        }
                    });
                    Bitmap bitmap = BitmapFactory.decodeFile(mPath);
                    ivFoto.setImageBitmap(bitmap);
                    break;
                case GALLERY_INTENT:
                    Uri path = data.getData();
                    ivFoto.setImageURI(path);
                    break;
            }
        }
    }

}
