package onthestage.es.onthestage;
/*
 * Author: Carlos Tarazona Tárrega
 * License: Copyrigth 2018
 * Actividad EventoArtistaLocal. Usada para cargar
 * */
import android.graphics.Bitmap;
import android.support.annotation.Nullable;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.design.widget.TabLayout;
import android.support.v4.app.FragmentStatePagerAdapter;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;

import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.view.ViewPager;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;

import android.widget.ProgressBar;
import android.widget.TextView;

import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;

import onthestage.es.onthestage.Service.GetAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.fragments.ArtistaListFragment;
import onthestage.es.onthestage.fragments.EventListFragment;
import onthestage.es.onthestage.fragments.EventoFragment;
import onthestage.es.onthestage.fragments.LocalFragment;
import onthestage.es.onthestage.fragments.MapViewFragment;
import onthestage.es.onthestage.model.EventosContent;
import onthestage.es.onthestage.utils.AppData;

public class EventoArtistaLocal extends AppCompatActivity {

    final static int MAX_RETRIES = 4;
    static int RETRIES = MAX_RETRIES;

    private int idEvento;

    private String tabTitles[];
    private ProgressBar progressBar;

    private SectionsPagerAdapter mSectionsPagerAdapter;

    /**
     * The {@link ViewPager} that will host the section contents.
     */
    private ViewPager mViewPager;
    private TabLayout tabLayout;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_evento_artista_local);

        progressBar = (ProgressBar) findViewById(R.id.progressBarEvento);
        tabTitles = new String[]{getResources().getString(R.string.evento),getResources().getString(R.string.artista),getResources().getString(R.string.local)};

        if(getIntent().hasExtra(AppData.ARG_ID_EVENTO)) {
            idEvento = getIntent().getIntExtra(AppData.ARG_ID_EVENTO,-1);
            getEvento();
        }

        AppData.context = this;

        //startView();

    }


//    @Override
//    public boolean onOptionsItemSelected(MenuItem item) {
//        // Handle action bar item clicks here. The action bar will
//        // automatically handle clicks on the Home/Up button, so long
//        // as you specify a parent activity in AndroidManifest.xml.
//        int id = item.getItemId();
//        AppData.context = this;
//        FragmentManager fragmentManager = getSupportFragmentManager();
//        switch (id) {
//            case 0:
//                fragmentManager.beginTransaction().replace(R.id.container_evento_artista_local, EventoFragment.newInstance(0));
//                break;
//            case 1:
//                fragmentManager.beginTransaction().replace(R.id.container_evento_artista_local, ArtistaListFragment.newInstance(1));
//                break;
//            case 2:
//                fragmentManager.beginTransaction().replace(R.id.container_evento_artista_local, LocalFragment.newInstance(2));
//                break;
//            default:
//                fragmentManager.beginTransaction().replace(R.id.container_evento_artista_local, EventoFragment.newInstance(3));
//                break;
//        }
//            return super.onOptionsItemSelected(item);
//    }


    /**
     * A {@link FragmentPagerAdapter} that returns a fragment corresponding to
     * one of the sections/tabs/pages.
     */
    public class SectionsPagerAdapter extends FragmentPagerAdapter {

        public SectionsPagerAdapter(FragmentManager fm) {
            super(fm);
        }

        @Override
        public Fragment getItem(int position) {
            // getItem is called to instantiate the fragment for the given page.
            // Return a PlaceholderFragment (defined as a static inner class below).
            switch (position){
                case 0://Evento
                    return EventoFragment.newInstance(0);
                case 1://Artista
                    return ArtistaListFragment.newInstance(1);
                case 2://Local
                    return LocalFragment.newInstance(AppData.LF_FROM_EVENTO,-1);
                default://Evento
                    break;
            }
            return null;//EventoFragment.newInstance(0);
        }

        @Override
        public int getCount() {
            // Show 3 total pages.
            return 3;
        }

        @Nullable
        @Override
        public CharSequence getPageTitle(int position) {
            return tabTitles[position];
        }
    }

    private void startView(){
        tabLayout = (TabLayout) findViewById(R.id.tab_layout_event_artista_local);
        tabLayout.setTabMode(TabLayout.MODE_FIXED);

        mSectionsPagerAdapter = new SectionsPagerAdapter(getSupportFragmentManager());

        // Set up the ViewPager with the sections adapter.
        mViewPager = (ViewPager) findViewById(R.id.container_evento_artista_local);
        mViewPager.setAdapter(mSectionsPagerAdapter);
        mViewPager.setOffscreenPageLimit(3);

        mViewPager.addOnPageChangeListener(new ViewPager.OnPageChangeListener() {
            @Override
            public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {
                        FragmentManager fragmentManager = getSupportFragmentManager();
                switch (position) {
                    case 0:
                        fragmentManager.beginTransaction().replace(R.id.container_evento_artista_local, EventoFragment.newInstance(0));
                        break;
                    case 1:
                        fragmentManager.beginTransaction().replace(R.id.container_evento_artista_local, ArtistaListFragment.newInstance(1));
                        break;
                    case 2:
                        fragmentManager.beginTransaction().replace(R.id.container_evento_artista_local, LocalFragment.newInstance(AppData.LF_FROM_EVENTO,-1));
                        break;
                    default:
                        fragmentManager.beginTransaction().replace(R.id.container_evento_artista_local, EventoFragment.newInstance(3));
                        break;
                }

            }

            @Override
            public void onPageSelected(int position) {

            }

            @Override
            public void onPageScrollStateChanged(int state) {

            }
        });

        tabLayout.setTabGravity(TabLayout.GRAVITY_FILL);
        tabLayout.setupWithViewPager(mViewPager);

        progressBar.setVisibility(View.GONE);
    }

    public void getEvento(){

        GetAsync ga = new GetAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject data) {
                if(data != null) {
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            AppData.EVENTO = new EventosContent.Evento();
                            Gson gson = new Gson();
                            JSONArray jsonArray = data.getJSONArray("DATA");
                            JSONObject jsonObject = (JSONObject) jsonArray.get(0);
                            JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                            AppData.EVENTO = gson.fromJson(element, EventosContent.Evento.class);

                            startView();
//                            mSectionsPagerAdapter.notifyDataSetChanged();
//                            mViewPager.setCurrentItem(0);


                            RETRIES = MAX_RETRIES;
                        }else{

                            if(RETRIES>0){
                                RETRIES--;
                                getEvento();
                            }
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }


                    Log.d("DESTACADOS",AppData.EVENTOS_DESTACADOS.toString());
                }else{
                    if(RETRIES>0){
                        RETRIES--;
                        getEvento();
                    }

                }
            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        },AppData.CURRENT_USER.getToken());

        ga.execute("evento/"+idEvento);
    }

    @Override
    protected void onStop() {
        super.onStop();
        FragmentManager fragmentManager = getSupportFragmentManager();
        //fragmentManager.beginTransaction().
    }
}
