package onthestage.es.onthestage;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.content.DialogInterface;
import android.graphics.Bitmap;
import android.support.annotation.Nullable;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.design.widget.TabLayout;
import android.support.v4.app.FragmentTransaction;
import android.support.v7.app.ActionBar;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;

import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;
import android.support.v4.view.ViewPager;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;

import android.widget.ProgressBar;
import android.widget.TextView;

import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import onthestage.es.onthestage.Service.GetAsync;
import onthestage.es.onthestage.Service.LocationService;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.fragments.EventListFragment;
import onthestage.es.onthestage.fragments.MapViewFragment;
import onthestage.es.onthestage.model.EventosContent;
import onthestage.es.onthestage.utils.AppData;

public class EventsListActivity extends AppCompatActivity {

    final static int MAX_RETRIES = 4;
    static int RETRIES = MAX_RETRIES;
    private String tabTitles[];
    private boolean segundaPaginaFirst=false; //Para que el dialogo no se habra siempre;

    String url ="";

    private SectionsPagerAdapter mSectionsPagerAdapter;
    private ViewPager mViewPager;
    private TabLayout tabLayout;

    ProgressBar progressBar;

    LocationService locationService;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_events_list);

        locationService = LocationService.getLocationManager(this);

        progressBar = (ProgressBar) findViewById(R.id.progressBarEvento);
        tabTitles = new String[]{getResources().getString(R.string.lista),getResources().getString(R.string.ordenar),getResources().getString(R.string.mapa)};
        if(this.getIntent().hasExtra(AppData.SEARCH_QUERY)) {
            url = getIntent().getStringExtra(AppData.SEARCH_QUERY);
            getEventos(url);
        }




        // Create the adapter that will return a fragment for each of the three
        // primary sections of the activity.



    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        //getMenuInflater().inflate(R.menu.menu_events_list, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        FragmentManager fragmentManager = getSupportFragmentManager();
        switch (id){
            case 0:
                fragmentManager.beginTransaction().replace(R.id.event_container,EventListFragment.getInstance(AppData.LISTA_EVENTO_PRIMARY));
                break;
            case 1:
                fragmentManager.beginTransaction().replace(R.id.event_container,EventListFragment.getInstance(AppData.LISTA_EVENTO_SECONDARY));
                break;
            case 2:
                fragmentManager.beginTransaction().replace(R.id.event_container,MapViewFragment.getInstance());
                break;
            default:
                fragmentManager.beginTransaction().replace(R.id.event_container,new EventListFragment());
                break;
        }

        //noinspection SimplifiableIfStatement
//        if (id == R.id.action_settings) {
//            return true;
//        }

        return super.onOptionsItemSelected(item);
    }


    /**
     * A {@link FragmentPagerAdapter} that returns a fragment corresponding to
     * one of the sections/tabs/pages.
     */
    public class SectionsPagerAdapter extends FragmentPagerAdapter {



        public SectionsPagerAdapter(FragmentManager fm) {
            super(fm);
        }

        @Override
        public Fragment getItem(int position) {
            // getItem is called to instantiate the fragment for the given page.
            // Return a PlaceholderFragment (defined as a static inner class below).
            //return PlaceholderFragment.newInstance(position + 1);
            switch (position){
                case 0: //Event List
                    return EventListFragment.getInstance(AppData.LISTA_EVENTO_PRIMARY);

                case 1: //Order
                    return EventListFragment.getInstance(AppData.LISTA_EVENTO_SECONDARY);

                case 2: // Map
                    return MapViewFragment.getInstance();
                default: //Event List
                    return EventListFragment.getInstance(AppData.LISTA_EVENTO_PRIMARY);
            }
        }

        @Override
        public int getCount() {
            // Show 3 total pages.
            return 3;
        }

        @Nullable
        @Override
        public CharSequence getPageTitle(int position) {
            return tabTitles[position];
        }
    }

    @Override
    protected void onResume() {
        super.onResume();
        AppData.context = this;
    }

    public void getEventos(final String mUrl){
        final String auxUrl;
        progressBar.setVisibility(View.VISIBLE);
        if(!locationService.locationServiceAvailable){
            locationService.initLocationService(this);
            auxUrl=mUrl;
        }else{
            double latitude = locationService.latitude;
            double longitud = locationService.longitude;
            if(mUrl.equals("")){
                auxUrl=mUrl+"?lat="+latitude+"&long="+longitud;
            }else{
                auxUrl=mUrl+"&lat="+latitude+"&long="+longitud;
            }

        }
        GetAsync ga = new GetAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject data) {
                if(data != null) {
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            AppData.EVENTOS_MIN = new ArrayList<EventosContent.EventoMin>();
                            Gson gson = new Gson();
                            JSONArray jsonArray = data.getJSONArray("DATA");
                            for (int i = 0; i < jsonArray.length(); i++) {
                                JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                                JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                                EventosContent.EventoMin evento = gson.fromJson(element, EventosContent.EventoMin.class);
                                AppData.EVENTOS_MIN.add(evento);
                            }
                            progressBar.setVisibility(View.GONE);
                            startViews();
                            mSectionsPagerAdapter.notifyDataSetChanged();
                            mViewPager.setCurrentItem(0);



                            RETRIES = MAX_RETRIES;
                        }else{

                            if(RETRIES>0){
                                RETRIES--;
                                getEventos(auxUrl);
                            }
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }


                    Log.d("DESTACADOS",AppData.EVENTOS_DESTACADOS.toString());
                }else{
                    if(RETRIES>0){
                        RETRIES--;
                        getEventos(auxUrl);
                    }

                }
            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        },AppData.CURRENT_USER.getToken());

        ga.execute("evento/getfiltered"+auxUrl);
    }

    private void startViews(){
        tabLayout = (TabLayout) findViewById(R.id.tab_layout_event_list);
        tabLayout.setTabMode(TabLayout.MODE_FIXED);

        mSectionsPagerAdapter = new SectionsPagerAdapter(getSupportFragmentManager());

        // Set up the ViewPager with the sections adapter.
        mViewPager = (ViewPager) findViewById(R.id.event_container);
        mViewPager.setAdapter(mSectionsPagerAdapter);

        mViewPager.addOnPageChangeListener(new ViewPager.OnPageChangeListener() {
            @Override
            public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {
                if(position==1 && segundaPaginaFirst){
                    segundaPaginaFirst=false;
                    CharSequence ordenes[] = new CharSequence[] {
                            getResources().getString(R.string.precio),      //2
                            getResources().getString(R.string.distancia),   //3
                            getResources().getString(R.string.ordenarpor_fecha),//4
                            getResources().getString(R.string.num_favoritos)};//5

                    AlertDialog.Builder builder = new AlertDialog.Builder(AppData.context);
                    builder.setTitle(getResources().getString(R.string.ordenarpor));
                    builder.setItems(ordenes, new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            String urlAux = url;
                            if(url.equals("")){
                                urlAux += "?";
                            }else{
                                urlAux += "&";
                            }
                            switch (which){
                                case 0:
                                    urlAux += "orden=precio&torden=ASC";
                                    break;
                                case 1:
                                    urlAux += "orden=distancia&torden=ASC";
                                    break;
                                case 2:
                                    urlAux += "orden=dia&torden=ASC";
                                    break;
                                case 3:
                                    urlAux += "orden=numUserFabOfEvent&torden=DESC";
                                    break;
                                default:
                                    urlAux += "orden=dia&torden=ASC";
                                    break;
                            }

                            getEventos(urlAux);
                            //mViewPager.setCurrentItem(0);
                        }
                    });

                    builder.setCancelable(true);
                    builder.setOnCancelListener(new DialogInterface.OnCancelListener() {
                        @Override
                        public void onCancel(DialogInterface dialog) {
                            dialog.dismiss();
                            mViewPager.setCurrentItem(0);
                        }
                    });
                    builder.setNegativeButton(getString(R.string.cancel), new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                            mViewPager.setCurrentItem(0);
                        }
                    });
                    builder.show();
                }
                //Todo hacerlo con check box la ordenación
                /*Para hacerlo con check box!
                * final CharSequence[] items = {" Easy "," Medium "," Hard "," Very Hard "};
// arraylist to keep the selected items
final ArrayList seletedItems=new ArrayList();

AlertDialog dialog = new AlertDialog.Builder(this)
.setTitle("Select The Difficulty Level")
.setMultiChoiceItems(items, null, new DialogInterface.OnMultiChoiceClickListener() {
    @Override
    public void onClick(DialogInterface dialog, int indexSelected, boolean isChecked) {
        if (isChecked) {
            // If the user checked the item, add it to the selected items
            seletedItems.add(indexSelected);
        } else if (seletedItems.contains(indexSelected)) {
            // Else, if the item is already in the array, remove it
            seletedItems.remove(Integer.valueOf(indexSelected));
        }
    }
}).setPositiveButton("OK", new DialogInterface.OnClickListener() {
    @Override
    public void onClick(DialogInterface dialog, int id) {
        //  Your code when user clicked on OK
        //  You can write the code  to save the selected item here
    }
}).setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
    @Override
    public void onClick(DialogInterface dialog, int id) {
        //  Your code when user clicked on Cancel
    }
}).create();
dialog.show();*/



            }

            @Override
            public void onPageSelected(int position) {
                if(position==1){
                    segundaPaginaFirst = true;
                }else{
                    segundaPaginaFirst = false;
                }
            }

            @Override
            public void onPageScrollStateChanged(int state) {

            }
        });

//        tabLayout.addTab(tabLayout.newTab().setText(getResources().getString(R.string.lista)),0,true);
//        tabLayout.addTab(tabLayout.newTab().setText(getResources().getString(R.string.ordenar)),1,false);
//        tabLayout.addTab(tabLayout.newTab().setText(getResources().getString(R.string.mapa)),2,false);
//
        tabLayout.setTabGravity(TabLayout.GRAVITY_FILL);

        tabLayout.setupWithViewPager(mViewPager);
    }
}
