package onthestage.es.onthestage;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.content.Intent;
import android.net.Uri;
import android.os.Build;
import android.support.annotation.NonNull;
import android.support.design.widget.BottomNavigationView;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.widget.NestedScrollView;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;
import android.view.MenuItem;
import android.widget.Toast;

import onthestage.es.onthestage.fragments.ArtistaFragment;
import onthestage.es.onthestage.fragments.BusquedaFragment;
import onthestage.es.onthestage.fragments.FavoritoArtistaFragment;
import onthestage.es.onthestage.fragments.FavoritoEventoFragment;
import onthestage.es.onthestage.fragments.FavoritoFragment;
import onthestage.es.onthestage.fragments.FavoritoLocalFragment;
import onthestage.es.onthestage.fragments.MapViewFragment;
import onthestage.es.onthestage.menu.Menu;
import onthestage.es.onthestage.utils.AppData;

public class FavoritosBusquedasActivity extends AppCompatActivity implements FavoritoFragment.OnFragmentInteractionListener,
        BusquedaFragment.OnFragmentInteractionListener {

    public static boolean estoyFavoritos = false; //Variable para comprobar si estoy en esta actividad
    public static boolean estoyBusquedas = false; //Variable para comprobar si estoy en esta actividad

    private BottomNavigationView bottomMenu;
    private Toolbar tbPerfil;
    private Menu mMenu;
    private int tipoFragment=0;
    FragmentManager fragmentManager;
    FragmentTransaction fragmentTransaction;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_favorito_busquedas);

        tipoFragment = getIntent().getIntExtra(AppData.FAVORITOS_O_BUSQUEDA,AppData.OPEN_FAVORITOS);

    }

    private void startView() {
        AppData.context = this;

        /*Creates Menu Drawer*/
        tbPerfil = (Toolbar) findViewById(R.id.my_toolbar_busquedas);
        setSupportActionBar(tbPerfil);


        fragmentManager = getSupportFragmentManager();
        fragmentTransaction = fragmentManager.beginTransaction();
        if(tipoFragment==AppData.OPEN_FAVORITOS){//Mostramos el fragmento de favoritos
            fragmentManager.beginTransaction().replace(R.id.fav_search_container, FavoritoFragment.newInstance("","")).commit();;

            if(Build.VERSION.SDK_INT >= 21){
                getSupportActionBar().setBackgroundDrawable(getDrawable(R.color.colorFavoritos));
            }

            getSupportActionBar().setTitle(R.string.mis_favoritos);

        }else{ //Mostramos el fragmento búsqueda
            fragmentManager.beginTransaction().replace(R.id.fav_search_container, BusquedaFragment.newInstance()).commit();

            if(Build.VERSION.SDK_INT >= 21){
                getSupportActionBar().setBackgroundDrawable(getDrawable(R.color.colorBusquedas));
            }
            getSupportActionBar().setTitle(R.string.mis_busquedas);
        }
        bottomMenu = (BottomNavigationView) findViewById(R.id.navigation_bar);
        //bottomMenu.setItemIconTintList(null);
        bottomMenu.getMenu().getItem(tipoFragment).setChecked(true);
        //bottomMenu.getMenu().findItem(R.id.menu_favorites).getIcon().setColorFilter(Color.RED, PorterDuff.Mode.SRC_IN);
        //bottomMenu.getMenu().findItem(R.id.menu_searches).getIcon().setColorFilter(Color.BLUE, PorterDuff.Mode.SRC_IN);

        bottomMenu.setOnNavigationItemSelectedListener(new BottomNavigationView.OnNavigationItemSelectedListener() {
            @Override
            public boolean onNavigationItemSelected(@NonNull MenuItem item) {
                int id = item.getItemId();
                switch (id){
                    case R.id.menu_home:

                        Intent intent = new Intent(AppData.context, MainActivity.class);
                        startActivity(intent);
                        break;
                    case R.id.menu_favorites:
                        getSupportActionBar().setTitle(R.string.mis_favoritos);
                        if(Build.VERSION.SDK_INT >= 21){
                            getSupportActionBar().setBackgroundDrawable(getDrawable(R.color.colorFavoritos));
                        }
                        if(Build.VERSION.SDK_INT >= 23){
                            item.getIcon().setTint(getColor(R.color.colorFavoritos));
                        }
                        estoyFavoritos=true;
                        fragmentManager.beginTransaction().replace(R.id.fav_search_container, FavoritoFragment.newInstance("","")).addToBackStack(null).commit();
                        break;
                    case R.id.menu_searches:
                        getSupportActionBar().setTitle(R.string.mis_busquedas);
                        if(Build.VERSION.SDK_INT >= 21){
                            getSupportActionBar().setBackgroundDrawable(getDrawable(R.color.colorBusquedas));
                        }
                        if(Build.VERSION.SDK_INT >= 23){
                            item.getIcon().setTint(getColor(R.color.colorBusquedas));
                        }
                        estoyBusquedas = true;
                        fragmentManager.beginTransaction().replace(R.id.fav_search_container, BusquedaFragment.newInstance()).addToBackStack(null).commit();
                        break;
                    default:
                        Toast.makeText(AppData.context,"Estoy en home", Toast.LENGTH_LONG).show();
                        break;
                }
                item.setChecked(true);
                return false;
            }
        });

        NestedScrollView scrollView = (NestedScrollView) findViewById (R.id.fav_search_container);
        scrollView.setFillViewport (true);//Para poder poner un ViewPager dentro



        mMenu = new Menu(this,tbPerfil );
    }

    @Override
    public void onFragmentInteraction(Uri uri) {

    }

    @Override
    protected void onResume() {
        super.onResume();
        startView();
    }

    @Override
    protected void onStop() {
        super.onStop();
        estoyBusquedas = false;
        estoyFavoritos = false;
    }
}
