package onthestage.es.onthestage;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.Toolbar;

import onthestage.es.onthestage.fragments.FavoritoEventoFragment;
import onthestage.es.onthestage.menu.Menu;
import onthestage.es.onthestage.utils.AppData;

public class HistoricoEventosActivity extends AppCompatActivity {
    int from = 0;
    int idTarget=-1;
    Toolbar toolbar;
    Menu mMenu;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_historico_eventos);
        toolbar = (Toolbar) findViewById(R.id.historico_toolbar);
        setSupportActionBar(toolbar);
        getSupportActionBar().setTitle("");

        mMenu = new Menu(this,toolbar );

        Intent intent = getIntent();
        if(intent.hasExtra(AppData.FROM__TAG)){
            this.from = intent.getIntExtra(AppData.FROM__TAG, 0);
        }
        if(intent.hasExtra(AppData.ARG_ITEM_ID)){
            this.idTarget = intent.getIntExtra(AppData.ARG_ITEM_ID, -1);
        }

        switch (from){
            case AppData.FROM_ARTISTAS:
                getSupportActionBar().setTitle(getString(R.string.historial_artistas));
                break;
            case AppData.FROM_LOCALES:
                getSupportActionBar().setTitle(getString(R.string.historial_local));
                break;
            default:
                getSupportActionBar().setTitle(getString(R.string.historial));
                break;
        }

        getSupportFragmentManager().beginTransaction().add(R.id.historico_fragment_container, FavoritoEventoFragment.newInstance(from,idTarget)).commit();
    }
}
