package onthestage.es.onthestage;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;

import android.graphics.BitmapFactory;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;

import android.os.Handler;
import android.support.annotation.NonNull;
import android.support.design.widget.BottomNavigationView;
import android.support.v4.graphics.drawable.RoundedBitmapDrawable;
import android.support.v4.graphics.drawable.RoundedBitmapDrawableFactory;
import android.support.v4.view.ViewPager;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;
import android.support.v7.widget.Toolbar;

import com.facebook.AccessToken;
import com.facebook.login.LoginManager;
import com.facebook.stetho.Stetho;
import com.google.android.gms.auth.api.Auth;
import com.google.android.gms.auth.api.signin.GoogleSignInAccount;
import com.google.android.gms.auth.api.signin.GoogleSignInResult;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.common.api.OptionalPendingResult;
import com.google.android.gms.common.api.ResultCallback;
import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import de.hdodenhof.circleimageview.CircleImageView;
import onthestage.es.onthestage.Service.GetAsync;
import onthestage.es.onthestage.Service.LocationService;
import onthestage.es.onthestage.Service.PostAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.menu.Menu;
import onthestage.es.onthestage.model.Artista;
import onthestage.es.onthestage.model.CurrentUser;
import onthestage.es.onthestage.model.EventosContent;
import onthestage.es.onthestage.sliders.MyPageAdapter;
import onthestage.es.onthestage.utils.AppData;

public class MainActivity extends AppCompatActivity implements TaskDelegateService {
//    private GoogleApiClient googleApiClient;
    private ProgressBar pbInicial;
    private LinearLayout layoutBottomMenu, layoutNick;
    private Button btnSearch;
    //private CircleImageView imageViewNick;
    //private TextView tvNick;
    private Toolbar tbPerfil;
    private BottomNavigationView bottomMenu;
    private Menu mMenu;
    private ViewPager pagerDestacado, pagerPremium;
    private MyPageAdapter pagerAdapterDestacado, pagerAdapterPremium;
    int currentPageDestacado;
    int numPagesDestacdo;
    int currentPagePremium;
    int numPagesPremium;
    static int enableComponents=2;

    public static int intentosLogin = 3;

    GoogleApiClient googleApiClient;

    Runnable login = new Runnable() {
        @Override
        public void run() {
            if(AppData.CURRENT_USER != null && intentosLogin>0){
                checkValidUser(AppData.CURRENT_USER.getToken());
                intentosLogin--;
                handler.postDelayed(login,1000);
            }else{
                intentosLogin = 3;
                goLoginScreen();
            }

        }
    };

    final Handler handler = new Handler();
    /*Handle with destacado slider*/
    Runnable d = new Runnable() {

        public void run() {
            if(pagerDestacado!=null){
                if (currentPageDestacado == numPagesDestacdo - 1) {
                    EventosContent.Evento primero = AppData.EVENTOS_DESTACADOS.get(AppData.EVENTOS_DESTACADOS.size()-1);
                    AppData.EVENTOS_DESTACADOS.remove(AppData.EVENTOS_DESTACADOS.size()-1);
                    AppData.EVENTOS_DESTACADOS.add(0,primero);
                    pagerAdapterDestacado = new MyPageAdapter(getSupportFragmentManager(),AppData.IS_DESTACADO );
                    pagerDestacado.setAdapter(pagerAdapterDestacado);
                    pagerAdapterDestacado.notifyDataSetChanged();
                    currentPageDestacado = 0;
                }
                else {
                    currentPageDestacado++;

                }
                pagerDestacado.setCurrentItem(currentPageDestacado, false);
            }

            if(currentPagePremium == 0){
                handler.postDelayed(d,1000);
            }else{
                handler.postDelayed(d,2000);
            }

        }

    };
    /*Handle with premium slider*/
    Runnable p = new Runnable() {

        public void run() {
            if(pagerPremium!=null){
                if (currentPagePremium == numPagesPremium - 1) {
                    Artista primero = AppData.ARTISTAS_PREMIUM.get(AppData.ARTISTAS_PREMIUM.size()-1);
                    AppData.ARTISTAS_PREMIUM.remove(AppData.ARTISTAS_PREMIUM.size()-1);
                    AppData.ARTISTAS_PREMIUM.add(0,primero);
                    pagerAdapterPremium = new MyPageAdapter(getSupportFragmentManager(),AppData.IS_PREMIUM );
                    pagerPremium.setAdapter(pagerAdapterPremium);
                    pagerAdapterPremium.notifyDataSetChanged();
                    currentPagePremium = 0;
                }
                else {
                    currentPagePremium++;

                }
                pagerPremium.setCurrentItem(currentPagePremium, true);
            }

            if(currentPagePremium == 0){
                handler.postDelayed(p,1000);
            }else{
                handler.postDelayed(p,2000);
            }


        }

    };


    AppData appData;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //For watching database in browser
        Stetho.initializeWithDefaults(this);

        setContentView(R.layout.activity_main);

        startFunctions();


    }


    private void disableAllComponents() {
//        try{
//            Thread.sleep(1000);
//        }catch (InterruptedException e){
//            Log.e("ERROR DORMIR",e.getLocalizedMessage());
//        }

        enableComponents=2;

        pbInicial=(ProgressBar)findViewById(R.id.progressBarLogin);
        pbInicial.setVisibility(View.VISIBLE);
        layoutBottomMenu = (LinearLayout) findViewById(R.id.layout_bottom_menu);
        layoutBottomMenu.setVisibility(View.INVISIBLE);
        AppData.context = this;

        bottomMenu = (BottomNavigationView) findViewById(R.id.navigation_bar);
        //bottomMenu.setItemIconTintList(null);
        bottomMenu.getMenu().getItem(0).setChecked(true);
        //bottomMenu.getMenu().findItem(R.id.menu_favorites).getIcon().setColorFilter(Color.RED, PorterDuff.Mode.SRC_IN);
        //bottomMenu.getMenu().findItem(R.id.menu_searches).getIcon().setColorFilter(Color.BLUE, PorterDuff.Mode.SRC_IN);

        bottomMenu.setOnNavigationItemSelectedListener(new BottomNavigationView.OnNavigationItemSelectedListener() {
            @Override
            public boolean onNavigationItemSelected(@NonNull MenuItem item) {
                int id = item.getItemId();
                //Todo: Cambiar colores a los menus, Rojo favoritos, azul búsquedas
                //Todo: Menú con fragemtos
                switch (id){
                    case R.id.menu_home:
                        Toast.makeText(AppData.context,"Estoy en home", Toast.LENGTH_LONG).show();
                        break;
                    case R.id.menu_favorites:
                        handler.removeCallbacks(p);
                        handler.removeCallbacks(d);
                       Intent intent = new Intent(AppData.context,FavoritosBusquedasActivity.class);
                       intent.putExtra(AppData.FAVORITOS_O_BUSQUEDA, AppData.OPEN_FAVORITOS);
                       startActivity(intent);
                        break;
                    case R.id.menu_searches:
                        handler.removeCallbacks(p);
                        handler.removeCallbacks(d);
                        Intent intent2 = new Intent(AppData.context,FavoritosBusquedasActivity.class);
                        intent2.putExtra(AppData.FAVORITOS_O_BUSQUEDA, AppData.OPEN_BUSQUEDA);
                        startActivity(intent2);
                        break;
                    default:
                        Toast.makeText(AppData.context,"Estoy en home", Toast.LENGTH_LONG).show();
                        break;
                }
                item.setChecked(true);
                return false;
            }
        });


        /*layoutNick = (LinearLayout) findViewById(R.id.layout_nick);
        layoutNick.setVisibility(View.INVISIBLE);
        tvNick = (TextView) findViewById(R.id.text_nick);
        tvNick.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                mMenu.showMenu();
            }
        });
        if(AppData.CURRENT_USER.getTipousuario()<3){
            tvNick.setText(AppData.CURRENT_USER.getNombre());
        } else if(AppData.CURRENT_USER.getTipousuario()<5){
            tvNick.setText(AppData.CURRENT_USER.getNartista());
        }*/
        /*Creates Menu Drawer*/
        tbPerfil = (Toolbar) findViewById(R.id.my_toolbar);
        setSupportActionBar(tbPerfil);
        getSupportActionBar().setTitle(getResources().getString(R.string.app_name));

        btnSearch = (Button) findViewById(R.id.btn_search );
        final Context context = this;
        btnSearch.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                handler.removeCallbacks(p);
                handler.removeCallbacks(d);
                Intent intent = new Intent(context, UserSearch.class);
                startActivity(intent);
            }
        });
        btnSearch.setVisibility(View.INVISIBLE);
        //imageViewNick = (CircleImageView) findViewById(R.id.img_nick);
    }

    private void enableAllComponents() {

        pbInicial.setVisibility(View.GONE);
        layoutBottomMenu.setVisibility(View.VISIBLE);
        //layoutNick.setVisibility(View.VISIBLE);
        btnSearch.setVisibility(View.VISIBLE);
        AppData.context = this;

        pagerDestacado = (ViewPager) findViewById(R.id.pager_destacado);
        pagerDestacado.addOnPageChangeListener(new ViewPager.OnPageChangeListener() {
            @Override
            public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {

            }

            @Override
            public void onPageSelected(int position) {
                currentPageDestacado = position;
            }

            @Override
            public void onPageScrollStateChanged(int state) {

            }
        });

        pagerAdapterDestacado = new MyPageAdapter(getSupportFragmentManager(),AppData.IS_DESTACADO );

        pagerDestacado.setAdapter(pagerAdapterDestacado);

        currentPageDestacado = pagerDestacado.getCurrentItem();
        numPagesDestacdo = pagerDestacado.getAdapter().getCount();
        handler.removeCallbacks(d);
        handler.postDelayed(d,2000);




        pagerPremium = (ViewPager) findViewById(R.id.pager_premium);
        pagerPremium.addOnPageChangeListener(new ViewPager.OnPageChangeListener() {
            @Override
            public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {

            }

            @Override
            public void onPageSelected(int position) {
                currentPagePremium = position;
            }

            @Override
            public void onPageScrollStateChanged(int state) {

            }
        });

        pagerAdapterPremium = new MyPageAdapter(getSupportFragmentManager(),AppData.IS_PREMIUM );

        pagerPremium.setAdapter(pagerAdapterPremium);

        currentPagePremium = pagerPremium.getCurrentItem();
        numPagesPremium = pagerPremium.getAdapter().getCount();
        handler.removeCallbacks(p);
        handler.postDelayed(p,2000);

        mMenu = new Menu(this,tbPerfil );

        LocationService ls = LocationService.getLocationManager(this);
     }

    private void checkValidUser(String token) {
        Map<String, String> postData = new HashMap<>();
        postData.put("token", token);
        PostAsync task = new PostAsync(this,postData);
        task.execute("validuser");
    }

    @Override
    protected void onStart() {
      super.onStart();
        AppData.context = this;
        enableComponents = 2;
//        handler.removeCallbacks(d);
//        handler.removeCallbacks(p);
//        handler.postDelayed(d,2000);
//        handler.postDelayed(p,2000);
//        OptionalPendingResult<GoogleSignInResult> opr = Auth.GoogleSignInApi.silentSignIn(googleApiClient);
//        if(opr.isDone()){
//            GoogleSignInResult result = opr.get();
//            handleLoginGoogle(result);
//        }else{
//            opr.setResultCallback(new ResultCallback<GoogleSignInResult>() {
//              @Override
//                public void onResult(@NonNull GoogleSignInResult googleSignInResult) {
//                    handleLoginGoogle(googleSignInResult);
//                }
//            });
//        }
    }

//    private void handleLoginGoogle(GoogleSignInResult result) {
//        if(result.isSuccess()){
//            GoogleSignInAccount account = result.getSignInAccount();
//            String nombre = account.getDisplayName();
//            String email = account.getEmail();
//            Toast.makeText(this, email, Toast.LENGTH_LONG);
//            //Log.d("FOTO", account.getPhotoUrl().toString());
//        }else {
//            /*Check if user has been logged by Facebook*/
//            if (AccessToken.getCurrentAccessToken() == null) {
//                goLoginScreen();
//            }
//        }}

    private void goLoginScreen() {
        handler.removeCallbacks(d);
        handler.removeCallbacks(p);
        Intent intent = new Intent(this, Presentation.class);
        intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK);
        startActivity(intent);
    }

    /*LogOut */
    public void logOut(View view) {
        handler.removeCallbacks(d);
        handler.removeCallbacks(p);
        LoginManager.getInstance().logOut();
        goLoginScreen();
    }

    @Override
    public void taskServiceCompleted(JSONObject result) {

    }

    @Override
    public boolean taskServicePost(JSONObject data) {
        if(data != null) {
            try {
                String status = (String) data.get("STATUS");
                if (status.equals("OK")) {
                    getArtistasPremium();
                    getEventosDestacados();
                    Bitmap bmpNick = AppData.CURRENT_USER.getFotoPerfilBmp(this);
                    if(bmpNick == null){
                        String url="";
                        if(AppData.CURRENT_USER.getProcedencia() == AppData.FROM_OTS){
                            url = AppData.REST_BASE_URI+"fotoany/usuario/"+AppData.CURRENT_USER.getFotoperfil();
                        }else{
                            url = AppData.CURRENT_USER.getFotoperfil();
                        }

                        //AppData.getGlide(this,url,imageViewNick);
                        AppData.glideSaveBMPinLocal(this,url,AppData.FOTO_PERFIL);
                    }//else{
                     //   setRoundImageNick(bmpNick);
                    //}
                }else{
                    goLoginScreen();//Todo: Repetir más intentos
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }else{
            handler.postDelayed(login, 1000);

        }
        return false;
    }

    @Override
    public void taskGetImage(Bitmap bmp) {
        //setRoundImageNick(bmp);
        if(!AppData.CURRENT_USER.saveFotoPerfilBmp(this,bmp)){
            Toast.makeText(this,R.string.error_saving_image, Toast.LENGTH_LONG).show();
        }
    }

    /*private void setRoundImageNick(Bitmap bmp){
        if(bmp!=null){
            RoundedBitmapDrawable roundedDrawable =
                    RoundedBitmapDrawableFactory.create(getResources(), bmp);

            //asignamos el CornerRadius
            roundedDrawable.setCornerRadius(bmp.getHeight());

            imageViewNick.setImageDrawable(roundedDrawable);
        }else{
            RoundedBitmapDrawable roundedDrawable =
                    RoundedBitmapDrawableFactory.create(getResources(), BitmapFactory.decodeResource(this.getResources(),
                            R.drawable.noimage));
            //asignamos el CornerRadius
            roundedDrawable.setCornerRadius(bmp.getHeight());

            imageViewNick.setImageDrawable(roundedDrawable);
        }
    }*/

    public boolean isOnline() {
        ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        boolean res = netInfo != null && netInfo.isConnectedOrConnecting();
        return res;
    }

/*    @Override
    public void onConnectionFailed(@NonNull ConnectionResult connectionResult) {
        Log.e("ERROR_LOGIN_GOOGLE",connectionResult.getErrorMessage());
        Toast.makeText(getApplicationContext(), R.string.error_login, Toast.LENGTH_LONG).show();
    }*/

//    public GoogleApiClient getGoogleApiClient(){
//        return this.googleApiClient;
//    }

    public void getArtistasPremium() {
        GetAsync ga = new GetAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject data) {
                if(data != null) {
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            AppData.ARTISTAS_PREMIUM = new ArrayList<Artista>();
                            Gson gson = new Gson();
                            JSONArray jsonArray = data.getJSONArray("DATA");
                            for (int i = 0; i < jsonArray.length(); i++) {
                                JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                                JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                                Artista artista = gson.fromJson(element, Artista.class);
                                AppData.ARTISTAS_PREMIUM.add(artista);
                            }

                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                    enableComponents--;
                    if(enableComponents==0){
                        enableAllComponents();
                    }

                    Log.d("PREMIUMS",AppData.ARTISTAS_PREMIUM.toString());
                }else{
                    getArtistasPremium();
                }
            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        },AppData.CURRENT_USER.getToken());

        ga.execute("artista/destacados");
    }

    public void getEventosDestacados() {
        GetAsync ga = new GetAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject data) {
                if(data != null) {
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            AppData.EVENTOS_DESTACADOS = new ArrayList<EventosContent.Evento>();
                            Gson gson = new Gson();
                            JSONArray jsonArray = data.getJSONArray("DATA");
                            for (int i = 0; i < jsonArray.length(); i++) {
                                JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                                JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                                EventosContent.Evento evento = gson.fromJson(element, EventosContent.Evento.class);
                                AppData.EVENTOS_DESTACADOS.add(evento);
                            }

                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                    enableComponents--;
                    if(enableComponents==0){
                        enableAllComponents();
                    }


                    Log.d("DESTACADOS",AppData.EVENTOS_DESTACADOS.toString());
                }else{

                    getEventosDestacados();
                }
            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        },AppData.CURRENT_USER.getToken());

        ga.execute("evento/destacados");
    }

    @Override
    protected void onResume() {
        super.onResume();
        AppData.context = this;
        enableComponents = 2;
        if(AppData.CURRENT_USER != null){
            try{
                handler.removeCallbacks(d);
                handler.removeCallbacks(p);
                handler.postDelayed(d,2500);
                handler.postDelayed(p,1800);
            }catch (NullPointerException e){
                Log.e("ERROR-MAIN_ACTIVITY", e.getLocalizedMessage());
            }catch (Exception e){
                Log.e("ERROR-MAIN_ACTIVITY", e.getLocalizedMessage());
            }

        }
    }

    @Override
    protected void onStop(){
        super.onStop();
        handler.removeCallbacks(d);
        handler.removeCallbacks(p);
    }

    @Override
    public boolean isDestroyed() {
        return super.isDestroyed();
    }

    @Override
    protected void onRestart() {
        super.onRestart();
        intentosLogin = 3;
        startFunctions();
    }

    private void startFunctions(){
        if(!isOnline()){
            Toast.makeText(this,R.string.no_internet,Toast.LENGTH_LONG).show();
            //Snackbar.make(,R.string.no_internet,Snackbar.LENGTH_SHORT).show();

        }else {

            appData = AppData.getInstance();
            appData.init();

            AppData.CURRENT_USER = CurrentUser.first(CurrentUser.class);
            if (AppData.CURRENT_USER == null) {
                goLoginScreen();
            } else {
                checkValidUser(AppData.CURRENT_USER.getToken());
                disableAllComponents();
            }

//        GoogleSignInOptions gso = new GoogleSignInOptions.Builder(GoogleSignInOptions.DEFAULT_SIGN_IN)
//                .requestEmail()
//                .build();
//
//        googleApiClient = new GoogleApiClient.Builder(this)
//                .enableAutoManage(this, this)
//                .addApi(Auth.GOOGLE_SIGN_IN_API,gso)
//                .build();
            /*End check login with android*/
        }
    }
}
