package onthestage.es.onthestage;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.net.Uri;
import android.support.annotation.NonNull;
import android.support.design.widget.TextInputEditText;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.util.Patterns;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import com.bumptech.glide.Glide;
import com.facebook.CallbackManager;
import com.facebook.FacebookCallback;
import com.facebook.FacebookException;
import com.facebook.FacebookSdk;
import com.facebook.GraphRequest;
import com.facebook.GraphResponse;
import com.facebook.appevents.AppEventsLogger;
import com.facebook.login.LoginManager;
import com.facebook.login.LoginResult;
import com.facebook.login.widget.LoginButton;
import com.google.android.gms.auth.api.Auth;
import com.google.android.gms.auth.api.signin.GoogleSignInAccount;
import com.google.android.gms.auth.api.signin.GoogleSignInOptions;
import com.google.android.gms.auth.api.signin.GoogleSignInResult;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.SignInButton;
import com.google.android.gms.common.api.GoogleApiClient;
import com.google.android.gms.common.api.ResultCallback;
import com.google.android.gms.common.api.Status;
import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ExecutionException;
import java.util.regex.Pattern;

import onthestage.es.onthestage.Service.GetAsync;
//import onthestage.es.onthestage.Service.HandlerComunidades;
import onthestage.es.onthestage.Service.MyCallBack;
import onthestage.es.onthestage.Service.PostAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.model.Comunidad;
import onthestage.es.onthestage.model.CurrentUser;
import onthestage.es.onthestage.utils.AppData;

public class Presentation extends AppCompatActivity implements GoogleApiClient.OnConnectionFailedListener, TaskDelegateService {

    private LoginButton fb_Login_button;
    private CallbackManager fbCallbackManager;

    private GoogleApiClient googleApiClient;
    private SignInButton ggl_Login_button;

    private FrameLayout login_panel;

    private final int RESULT_GOOGLE = 1111;
    private final int RESULT_FACEBOOK = 2222;
    private final int RESULT_OTS = 3333;

    /*LOGIN PANEL ELEMENTS*/
    private TextInputEditText teUser;
    private TextInputEditText tePass;
    private ProgressBar pbLogin;
    private TextView tvResult;
    private Button btnLogin, btnLogup;

    private boolean login_btn_pressed = false;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_presentation);

        tvResult = (TextView) findViewById(R.id.txt_login_result);
        pbLogin = (ProgressBar) findViewById(R.id.progressBarLogin);
        pbLogin.setVisibility(View.GONE);
        btnLogin = (Button) findViewById(R.id.ots_login_btn);
        btnLogup = (Button) findViewById(R.id.ots_logup_btn);

        /*Facebook Login*******************************************************************************************/
        fbCallbackManager = CallbackManager.Factory.create();

        fb_Login_button = (LoginButton) findViewById(R.id.fb_login_button);


        //fb_Login_button.setBackgroundResource(R.drawable.facebook);
        //Set ReadEmail Permission
        fb_Login_button.setReadPermissions(Arrays.asList("email"));
        fb_Login_button.registerCallback(fbCallbackManager, new FacebookCallback<LoginResult>() {
            @Override
            public void onSuccess(LoginResult loginResult) {
                handleFaceBookLogin(loginResult);
            }

            @Override
            public void onCancel() {
                Toast.makeText(getApplicationContext(), R.string.cancel_login, Toast.LENGTH_LONG).show();
            }

            @Override
            public void onError(FacebookException error) {
                showLoginError();
            }
        });

        /*End Facebook Login**************************************************************************************/

        /*Google Login********************************************************************************************/
        GoogleSignInOptions gso = new GoogleSignInOptions.Builder(GoogleSignInOptions.DEFAULT_SIGN_IN)
                .requestEmail()
                .build();

        googleApiClient = new GoogleApiClient.Builder(this)
                .enableAutoManage(this, this)
                .addApi(Auth.GOOGLE_SIGN_IN_API,gso)
                .build();

        ggl_Login_button = (SignInButton) findViewById(R.id.ggl_login_button);
        setGooglePlusButtonText(ggl_Login_button,getString(R.string.google_signin_text));
        ggl_Login_button.setSize(SignInButton.SIZE_WIDE);
        ggl_Login_button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = Auth.GoogleSignInApi.getSignInIntent(googleApiClient);
                startActivityForResult(intent, RESULT_GOOGLE );
            }
        });

        /*End google login****************************************************************************************/

        login_panel = (FrameLayout) findViewById(R.id.login_panel);

    }

    private void handleFaceBookLogin(LoginResult loginResult) {

        final String urlFoto = "https://graph.facebook.com/"+loginResult.getAccessToken().getUserId()+"/picture?type=large";
        GraphRequest request =  GraphRequest.newMeRequest(
                loginResult.getAccessToken(), new GraphRequest.GraphJSONObjectCallback() {
                    @Override
                    public void onCompleted(JSONObject me, GraphResponse response) {

                        if (response.getError() != null) {
                            // handle error
                        } else {

                            String user_lastname = me.optString("last_name");
                            String user_firstname = me.optString("first_name");
                            String user_email =response.getJSONObject().optString("email");

                            CurrentUser cu = AppData.CURRENT_USER;
                            if(cu == null){
                                CurrentUser.delete(CurrentUser.class);
                                cu = new CurrentUser();
                            }
                            cu.setEmail(user_email);
                            cu.setNombre(user_firstname);
                            String foto = AppData.NO_USER_IMAGE;
                            if(urlFoto != null && !urlFoto.equals("")){
                                foto = urlFoto.toString();
                            }


                            cu.setFotoperfil(foto);
                            cu.setApellidos(user_lastname);
                            cu.setTipousuario(AppData.USER_STANDARD);
                            cu.setActivado(1);
                            cu.setProcedencia(AppData.FROM_FACEBOOK);
                            cu.save();
                            AppData.CURRENT_USER = cu;
                            AppData.glideSaveExternalBMPinLocal(Presentation.this,foto,AppData.FOTO_PERFIL);
                            AppData.CURRENT_USER.guardarUsuarioEnBDWeb(new MyCallBack() {
                                @Override
                                public void callbackCall() {
                                    goMainScreen();
                                }
                            });

                            LoginManager.getInstance().logOut();

                        }
                    }
                });

        Bundle parameters = new Bundle();
        parameters.putString("fields", "last_name,first_name,email");
        request.setParameters(parameters);
        request.executeAsync();
    }


    /* Activity Result For login */
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        switch (requestCode){

            case RESULT_GOOGLE:
                GoogleSignInResult result = Auth.GoogleSignInApi.getSignInResultFromIntent(data);
                ProgressBar pb = (ProgressBar) findViewById(R.id.progressBarPresentacion);
                pb.setVisibility(View.VISIBLE);
                handleGoogleLogin(result);
                break;
            case RESULT_FACEBOOK:
                fbCallbackManager.onActivityResult(requestCode, resultCode, data);
                break;
            case RESULT_OTS:
                if(resultCode == Activity.RESULT_OK) {
                    login_panel.setVisibility(View.GONE);
                    Toast.makeText(this, getResources().getString(R.string.signupmessage), Toast.LENGTH_LONG).show();
                }//else{
//                    Toast.makeText(this,getResources().getString(R.string.signuperrormessage), Toast.LENGTH_LONG ).show();
//                }
                break;
            default: //Don't know facebook requestCode
                ProgressBar pb2 = (ProgressBar) findViewById(R.id.progressBarPresentacion);
                pb2.setVisibility(View.VISIBLE);
                fbCallbackManager.onActivityResult(requestCode, resultCode, data);
                break;
        }
    }

    private void handleGoogleLogin(GoogleSignInResult result) {

        if(result.isSuccess()){
            GoogleSignInAccount account = result.getSignInAccount();
            String email = account.getEmail();
            String nombre = account.getDisplayName();
            String apellidos  = account.getFamilyName();
            final Uri urlFoto = account.getPhotoUrl();
            final Context context = this;

            CurrentUser cu = AppData.CURRENT_USER;
            if(cu == null){
                CurrentUser.delete(CurrentUser.class);
                cu = new CurrentUser();
            }
            cu.setEmail(email);
            cu.setNombre(nombre);
            String foto = AppData.NO_USER_IMAGE;
            if(urlFoto != null && !urlFoto.equals("")){
                foto = urlFoto.toString();
            }


            cu.setFotoperfil(foto);
            cu.setApellidos(apellidos);
            cu.setTipousuario(AppData.USER_STANDARD);
            cu.setActivado(1);
            cu.setProcedencia(AppData.FROM_GOOGLE);
            cu.save();
            AppData.CURRENT_USER = cu;

            AppData.CURRENT_USER.guardarUsuarioEnBDWeb(new MyCallBack() {
                @Override
                public void callbackCall() {
                    goMainScreen();
                }
            });


//            Bitmap bmp = AppData.getGlide(this,url);
//            try {
//
//                bmp = Glide.with(context).asBitmap().load(urlFoto).submit(-1,-1).get();
//
//            }catch (ExecutionException ee){
//                Log.e("ERROR", "ERROR GETTING IMAGE FROM GOOGLE");
//            }catch (InterruptedException ie){
//                Log.e("ERROR", "ERROR GETTING IMAGE FROM GOOGLE");
//            }
//            new ThreadSaveFoto(bmp, context).start();

            Auth.GoogleSignInApi.revokeAccess(googleApiClient).setResultCallback(new ResultCallback<Status>() {
                @Override
                public void onResult(@NonNull Status status) {
                    if(status.isSuccess()){
                        Log.i("PRESENTATION", "GOOGLE LOGOUT");
                    }
                }
            });


        }else{
            Log.e("ERROR_LOG",result.getStatus().toString());
            showLoginError();
        }
    }

    private class ThreadSaveFoto extends Thread{
        Bitmap bmp;
        Context context;
        public ThreadSaveFoto(Bitmap bmp, Context context) {
            this.bmp = bmp;
            this.context = context;
        }

        public void run(){
            if(bmp == null){
                bmp = BitmapFactory.decodeResource(getResources(),R.drawable.noimage);
            }
            AppData.CURRENT_USER.saveFotoPerfilBmp(context,bmp);
        }
    }

    private void goMainScreen(){
        ProgressBar pb = (ProgressBar) findViewById(R.id.progressBarPresentacion);
        pb.setVisibility(View.GONE);
        Intent intent = new Intent(this, MainActivity.class);
        intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK);
        startActivity(intent);
    }

    @Override
    public void onConnectionFailed(@NonNull ConnectionResult connectionResult) {
        showLoginError();
    }



    private void showLoginError(){
        Toast.makeText(getApplicationContext(), R.string.error_login, Toast.LENGTH_LONG).show();
    }

    public void showLoginPanel(View view) {
        login_panel.setVisibility(View.VISIBLE);
    }

    protected void setGooglePlusButtonText(SignInButton signInButton, String buttonText) {
        // Find the TextView that is inside of the SignInButton and set its text
        for (int i = 0; i < signInButton.getChildCount(); i++) {
            View v = signInButton.getChildAt(i);

            if (v instanceof TextView) {
                TextView tv = (TextView) v;
                tv.setText(buttonText);
                return;
            }
        }
    }

    //SIGN IN WITH ONTHESTAGE
    public void loginOnTheStage(View view) {

        tvResult.setText("");
        tePass = (TextInputEditText) findViewById(R.id.txtEditPass);
        teUser = (TextInputEditText) findViewById(R.id.txtEditUser);

        /*Close soft keyboard*/
        InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
        imm.hideSoftInputFromWindow(tePass.getWindowToken(), 0);

        if(teUser.getText().toString().equals("")){
            tvResult.setText(getString(R.string.empty_user));
            login_btn_pressed = false;
            return;
        }
        if(Patterns.EMAIL_ADDRESS.matcher(teUser.getText().toString()).matches()==false){
            tvResult.setText(getString(R.string.invalid_email));
            login_btn_pressed = false;
            return;
        }
        if(tePass.getText().toString().equals("")){
            tvResult.setText(getString(R.string.empty_pass));
            login_btn_pressed = false;
            return;
        }
        //Send Login Request
        btnLogin.setEnabled(false);
        btnLogup.setEnabled(false);
        pbLogin.setVisibility(View.VISIBLE);
        login_btn_pressed = true;
        String user = teUser.getText().toString();
        String password = tePass.getText().toString();
        Map<String, String> postData = new HashMap<>();
        postData.put("email", user);
        postData.put("password", password);
        PostAsync task = new PostAsync(this,postData);
        task.execute("user/signin");


//        pbLogin = (ProgressBar) findViewById(R.id.pr);

    }

    //SIGN UP WITH ONTHESTAGE
    public void logupOnTheStage(View view) {
        //login_panel.setVisibility(View.GONE);
        Intent intent = new Intent(this, UserSignUp.class);
        startActivityForResult(intent, RESULT_OTS);


    }

    @Override
    public void onBackPressed() {
        if(login_panel.getVisibility() == View.GONE){
            super.onBackPressed();
        }else if (!login_btn_pressed ){
            login_panel.setVisibility(View.GONE);
        }
    }

    @Override
    public void taskServiceCompleted(JSONObject result) {
        pbLogin.setVisibility(View.GONE);
        int a = 0;
    }

    @Override
    public boolean taskServicePost(JSONObject data) {

        pbLogin.setVisibility(View.GONE);
        btnLogin.setEnabled(true);
        btnLogup.setEnabled(true);
        login_btn_pressed = false;
        if(data != null){
            try {
                String status = (String) data.get("STATUS");
                if (status.equals("OK")) {
                    Gson gson = new Gson();
                    JSONObject jsData = data.getJSONObject("DATA");
                    JSONObject jsUser = jsData.getJSONObject("usuario");
                    JsonElement element = gson.fromJson(jsUser.toString(), JsonElement.class);
                    AppData.CURRENT_USER = gson.fromJson(element, CurrentUser.class);
                    String token = jsData.getString("token");
                    AppData.CURRENT_USER.setToken(token);
                    int a = 2;
                    AppData.CURRENT_USER.setProcedencia(AppData.FROM_OTS);

                    //Delete all previous users
                    CurrentUser.deleteAll(CurrentUser.class);
                    AppData.CURRENT_USER.save();
                    goMainScreen();
                }else{
                    tvResult.setText(getString(R.string.login_error));
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }else{
            tvResult.setText(getString(R.string.login_error));
        }
        return false;
    }

    @Override
    public void taskGetImage(Bitmap bmp) {

    }

    @Override
    protected void onResume() {
        super.onResume();
        AppData.context = this;
    }
}
