package onthestage.es.onthestage;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/

import android.graphics.Bitmap;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;

import android.util.Log;
import android.view.View;
import android.widget.ProgressBar;
import android.widget.SearchView;

import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import onthestage.es.onthestage.Service.GetAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.adapters.ArtistaMinAdapter;
import onthestage.es.onthestage.model.ArtistaMin;
import onthestage.es.onthestage.utils.AppData;

public class SearchArstista extends AppCompatActivity {
    final static int MAX_RETRIES = 3;
    static int RETRIES = MAX_RETRIES;

    @BindView(R.id.search_artista_list)  RecyclerView mRecyclerView;
    @BindView(R.id.filtrar_artista) SearchView svArtista;

    @BindView(R.id.progressBar2) ProgressBar progressBar;

    ArtistaMinAdapter artistaMinAdapter;
    List<ArtistaMin> misArtistas;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_search_arstista);

        //Dependency Injection
        ButterKnife.bind(this);



        svArtista.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String query) {
                return false;
            }

            @Override
            public boolean onQueryTextChange(String newText) {
                List<ArtistaMin> mArtistaMin = new ArrayList<ArtistaMin>();
                for (ArtistaMin artista : misArtistas) {
                    String name = artista.getNartista();
                    if (name.toLowerCase().contains(newText.toLowerCase())) {
                        mArtistaMin.add(artista);
                    }
                }
                artistaMinAdapter.setDataSet(mArtistaMin);
                artistaMinAdapter.notifyDataSetChanged();
                return false;
            }
        });

        cargarArtistaMin();

    }


    private void cargarArtistaMin() {
        GetAsync ga = new GetAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject data) {
                if(data != null) {
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            AppData.ARTISTAMIN = new ArrayList<ArtistaMin>();
                            Gson gson = new Gson();
                            JSONArray jsonArray = data.getJSONArray("DATA");
                            for (int i = 0; i < jsonArray.length(); i++) {
                                JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                                JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                                ArtistaMin artistaMin = gson.fromJson(element, ArtistaMin.class);
                                AppData.ARTISTAMIN.add(artistaMin);
                            }

                            showViews();

                            RETRIES = MAX_RETRIES;
                        }else{
                            if(RETRIES>0){
                                RETRIES--;
                                cargarArtistaMin();
                            }
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                    Log.d("GENEROS",AppData.ARTISTAMIN.toString());
                }else{
                    if(RETRIES>0){
                        RETRIES--;
                        cargarArtistaMin();
                    }

                }
            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        },AppData.CURRENT_USER.getToken());

        ga.execute("artista/allmin");
    }

    private void showViews() {

        misArtistas = new ArrayList<ArtistaMin>(AppData.ARTISTAMIN);
        artistaMinAdapter = new ArtistaMinAdapter(this,this,misArtistas,AppData.AMIN_FROM_SEARCH);
        mRecyclerView.setAdapter(artistaMinAdapter);
        //final StaggeredGridLayoutManager mLayoutManager = new StaggeredGridLayoutManager(2, StaggeredGridLayoutManager.VERTICAL);
        mRecyclerView.setLayoutManager(new LinearLayoutManager(this));
        progressBar.setVisibility(View.GONE);
    }
}
