package onthestage.es.onthestage.Service;

import android.os.AsyncTask;
import android.util.Log;
import android.widget.Toast;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Locale;

import onthestage.es.onthestage.utils.AppData;


/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/

public class GetAsync extends AsyncTask<String, Integer, JSONObject> {

    JSONObject resultado;
    private TaskDelegateService taskDelegateService;
    String token="";

    public GetAsync(TaskDelegateService taskDelegateService) {
        this.taskDelegateService = taskDelegateService;
        this.token="";
    }
    public GetAsync(TaskDelegateService taskDelegateService,String token) {
        this.taskDelegateService = taskDelegateService;
        this.token = token;
    }

    public JSONObject getResultado() {
        return resultado;
    }

    public void setResultado(JSONObject resultado) {
        this.resultado = resultado;
    }

    @Override
    protected JSONObject doInBackground(String... params) {
        StringBuilder result = new StringBuilder();
        HttpURLConnection urlConnection = null;

        try {
            String sUrl = AppData.REST_BASE_URI+params[0];
            URL url = new URL(sUrl);
            // OPTIONAL - Sets an authorization header


            urlConnection = (HttpURLConnection) url.openConnection();
            urlConnection.setRequestMethod("GET");
            urlConnection.setRequestProperty("Authorization", this.token);
            urlConnection.setRequestProperty("Accept-Language", Locale.getDefault().toString());

            InputStream in = new BufferedInputStream(urlConnection.getInputStream());

            BufferedReader reader = new BufferedReader(new InputStreamReader(in,"UTF-8"));

            String line;
            while ((line = reader.readLine()) != null) {
                result.append(line);
            }

        }catch( Exception e) {
            e.printStackTrace();
        }
        finally {
            if(urlConnection!=null)
                urlConnection.disconnect();
        }


        try {
            String res= result.toString();
            resultado = new JSONObject(res);
        }catch (JSONException e) {
            e.printStackTrace();
        }

        return resultado;
    }


    @Override
    protected void onProgressUpdate(Integer... values) {
        int progreso = values[0].intValue();


    }

    @Override
    protected void onPreExecute() {


    }

    @Override
    protected void onPostExecute(JSONObject result) {
        taskDelegateService.taskServiceCompleted(result);
    }

    @Override
    protected void onCancelled() {

    }
}