package onthestage.es.onthestage.Service;

import android.graphics.Bitmap;
import android.util.Log;
import android.widget.ImageView;

import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import onthestage.es.onthestage.model.Comunidad;
import onthestage.es.onthestage.utils.AppData;

/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/

public class HandlerComunidades implements TaskDelegateService {
    public HandlerComunidades() {
    }

    @Override
    public void taskServiceCompleted(JSONObject result) {
        List<Comunidad> comunidades = null;
        if(result == null){
            AppData.COMUNIDADES = null;
            return;
        }
        try {
            String status = (String) result.get("STATUS");
            if (status.equals("OK")) {
                comunidades = new ArrayList<Comunidad>();
                Gson gson = new Gson();
                JSONArray jsonArray = result.getJSONArray("DATA");
                for (int i = 0; i < jsonArray.length(); i++) {
                    JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                    JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                    Comunidad comunidad = gson.fromJson(element, Comunidad.class);
                    comunidades.add(comunidad);
                }
            }
            AppData.COMUNIDADES = comunidades;

//            for(Comunidad c:comunidades){
//                Log.d("COMUNIDAD",c.getDescripcion());
//            }

        } catch (JSONException e) {
            e.printStackTrace();
            AppData.COMUNIDADES = null;
        }


    }

    @Override
    public boolean taskServicePost(JSONObject data) {
        return false;
    }

    @Override
    public void taskGetImage(Bitmap bmp) {

    }
}
