package onthestage.es.onthestage.Service;

import android.graphics.Bitmap;
import android.util.Log;
import android.widget.ImageView;

import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;
import onthestage.es.onthestage.model.Localidad;
import onthestage.es.onthestage.utils.AppData;

/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/

public class HandlerLocalidades implements TaskDelegateService {

    public HandlerLocalidades() {

    }

    @Override
    public void taskServiceCompleted(JSONObject result) {
        List<Localidad> localidades = null;
        if(result == null){
            AppData.LOCALIDADES = localidades;
            return;
        }
        try {
            String status = (String) result.get("STATUS");
            if (status.equals("OK")) {
                localidades = new ArrayList<Localidad>();
                Gson gson = new Gson();
                JSONArray jsonArray = result.getJSONArray("DATA");
                for (int i = 0; i < jsonArray.length(); i++) {
                    JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                    JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                    Localidad localidad = gson.fromJson(element, Localidad.class);
                    localidades.add(localidad);
                }
            }
            AppData.LOCALIDADES = localidades;

        } catch (JSONException e) {
            e.printStackTrace();
            AppData.LOCALIDADES = null;
        }
    }

    @Override
    public boolean taskServicePost(JSONObject data) {
        return false;
    }

    @Override
    public void taskGetImage(Bitmap bmp) {

    }

}
