package onthestage.es.onthestage.Service;

import android.graphics.Bitmap;
import android.util.Log;
import android.widget.ImageView;

import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import onthestage.es.onthestage.model.Localidad;
import onthestage.es.onthestage.model.Provincia;
import onthestage.es.onthestage.utils.AppData;

/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/

public class HandlerProvincias implements TaskDelegateService {

    public HandlerProvincias() {

    }

    @Override
    public void taskServiceCompleted(JSONObject result) {
        List<Provincia> provincias = null;
        if(result == null){
            AppData.PROVINCIAS = provincias;
            return;
        }
        try {
            String status = (String) result.get("STATUS");
            if (status.equals("OK")) {
                provincias = new ArrayList<Provincia>();
                Gson gson = new Gson();
                JSONArray jsonArray = result.getJSONArray("DATA");
                for (int i = 0; i < jsonArray.length(); i++) {
                    JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                    JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                    Provincia provincia = gson.fromJson(element, Provincia.class);
                    provincias.add(provincia);
                }
            }
            AppData.PROVINCIAS = provincias;

        } catch (JSONException e) {
            e.printStackTrace();
            AppData.PROVINCIAS = null;
        }
    }

    @Override
    public boolean taskServicePost(JSONObject data) {
        return false;
    }

    @Override
    public void taskGetImage(Bitmap bmp) {

    }

}