package onthestage.es.onthestage.Service;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.os.AsyncTask;
import android.util.Log;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.util.Map;

import onthestage.es.onthestage.utils.AppData;

public class PostAsyncWithFiles extends AsyncTask<String, Integer, JSONObject> {
    private static final String TAG = "ERROR_POST";
    JSONObject postData, postResult = null;
    Map<String, String> postDataMap;
    private TaskDelegateService taskDelegateService;


    public PostAsyncWithFiles() {

    }

    public PostAsyncWithFiles(TaskDelegateService taskDelegateService,Map<String, String> postData) {
        this.taskDelegateService = taskDelegateService;
        if (postData != null) {
            this.postData = new JSONObject(postData);
            this.postDataMap = postData;
        }
    }

    public JSONObject getResultado() {
        return postData;
    }

    public void setResultado(JSONObject resultado) {
        this.postData = resultado;
    }

    @Override
    protected JSONObject doInBackground(String... params) { //0 => url a enviar, 1 => url fichero a enviar
        StringBuilder result = new StringBuilder();
        HttpURLConnection urlConnection = null;
        String filename = params[1];
        FileInputStream fileInputStream;

        try {

            String lineEnd = "\r\n";
            String twoHyphens = "--";
            String boundary = "*****";
            int bytesRead, bytesAvailable, bufferSize;
            byte[] buffer;
            @SuppressWarnings("PointlessArithmeticExpression")
            int maxBufferSize = 1 * 1024 * 1024;

            File sourceFile;


            String sUrl = AppData.REST_BASE_URI + params[0];
            // This is getting the url from the string we passed in
            URL url = new URL(sUrl);

            // Create the urlConnection
            urlConnection = (HttpURLConnection) url.openConnection();

            urlConnection.setDoInput(true);
            urlConnection.setDoOutput(true);
            urlConnection.setUseCaches(false);
            urlConnection.setRequestMethod("POST");

            //urlConnection.setReadTimeout( 10000 /*milliseconds*/ );
            //urlConnection.setConnectTimeout( 15000 /* milliseconds */ );

            urlConnection.setRequestProperty("Connection", "Keep-Alive");
            urlConnection.setRequestProperty("ENCTYPE", "multipart/form-data");
            urlConnection.setRequestProperty("Content-Type", "multipart/form-data;boundary=" + boundary);
            //urlConnection.setRequestProperty("Accept", "application/json");
            if(filename != null && !filename.equals(""))
                urlConnection.setRequestProperty("foto", filename);
            //urlConnection.setChunkedStreamingMode(0);
            //urlConnection.setRequestProperty("Content-Length", Integer.toString(fileInputStream.available())+500);

            urlConnection.connect();

            // Send the post body
            if (this.postData != null) {
                DataOutputStream osw = new DataOutputStream(urlConnection.getOutputStream());
                //BufferedWriter osw = new BufferedWriter(new OutputStreamWriter(urlConnection.getOutputStream(),"UTF-8"));

                for(Map.Entry<String, String> entry : this.postDataMap.entrySet()) {
                    String key = entry.getKey();
                    String value = entry.getValue();
                    osw.writeBytes(twoHyphens + boundary + lineEnd);
                    osw.writeBytes("Content-Disposition: form-data; name=\""+key+"\"" + lineEnd);
                    osw.writeBytes(lineEnd);
                    byte[] bytes = value.getBytes(StandardCharsets.UTF_8);
                    osw.write(bytes,0,bytes.length);
                    osw.writeBytes(lineEnd);
                }

                if(filename != null && !filename.equals("")) {// There is a picture
                    sourceFile = new File(filename);
                    if (sourceFile.isFile()){
                        fileInputStream = new FileInputStream(sourceFile);
                    }else{
                        fileInputStream = null;
                    }
                    if(fileInputStream != null){
                        osw.writeBytes(twoHyphens + boundary + lineEnd);
                        osw.writeBytes("Content-Disposition: form-data; name=\"foto\";filename=\"" + filename + "\"" + lineEnd);
                        osw.writeBytes(lineEnd);



                        bytesAvailable = fileInputStream.available();
                        bufferSize = Math.min(bytesAvailable, maxBufferSize);

                        buffer = new byte[bufferSize];

                        // Read file
                        bytesRead = fileInputStream.read(buffer, 0, bufferSize);

                        while (bytesRead > 0) {
                            osw.write(buffer, 0, bufferSize);
                            bytesAvailable = fileInputStream.available();
                            bufferSize = Math.min(bytesAvailable, maxBufferSize);
                            bytesRead = fileInputStream.read(buffer, 0, bufferSize);
                        }
                        osw.writeBytes(lineEnd);
                        osw.writeBytes(twoHyphens + boundary + twoHyphens + lineEnd);
                        fileInputStream.close();
                    }


                }
                //clean up

                osw.flush();
                osw.close();


            }

            int statusCode = urlConnection.getResponseCode();

            if (statusCode ==  200) {
                Log.d("POST","Entra");
                InputStream in = new BufferedInputStream(urlConnection.getInputStream());

                BufferedReader reader = new BufferedReader(new InputStreamReader(in,"UTF-8"));

                String line;
                while ((line = reader.readLine()) != null) {
                    result.append(line);
                }
                in.close();

                // From here you can convert the string to JSON with whatever JSON parser you like to use
                // After converting the string to JSON, I call my custom callback. You can follow this process too, or you can implement the onPostExecute(Result) method
            } else {
                postResult = null;
            }



        } catch (Exception e) {
            Log.d(TAG, e.getLocalizedMessage());
        }finally {
            if(urlConnection!=null)
                urlConnection.disconnect();
        }

        try {
            Log.d("POST",result.toString());
            postResult = new JSONObject(result.toString());
        }catch (JSONException e) {
            e.printStackTrace();
        }

        return postResult;

    }


    @Override
    protected void onProgressUpdate(Integer... values) {
        int progreso = values[0].intValue();


    }

    @Override
    protected void onPreExecute() {


    }

    @Override
    protected void onPostExecute(JSONObject result) {
        taskDelegateService.taskServicePost(result);
    }

    @Override
    protected void onCancelled() {

    }
}