package onthestage.es.onthestage;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.app.DatePickerDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.ColorStateList;
import android.graphics.Bitmap;
import android.location.LocationManager;
import android.os.Build;
import android.support.v4.widget.CompoundButtonCompat;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.Html;
import android.text.Spanned;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;


import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import onthestage.es.onthestage.Service.GetAsync;
import onthestage.es.onthestage.Service.LocationService;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.model.ArtistaMin;
import onthestage.es.onthestage.model.EventosContent;
import onthestage.es.onthestage.model.FiltroContent;
import onthestage.es.onthestage.model.TipoEvento;
import onthestage.es.onthestage.utils.AppData;

import static onthestage.es.onthestage.model.FiltroContent.filtros;
import static onthestage.es.onthestage.utils.AppData.SEPARATOR_FILTER;

public class UserSearch extends AppCompatActivity {

    public static boolean estoy = false; //Variable para comprobar si estoy en esta actividad

    final static int MAX_RETRIES = 4;
    static int RETRIES = MAX_RETRIES;


    final int BUSCAR_ARTISTA = 101;

    private String que;
    private int precio = -1;
    private String cuando;

    private String sCuando="";
    private int sumarCuando=-2;
    private String donde;
    private String quien;
    private String sQuien="";
    private String sQues="";
    private String sPrecio="";
    final Context context = this;

    private boolean buscandoEventos = false;

    private CheckBox todosMusicaDirecto;

    private int cantidad = 0;

    LocationService locationService;

    ArrayList<EventosContent.EventoMin> misEventos;


    //Views

    @BindView(R.id.layoutGeneros) LinearLayout lltGenero;
    @BindView(R.id.layoutMusica) LinearLayout lltMusica;
    @BindView(R.id.btnMostrarBusqueda) Button btnBuscar;
    @BindView(R.id.saveSearch) ImageButton btnGuardarBusqueda;
    @BindView(R.id.chkprecioAny) RadioButton chkPrecioTodos;
    @BindView(R.id.chkprecioGratis) RadioButton chkPrecioGratis;
    @BindView(R.id.chkprecioMenos5) RadioButton chkPrecioMenos5;
    @BindView(R.id.chkprecio5_10) RadioButton chkPrecio5_10;
    @BindView(R.id.chkprecio10_15) RadioButton chkPrecio10_15;
    @BindView(R.id.chkprecioMas15) RadioButton chkPrecioMas15;
    @BindView(R.id.rbtAny) RadioButton rbtnAny;
    @BindView(R.id.rbtHoy) RadioButton rbtnHoy;
    @BindView(R.id.rbt7days) RadioButton rbtn7days;
    @BindView(R.id.rbt30days) RadioButton rbtn30days;
    @BindView(R.id.rbtChooseDay) RadioButton rbtnChooseDay;

    @BindView(R.id.rbtGroup) RadioGroup rbtnGroup;
    @BindView(R.id.rbtGroupPrecio) RadioGroup rbtnGroupPrecio;
    @BindView(R.id.search_artista) EditText searchView;
    @BindView(R.id.elimnar_artista_busqueda)
    ImageView btnElimnarArtista;
    @OnClick(R.id.elimnar_artista_busqueda)
    public void eliminarArtita(){
        quien="";
        sQuien="";
        searchView.setText("");
        getEventos();
    }


    @OnClick(R.id.btnMostrarBusqueda)
    public void irEventosListActivity(){
        if (cantidad<=0){
            Toast.makeText(this,getResources().getString(R.string.no_hay_eventos),Toast.LENGTH_SHORT).show();
        }else{
            Intent intent = new Intent(this,EventsListActivity.class);
            intent.putExtra(AppData.SEARCH_QUERY,construirQuery());
            startActivity(intent);
        }

    }

    @OnClick(R.id.saveSearch)
    public void guardarFiltro(ImageButton button) {
        String mQuery = construirQuery();
        if(!mQuery.equals("")){
            if(!FiltroContent.existsFilter(mQuery)){
                FiltroContent.Filtro filtro = new FiltroContent.Filtro();
                filtro.setQuery(mQuery);
                filtro.setNombre(getResources().getString(R.string.filtro)+" "+(filtros.size()+1));
                filtro.setIduser(AppData.CURRENT_USER.getMid());
                filtro.setSumarCuando(sumarCuando);
                filtro.setNotificaciones(false);
                filtro.setCuando(sCuando);
                filtro.setPrecios(sPrecio);
                filtro.setQuien(sQuien);
                filtro.setQues(sQues);
                filtros.add(filtro);
                filtro.save();
                Toast.makeText(this,getResources().getString(R.string.filtro_guardado_ok),Toast.LENGTH_SHORT).show();
            }else{
                Toast.makeText(this,getResources().getString(R.string.busqueda_existe),Toast.LENGTH_SHORT).show();
            }
        }

    }

    ColorStateList  colorStateList;

    Calendar mCalendar;
    DatePickerDialog.OnDateSetListener date;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_user_search);

        //Dependency Injection
        ButterKnife.bind(this);

        estoy = true;

        locationService = LocationService.getLocationManager(this);

        initActivity();


    }

    private void initActivity() {
        cargarGeneros();
        cargarMusicas();

        //QueryDefaults
        //Por defecto seleccionamos la fecha como hoy
        cuando = AppData.sumarDiasAFechaBBDD(new Date(), 0)+SEPARATOR_FILTER+"0";
        sCuando = AppData.sumarDiasAFechaBBDD(new Date(), 0);
        sumarCuando=0;

        precio = -1; //Por defecto todos los precios.
        sPrecio ="";


        getEventos();
        colorStateList = new ColorStateList(
                new int[][]{
                        new int[]{-android.R.attr.state_checked}, // unchecked
                        new int[]{android.R.attr.state_checked}, // checked
                },
                new int[]{
                        getResources().getColor(R.color.checkDisabled),
                        getResources().getColor(R.color.accent),
                }
        );

        /*Calendar*/
        mCalendar = Calendar.getInstance();
        //mCalendar.set(Calendar.getInstance().get(Calendar.YEAR)-12,0,1);

        /*DatePicker*/
        date = new DatePickerDialog.OnDateSetListener() {
            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear,
                                  int dayOfMonth) {
                mCalendar.set(Calendar.YEAR, year);
                mCalendar.set(Calendar.MONTH, monthOfYear);
                mCalendar.set(Calendar.DAY_OF_MONTH, dayOfMonth);

                rbtnChooseDay.setText(getResources().getString(R.string.chooseday) + " " + AppData.sumarDiasAFechaUser(mCalendar.getTime(), 0));
                cuando = AppData.sumarDiasAFechaBBDD(mCalendar.getTime(), 0)+SEPARATOR_FILTER+"1";
                sCuando = AppData.sumarDiasAFechaBBDD(mCalendar.getTime(), 0);
                sumarCuando=-1;
                getEventos();
            }

        };

        bindHandlers();
    }





    private void bindHandlers() {
        searchView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(context, SearchArstista.class);
                startActivityForResult(intent, BUSCAR_ARTISTA);
            }
        });


        rbtnGroupPrecio.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                if (chkPrecioTodos.isChecked()) { //Default
                    precio=-1;
                }else
                if(chkPrecioGratis.isChecked()){
                    precio =0;
                }else
                 if (chkPrecioMenos5.isChecked()){
                     precio =5;
                 }else
                 if(chkPrecio5_10.isChecked()){
                     precio =10;
                 }
                 else
                 if(chkPrecio10_15.isChecked()){
                     precio =15;
                 }else
                 if(chkPrecioMas15.isChecked()){
                    precio =20;
                 }
                 construirPrecios();

            }
        });


        rbtnGroup.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup group, int checkedId) {
                if(rbtnHoy.isChecked()){ //Default
                   cuando = AppData.sumarDiasAFechaBBDD(new Date(), 0)+SEPARATOR_FILTER+"0";
                   sCuando = AppData.sumarDiasAFechaBBDD(new Date(), 0);
                   sumarCuando=0;
                   rbtnChooseDay.setText(getResources().getString(R.string.chooseday));
                }else
                if(rbtn7days.isChecked()){
                    cuando = AppData.sumarDiasAFechaBBDD(new Date(), 7)+SEPARATOR_FILTER+"0";
                    sCuando = AppData.sumarDiasAFechaBBDD(new Date(), 7);
                    sumarCuando=7;
                    rbtnChooseDay.setText(getResources().getString(R.string.chooseday));
                } else
                if(rbtn30days.isChecked()){
                    cuando = AppData.sumarDiasAFechaBBDD(new Date(), 30)+SEPARATOR_FILTER+"0";
                    sCuando = AppData.sumarDiasAFechaBBDD(new Date(), 30);
                    sumarCuando=30;
                    rbtnChooseDay.setText(getResources().getString(R.string.chooseday));
                } else
                if(rbtnChooseDay.isChecked()){

                }else{
                    if(rbtnAny.isChecked()){
                        cuando="";
                    }
                }

                getEventos();
            }
        });

        rbtnChooseDay.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                new DatePickerDialog(UserSearch.this, date, mCalendar
                        .get(Calendar.YEAR), mCalendar.get(Calendar.MONTH),
                        mCalendar.get(Calendar.DAY_OF_MONTH)).show();
            }
        });


    }

    private void cargarMusicas() {
        GetAsync ga = new GetAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject data) {
                if(data != null) {
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            AppData.MUSICAEVENTOS = new ArrayList<TipoEvento>();
                            Gson gson = new Gson();
                            JSONArray jsonArray = data.getJSONArray("DATA");

                            LinearLayout parent = (LinearLayout) findViewById(R.id.layoutMusica);

                            todosMusicaDirecto = new CheckBox(getApplicationContext());
                            todosMusicaDirecto.setText(getString(R.string.all));
                            todosMusicaDirecto.setChecked(true);

                            todosMusicaDirecto.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
                                @Override
                                public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                                    if(isChecked){//Todos las músicas en directo
                                        desactivarTodosMusica();
                                    }
                                }
                            });

                            CompoundButtonCompat.setButtonTintList(todosMusicaDirecto,colorStateList);
                            todosMusicaDirecto.setTextColor(getResources().getColor(R.color.md_black_1000));

                            parent.addView(todosMusicaDirecto);



                            for (int i = 0; i < jsonArray.length(); i++) {
                                JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                                JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                                TipoEvento tipoEvento = gson.fromJson(element, TipoEvento.class);
                                AppData.MUSICAEVENTOS.add(tipoEvento);
                                addCheckBox(tipoEvento,false);
                            }

                            RETRIES = MAX_RETRIES;
                        }else{
                            if(RETRIES>0){
                                RETRIES--;
                                cargarMusicas();
                            }
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                    Log.d("GENEROS",AppData.GENEROSEVENTOS.toString());
                }else{
                    if(RETRIES>0){
                        RETRIES--;
                        cargarMusicas();
                    }
                }

            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        });

        ga.execute("tipoeventomusica");
    }

    private void desactivarTodosMusica() {
        //Desmarcar todas las músicas en directo
        LinearLayout parent = (LinearLayout) findViewById(R.id.layoutMusica);
        ArrayList<View> vistas = parent.getTouchables();
        Iterator<View> it = vistas.iterator();
        while (it.hasNext()){
            View v = it.next();
            if (v instanceof CheckBox){
                CheckBox cb = (CheckBox) v;
                if(!todosMusicaDirecto.equals(cb))
                    cb.setChecked(false);
            }
        }

        todosMusicaDirecto.setChecked(true);

        getEventos();
    }




    private void cargarGeneros() {
        GetAsync ga = new GetAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject data) {
                if(data != null) {
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            AppData.GENEROSEVENTOS = new ArrayList<TipoEvento>();
                            Gson gson = new Gson();
                            JSONArray jsonArray = data.getJSONArray("DATA");
                            for (int i = 0; i < jsonArray.length(); i++) {
                                JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                                JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                                TipoEvento tipoEvento = gson.fromJson(element, TipoEvento.class);
                                AppData.GENEROSEVENTOS.add(tipoEvento);
                                addCheckBox(tipoEvento,true);
                            }
                            RETRIES = MAX_RETRIES;
                        }else{
                            if(RETRIES>0){
                                RETRIES--;
                                cargarGeneros();
                            }
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                    Log.d("GENEROS",AppData.GENEROSEVENTOS.toString());
                }else{
                    if(RETRIES>0){
                        RETRIES--;
                        cargarGeneros();
                    }
                }
            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        });

        ga.execute("tipoeventogenero");
    }

    public void addCheckBox(TipoEvento tipoEvento, boolean inGeneros){ //if false the music
        LinearLayout parent = null;
        if(inGeneros){
            parent = (LinearLayout) findViewById(R.id.layoutGeneros);
        }else{
            parent = (LinearLayout) findViewById(R.id.layoutMusica);
        }
        CheckBox cb = new CheckBox(getApplicationContext());
        cb.setText(tipoEvento.getDescripcion());
        cb.setId(0x33330000 + tipoEvento.getId());


        CompoundButtonCompat.setButtonTintList(cb,colorStateList);
        cb.setTextColor(getResources().getColor(R.color.md_black_1000));
        //cb.setTextAppearance(android.R.style.);
        //cb.setButtonDrawable(R.drawable.checkboxselector);
        parent.addView(cb);
        cb.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                Integer id = (Integer)buttonView.getId()- (Integer)0x33330000;
                if(id==1){
                   LinearLayout llMusica = (LinearLayout) findViewById(R.id.layoutMusica);
                   if(isChecked) {
                       llMusica.setVisibility(View.VISIBLE);
                       todosMusicaDirecto.setChecked(true);
                   }else{
                       llMusica.setVisibility(View.GONE);
                       desactivarTodosMusica();
                   }
                }else{
                   if(isChecked) {
                       if(id>100){
                           todosMusicaDirecto.setChecked(false);
                       }
                   }
                }

                getEventos();
            }
        });
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if(resultCode==RESULT_OK){
            if(data.hasExtra("id")){
                int id = data.getExtras().getInt("id");
                quien=""+id;
                String nombre = getResources().getString(R.string.no_name);
                boolean esta=false;
                for(int i = 0;i < AppData.ARTISTAMIN.size();i++){
                    ArtistaMin am = AppData.ARTISTAMIN.get(i);
                    if(id== am.getId()){
                        nombre = am.getNartista();
                        esta=true;
                        break;
                    }
                }
                if(esta) sQuien = nombre;
                searchView.setText(nombre.toUpperCase());
                getEventos();
            }

        }
        if(resultCode==RESULT_CANCELED){
            eliminarArtita();
        }
    }

    public void getEventos(){
        String url = construirQuery();
        if(buscandoEventos){
            return;
        }
        buscandoEventos = true;
        GetAsync ga = new GetAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject data) {
                if(data != null) {
                    try {
                        String status = (String) data.get("STATUS");
                        cantidad = (int) data.get("COUNT");
                        actualizarNumEventos(cantidad);
                        if (status.equals("OK")) {
                            misEventos = new ArrayList<EventosContent.EventoMin>();
                            Gson gson = new Gson();
                            JSONArray jsonArray = data.getJSONArray("DATA");
                            for (int i = 0; i < jsonArray.length(); i++) {
                                JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                                JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                                EventosContent.EventoMin evento = gson.fromJson(element, EventosContent.EventoMin.class);
                                misEventos.add(evento);
                            }



                            RETRIES = MAX_RETRIES;
                        }else{

                            if(RETRIES>0){
                                RETRIES--;
                                getEventos();
                            }
                        }
                        buscandoEventos = false;
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }


                    Log.d("DESTACADOS",AppData.EVENTOS_DESTACADOS.toString());
                }else{
                    if(RETRIES>0){
                        RETRIES--;
                        getEventos();
                    }

                }
            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        },AppData.CURRENT_USER.getToken());

        ga.execute("evento/getfiltered"+url);
    }

    private void construirPrecios(){
        sPrecio="";
        if(precio >= 0){
            sPrecio = ""+precio;
        }
        getEventos();
    }


    public boolean contruirQuesGeneros(){
        boolean estaMusica= false;
        LinearLayout parent = (LinearLayout) findViewById(R.id.layoutGeneros);
        ArrayList<View> vistas = parent.getTouchables();
        Iterator<View> it = vistas.iterator();
        boolean last=false;
        while (it.hasNext()){
            View v = it.next();

            if (v instanceof CheckBox){
                CheckBox cb = (CheckBox) v;
                if(cb.isChecked()){
                    Integer id = (Integer)cb.getId()- (Integer)0x33330000;
                    last=!it.hasNext();
                    if(id==1){
                        estaMusica = true;
                    }else{
                        if(last){
                            sQues+=AppData.getDescripcionEvento(AppData.GENEROSEVENTOS,id);
                            que += ""+id;
                        }else{
                            sQues+=AppData.getDescripcionEvento(AppData.GENEROSEVENTOS,id)+AppData.SEPARATOR_FILTER;
                            que += "" + id + AppData.SEPARATOR_FILTER;
                        }
                    }


                }
            }
        }
        return estaMusica;
    }

    public void contruirQueMusicas(boolean estaMusica){
        if(!estaMusica){
            return;
        }
        LinearLayout parent = (LinearLayout) findViewById(R.id.layoutMusica);
        ArrayList<View> vistas = parent.getTouchables();
        Iterator<View> it = vistas.iterator();
        if(todosMusicaDirecto.isChecked()){
            boolean last=false;
            sQues+=getString(R.string.live_music);
            while (it.hasNext()){
                View v = it.next();

                if ((v instanceof CheckBox)){
                    CheckBox cb = (CheckBox) v;
                    if(!cb.equals(todosMusicaDirecto)){
                        Integer id = (Integer)cb.getId()- (Integer)0x33330000;
                        last=!it.hasNext();
                        if(last){

                            que += "" + id;
                        }else{
                            que += ""+id+AppData.SEPARATOR_FILTER;
                        }

                    }
                }
            }
        }else{
            boolean last=false;
            if(!que.equals("")){
                que += AppData.SEPARATOR_FILTER;
            }
            while (it.hasNext()){
                View v = it.next();

                if (v instanceof CheckBox){
                    CheckBox cb = (CheckBox) v;
                    if(cb.isChecked()){
                        Integer id = (Integer)cb.getId()- (Integer)0x33330000;
                        last=!it.hasNext();
                        if(last){
                            sQues+=AppData.getDescripcionEvento(AppData.MUSICAEVENTOS,id);
                            que += ""+id;
                        }else{
                            sQues+=AppData.getDescripcionEvento(AppData.MUSICAEVENTOS,id)+AppData.SEPARATOR_FILTER;
                            que += ""+id+AppData.SEPARATOR_FILTER;
                        }

                    }
                }
            }
        }
    }

    private String construirQuery() {
        String query = "";
        if(quien != null && !quien.equals("")){
            query="?who=" + quien;
        }
        que="";
        sQues="";

        contruirQueMusicas(contruirQuesGeneros());


        if(que!=null && !que.equals("")){
            if(query.equals("")){
                query="?what="+que;
            }else{
                query = query + "&what="+que;
            }
        }
        if(cuando!=null && !cuando.equals("")){
            if(query.equals("")){
                query="?when="+cuando;
            }else{
                query = query + "&when="+cuando;
            }
        }
        if(sPrecio!=null && !sPrecio.equals("")){
            if(query.equals("")){
                query="?precio="+precio;
            }else{
                query = query + "&precio="+precio;
            }
        }
        return query;
    }

    private void actualizarNumEventos(int num){
        String html = getString(R.string.ver)+" <span style='color:#FF4081; font-size:120%'>"+num+"</span> "+getString(R.string.resultados);
        Spanned texto;
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
            texto = Html.fromHtml(html, Html.FROM_HTML_MODE_LEGACY);
        } else {
            texto = Html.fromHtml(html);
        }
        btnBuscar.setText(texto);
    }

    @Override
    protected void onResume() {
        super.onResume();
        AppData.context = this;
    }


    @Override
    protected void onStop() {
        super.onStop();
        estoy = false;
    }
}

