package onthestage.es.onthestage.adapters;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;

import android.support.v4.view.ViewPager;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import onthestage.es.onthestage.HistoricoEventosActivity;
import onthestage.es.onthestage.R;
import onthestage.es.onthestage.Service.PostAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.model.Artista;
import onthestage.es.onthestage.utils.AppData;

import static android.app.Activity.RESULT_OK;

public class ArtistaListfromEventAdapter extends RecyclerView.Adapter<ArtistaListfromEventAdapter.MyViewHolder> {
    private Context context;
    private AppCompatActivity activity;
    private List<Artista> mDataset;
    ArtistaPagerAdapter artistaPagerAdapter;

    public ArtistaListfromEventAdapter(Context context, AppCompatActivity activity, List<Artista> mDataset){
        this.context = context;
        this.activity = activity;
        this.mDataset = new ArrayList<Artista>(mDataset);
    }

    public Context getContext() {
        return context;
    }

    public void setContext(Context context) {
        this.context = context;
    }

    public List<Artista> getArtistas() {
        return mDataset;
    }

    public void setArtistas(List<Artista> mDataset) {
        this.mDataset = mDataset;
    }

    // Create new views (invoked by the layout manager)
    @Override
    public ArtistaListfromEventAdapter.MyViewHolder onCreateViewHolder(ViewGroup parent,
                                                             int viewType) {
        // create a new view
        View v = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.artista_list_item, parent, false);
        // set the view's size, margins, paddings and layout parameters

        ArtistaListfromEventAdapter.MyViewHolder vh = new ArtistaListfromEventAdapter.MyViewHolder(v);
        return vh;
    }

    // Replace the contents of a view (invoked by the layout manager)
    @Override
    public void onBindViewHolder(ArtistaListfromEventAdapter.MyViewHolder holder, int position) {

        final Artista artista = mDataset.get(position).duplicar();

        AppData.context = context;

       final AristaPagerAdapterNoFragment apa = new AristaPagerAdapterNoFragment(activity,artista.fotosToStringArray());
       holder.viewPager.setAdapter(apa);


        holder.tvDescArtista.setText(artista.getDesc_espectaculo());


        String tipo_evento = artista.getTipo_espectaculo().getDescripcion();
        int idEvento = artista.getTipo_espectaculo().getId();
        if(idEvento>100){
            tipo_evento = context.getString(R.string.live_music);
        }
        holder.tvTipoEvento.setText(tipo_evento+": ");

        holder.tvNartista.setText(artista.getNarnista());


        holder.ibPweb.setSelected(false);
        if(artista.getPweb()!=null && !artista.getPweb().equals("")){
            holder.ibPweb.setSelected(true);
        }

        holder.ibPweb.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    String url = artista.getPweb();
                    activity.startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
                }
            }
        });

        holder.ibFacebook.setSelected(false);
        if(artista.getFacebook()!=null && !artista.getFacebook().equals("")){
            holder.ibFacebook.setSelected(true);
        }

        holder.ibFacebook.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    String url = artista.getFacebook();
                    activity.startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
                }
            }
        });


        holder.ibTwitter.setSelected(false);
        if(artista.getTwitter()!=null && !artista.getTwitter().equals("")){
            holder.ibTwitter.setSelected(true);
        }
        holder.ibTwitter.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    String url = artista.getTwitter();
                    activity.startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
                }
            }
        });


        holder.ibInstagram.setSelected(false);
        if(artista.getInstagram()!=null && !artista.getInstagram().equals("")){
            holder.ibInstagram.setSelected(true);
        }
        holder.ibInstagram.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    String url = artista.getInstagram();
                    activity.startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
                }
            }
        });


        holder.ibCompartir.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

            }
        });


        holder.ibFavorito.setSelected(artista.getEsFavorito());

        holder.ibFavorito.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    cambiarFavorito(false,(ImageButton) v, artista.getId(),artista);
                }else{
                    cambiarFavorito(true,(ImageButton) v, artista.getId(), artista);
                }

            }
        });

        holder.btnHistorico.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(getContext(), HistoricoEventosActivity.class);
                intent.putExtra(AppData.FROM__TAG, AppData.FROM_ARTISTAS);
                intent.putExtra(AppData.ARG_ITEM_ID, artista.getId());
                getContext().startActivity(intent);
            }
        });

    }

    private void cambiarFavorito(boolean hacer,final ImageButton ib, int idArtista, final Artista artista){//Si hacer = true, lo inserta en la bbdd sinó lo elimina
        Map<String, String> postData = new HashMap<>();
        if(hacer){
            postData.put("hacer", "1");
        }else{
            postData.put("hacer", "0");
        }
        postData.put("token",AppData.CURRENT_USER.getToken());
        PostAsync task = new PostAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject result) {

            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                if(data != null){
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            ib.setSelected(!ib.isSelected());
                            artista.setEsFavorito(ib.isSelected());
                        }
                    }catch (JSONException je){
                        Log.e("EVENT_LIST",je.getLocalizedMessage());
                    }
                }
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        }, postData);
        task.execute("favorito/usuario/artista/"+idArtista);
    }


    // Return the size of your dataset (invoked by the layout manager)
    @Override
    public int getItemCount() {
        return mDataset.size();
    }

    public class MyViewHolder extends RecyclerView.ViewHolder{
        public final View mView;
        ImageButton ibFavorito;
        ImageButton ibCompartir;
        ImageButton ibInstagram;
        ImageButton ibTwitter;
        ImageButton ibFacebook;
        ImageButton ibPweb;
        TextView tvNartista;
        TextView tvTipoEvento;
        TextView tvDescArtista;
        Button btnHistorico;

        LinearLayout llPrimeraLinea;

        ViewPager viewPager;

        public MyViewHolder(View mainView) {
            super(mainView);
            mView = mainView;
            ibFavorito = (ImageButton) mainView.findViewById(R.id.artista_favorito);
            ibCompartir = (ImageButton) mainView.findViewById(R.id.artista_share);
            ibInstagram = (ImageButton) mainView.findViewById(R.id.artista_instagram);
            ibTwitter = (ImageButton) mainView.findViewById(R.id.artista_twitter);
            ibFacebook = (ImageButton) mainView.findViewById(R.id.artista_facebook);
            ibPweb = (ImageButton) mainView.findViewById(R.id.artista_web);

            btnHistorico = (Button) mainView.findViewById(R.id.artista_historico);

            tvNartista = (TextView) mainView.findViewById(R.id.artista_nartista);
            tvTipoEvento = (TextView) mainView.findViewById(R.id.artista_tipoevento);
            tvDescArtista = (TextView) mainView.findViewById(R.id.artista_descripcion);

            viewPager = (ViewPager) mainView.findViewById(R.id.artista_fotos_container);
            LinearLayout llPrimeraLinea = (LinearLayout) mainView.findViewById(R.id.llPrimeraFila);
            llPrimeraLinea.setVisibility(View.GONE);
        }


    }
}
