package onthestage.es.onthestage.adapters;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import onthestage.es.onthestage.ArtistaInfo;
import onthestage.es.onthestage.R;
import onthestage.es.onthestage.Service.PostAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.model.ArtistaMin;
import onthestage.es.onthestage.utils.AppData;

import static android.app.Activity.RESULT_OK;

public class ArtistaMinAdapter extends RecyclerView.Adapter<ArtistaMinAdapter.MyViewHolder> {
    private List<ArtistaMin> mDataset;
    private Context context;
    private Activity activity;
    private int from;


    // Provide a suitable constructor (depends on the kind of dataset)
    public ArtistaMinAdapter(Context context,Activity activity, List<ArtistaMin> myDataset, int from) {
        this.context = context;
        this.mDataset = new ArrayList<ArtistaMin>(myDataset);
        this.activity = activity;
        this.from = from;
    }

    public void setDataSet(List<ArtistaMin> artistas){
        this.mDataset = new ArrayList<ArtistaMin>(artistas);
        this.notifyDataSetChanged();
    }

    // Create new views (invoked by the layout manager)
    @Override
    public MyViewHolder onCreateViewHolder(ViewGroup parent,
                                                   int viewType) {
        // create a new view
        View v = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.artista_min, parent, false);
        // set the view's size, margins, paddings and layout parameters

        MyViewHolder vh = new MyViewHolder(v);
        return vh;
    }

    // Replace the contents of a view (invoked by the layout manager)
    @Override
    public void onBindViewHolder(MyViewHolder holder, int position) {
        // - get element from your dataset at this position
        // - replace the contents of the view with that element
        holder.mNartista.setText(AppData.ucFirst(mDataset.get(position).getNartista()).trim());
        holder.idArtista.setText(""+mDataset.get(position).getId());
        final int idartista = mDataset.get(position).getId();
        String url = mDataset.get(position).getFotoperfil();
        if(url==null || url.equals("")){
            url = AppData.NO_USER_IMAGE;
        }
        AppData.getGlide(context,url,holder.mFotoPerfil);

        holder.mView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                TextView tvid = (TextView) v.findViewById(R.id.idnartista);
                String sid = tvid.getText().toString();
                int id = Integer.parseInt(sid);
                if(from == AppData.AMIN_FROM_SEARCH){//Viene de la búsqueda por artista

                    Intent intent = new Intent();
                    intent.putExtra("id", idartista);
                    activity.setResult(RESULT_OK, intent);
                    activity.finish();
                }
                if(from==AppData.AMIN_FROM_FAVORITOS){//Viene de favoritos, cargamos el intent detalle artista
                    Intent intent = new Intent(context, ArtistaInfo.class);
                    intent.putExtra(AppData.ARG_ITEM_ID_OTROS,idartista);
                    activity.startActivity(intent);

                }

            }
        });

        if(from == AppData.AMIN_FROM_SEARCH){
            holder.favorito.setVisibility(View.GONE);
        }else if(from == AppData.AMIN_FROM_FAVORITOS){
            holder.favorito.setVisibility(View.VISIBLE);
            holder.favorito.setSelected(true);

            holder.favorito.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if(v.isSelected()){
                        cambiarFavorito(false,(Button) v, idartista);
                    }else{
                        cambiarFavorito(true,(Button) v, idartista);
                    }
                }
            });
        }

        holder.descEspect.setText(AppData.ucFirst(mDataset.get(position).getDesc_espectaculo()).trim()+"...");




    }

    // Return the size of your dataset (invoked by the layout manager)
    @Override
    public int getItemCount() {
        return mDataset.size();
    }

    public class MyViewHolder extends RecyclerView.ViewHolder{
        public final View mView;
        public final ImageView mFotoPerfil;
        public final TextView mNartista;
        public final TextView idArtista;
        public final TextView descEspect;
        public final Button favorito;

        public MyViewHolder(View view) {
            super(view);
            mView = view;
            mFotoPerfil = (ImageView) view.findViewById(R.id.image_miniatura);
            mNartista = (TextView) view.findViewById(R.id.nartista);
            idArtista = (TextView) view.findViewById(R.id.idnartista);
            descEspect = (TextView) view.findViewById(R.id.desc_artista);
            favorito = (Button) view.findViewById(R.id.btn_favorito);
        }


    }

    private void cambiarFavorito(boolean hacer,final Button ib, int idArtista){//Si hacer = true, lo inserta en la bbdd sinó lo elimina
        Map<String, String> postData = new HashMap<>();
        if(hacer){
            postData.put("hacer", "1");
        }else{
            postData.put("hacer", "0");
        }
        postData.put("token",AppData.CURRENT_USER.getToken());
        PostAsync task = new PostAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject result) {

            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                if(data != null){
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            ib.setSelected(!ib.isSelected());
                        }
                    }catch (JSONException je){
                        Log.e("EVENT_LIST",je.getLocalizedMessage());
                    }
                }
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        }, postData);
        task.execute("favorito/usuario/artista/"+idArtista);
    }
}