package onthestage.es.onthestage.adapters;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import onthestage.es.onthestage.ArtistaInfo;
import onthestage.es.onthestage.LocalInfoActivity;
import onthestage.es.onthestage.R;
import onthestage.es.onthestage.Service.PostAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.model.LocalMin;
import onthestage.es.onthestage.utils.AppData;

import static android.app.Activity.RESULT_OK;

public class LocalMinAdapter  extends RecyclerView.Adapter<LocalMinAdapter.MyViewHolder> {
    private List<LocalMin> mDataset;
    private Context context;
    private Activity activity;
    private int from;


    // Provide a suitable constructor (depends on the kind of dataset)
    public LocalMinAdapter(Context context, Activity activity, List<LocalMin> myDataset, int from) {
        this.context = context;
        this.mDataset = new ArrayList<LocalMin>(myDataset);
        this.activity = activity;
     }

    public void setDataSet(List<LocalMin> artistas) {
        this.mDataset = new ArrayList<LocalMin>(artistas);
        this.notifyDataSetChanged();
    }

    // Create new views (invoked by the layout manager)
    @Override
    public LocalMinAdapter.MyViewHolder onCreateViewHolder(ViewGroup parent,
                                                             int viewType) {
        // create a new view
        View v = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.artista_min, parent, false);
        // set the view's size, margins, paddings and layout parameters

        LocalMinAdapter.MyViewHolder vh = new LocalMinAdapter.MyViewHolder(v);
        return vh;
    }

    // Replace the contents of a view (invoked by the layout manager)
    @Override
    public void onBindViewHolder(LocalMinAdapter.MyViewHolder holder, int position) {
        // - get element from your dataset at this position
        // - replace the contents of the view with that element
        holder.tvNLocal.setText(AppData.ucFirst(mDataset.get(position).getNlocal()).trim());
        holder.idLocal.setText("" + mDataset.get(position).getId());
        final int idlocal = mDataset.get(position).getId();
        String url = mDataset.get(position).getFotoperfil();
        if (url == null || url.equals("")) {
            url = AppData.NO_USER_IMAGE;
        }
        AppData.getGlide(context, url, holder.mFotoPerfil);

        holder.mView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(activity, LocalInfoActivity.class);
                intent.putExtra(AppData.ARG_ITEM_ID,idlocal);
                activity.startActivity(intent);
            }
        });

        holder.favorito.setVisibility(View.VISIBLE);
        holder.favorito.setSelected(true);

        holder.favorito.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (v.isSelected()) {
                    cambiarFavorito(false, (Button) v, idlocal);
                } else {
                    cambiarFavorito(true, (Button) v, idlocal);
                }
            }
        });


        holder.desLocal.setText(AppData.ucFirst(mDataset.get(position).getDescripcion()).trim() + "...");


    }

    // Return the size of your dataset (invoked by the layout manager)
    @Override
    public int getItemCount() {
        return mDataset.size();
    }

    public class MyViewHolder extends RecyclerView.ViewHolder {
        public final View mView;
        public final ImageView mFotoPerfil;
        public final TextView tvNLocal;
        public final TextView idLocal;
        public final TextView desLocal;
        public final Button favorito;

        public MyViewHolder(View view) {
            super(view);
            mView = view;
            mFotoPerfil = (ImageView) view.findViewById(R.id.image_miniatura);
            tvNLocal = (TextView) view.findViewById(R.id.nartista);
            idLocal = (TextView) view.findViewById(R.id.idnartista);
            desLocal = (TextView) view.findViewById(R.id.desc_artista);
            favorito = (Button) view.findViewById(R.id.btn_favorito);
        }


    }

    private void cambiarFavorito(boolean hacer, final Button ib, int idLocal) {//Si hacer = true, lo inserta en la bbdd sinó lo elimina
        Map<String, String> postData = new HashMap<>();
        if (hacer) {
            postData.put("hacer", "1");
        } else {
            postData.put("hacer", "0");
        }
        postData.put("token", AppData.CURRENT_USER.getToken());
        PostAsync task = new PostAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject result) {

            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                if (data != null) {
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            ib.setSelected(!ib.isSelected());
                        }
                    } catch (JSONException je) {
                        Log.e("EVENT_LIST", je.getLocalizedMessage());
                    }
                }
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        }, postData);
        task.execute("favorito/usuario/local/" + idLocal);
    }
}
