package onthestage.es.onthestage.adapters;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.support.annotation.NonNull;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentPagerAdapter;

import java.util.ArrayList;
import java.util.List;

import onthestage.es.onthestage.fragments.LocalPagerFragment;
import onthestage.es.onthestage.utils.AppData;

public class LocalPagerAdapter  extends FragmentPagerAdapter {
    List<String> fotos;
    public LocalPagerAdapter(FragmentManager fm, List<String>  fotos) {
        super(fm);
        this.fotos = new ArrayList<String>(fotos);
        if(this.fotos.size()<=0){
            this.fotos.add(AppData.NO_IMAGE);
        }
    }


    @Override
    public int getCount() {
        return fotos.size();

    }

    @Override
    public int getItemPosition(@NonNull Object object) {
        return super.getItemPosition(object);
    }

    @Override
    public Fragment getItem(int position) {
        Fragment fragment = LocalPagerFragment.getInstance(fotos.get(position), fotos.size(), position);
        return  fragment;
    }

    public List<String> getFotos() {
        return fotos;
    }

    public void setFotos(List<String> fotos) {
        this.fotos = fotos;
        if(this.fotos.size()<=0){
            this.fotos.add(AppData.NO_IMAGE);
        }
        notifyDataSetChanged();
    }
}
