package onthestage.es.onthestage.fragments;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.view.ViewPager;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ImageButton;
import android.widget.TextView;

import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

import onthestage.es.onthestage.HistoricoEventosActivity;
import onthestage.es.onthestage.R;
import onthestage.es.onthestage.Service.GetAsync;
import onthestage.es.onthestage.Service.PostAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.adapters.ArtistaPagerAdapter;
import onthestage.es.onthestage.model.Artista;
import onthestage.es.onthestage.utils.AppData;

public class ArtistaFragment extends Fragment {
    final static int MAX_RETRIES = 4;
    static int RETRIES = MAX_RETRIES;

    private OnFragmentInteractionListener mListener;

    Artista artista = null;

    public ArtistaFragment() {
        // Required empty public constructor
    }

    public static ArtistaFragment newInstance() {
        ArtistaFragment fragment = new ArtistaFragment();
        Bundle args = new Bundle();
        args.putInt(AppData.ARG_ITEM_ID,0);
        fragment.setArguments(args);
        return fragment;
    }

    public interface OnFragmentInteractionListener {
          void onFragmentInteraction(Uri uri);
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        Log.i("TEST","Entra Oncreate Fragment");
        super.onCreate(savedInstanceState);
        if (getArguments().containsKey( AppData.ARG_ITEM_ID )) {
            artista = AppData.ARTISTA.duplicar();
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        Log.i("TEST","Entra Oncreate View Fragment Artista");
        View mainView = null;
            mainView = inflater.inflate(R.layout.artista_info, container, false);

        TextView tvDescArtista = (TextView) mainView.findViewById(R.id.artista_descripcion);
        String descripcion = artista.getDesc_espectaculo();
        tvDescArtista.setText(descripcion);

        LinearLayout llPrimeraFila = (LinearLayout) mainView.findViewById(R.id.llPrimeraFila);
        llPrimeraFila.setVisibility(View.GONE);

        ImageButton ibWeb = (ImageButton) mainView.findViewById(R.id.artista_web);
        ibWeb.setSelected(false);
        if(artista.getPweb()!=null && !artista.getPweb().equals("")){
            ibWeb.setSelected(true);
        }

        ibWeb.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    String url = artista.getPweb();
                    startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
                }
            }
        });


        ImageButton ibFacebook = (ImageButton) mainView.findViewById(R.id.artista_facebook);
        ibFacebook.setSelected(false);
        if(artista.getFacebook()!=null && !artista.getFacebook().equals("")){
            ibFacebook.setSelected(true);
        }

        ibFacebook.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    String url = artista.getFacebook();
                    startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
                }
            }
        });

        ImageButton ibTwitter = (ImageButton) mainView.findViewById(R.id.artista_twitter);
        ibTwitter.setSelected(false);
        if(artista.getTwitter()!=null && !artista.getTwitter().equals("")){
            ibTwitter.setSelected(true);
        }
        ibTwitter.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    String url = artista.getTwitter();
                    startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
                }
            }
        });

        ImageButton ibInstagram = (ImageButton) mainView.findViewById(R.id.artista_instagram);
        ibInstagram.setSelected(false);
        if(artista.getInstagram()!=null && !artista.getInstagram().equals("")){
            ibInstagram.setSelected(true);
        }
        ibInstagram.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    String url = artista.getInstagram();
                    startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
                }
            }
        });

        ImageButton ibCompartir = (ImageButton) mainView.findViewById(R.id.artista_share);
        ibCompartir.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

            }
        });

        ImageButton ibFavorito = (ImageButton) mainView.findViewById(R.id.artista_favorito);
        ibFavorito.setSelected(artista.getEsFavorito());

        ibFavorito.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    cambiarFavorito(false,(ImageButton) v, artista.getId());
                }else{
                    cambiarFavorito(true,(ImageButton) v, artista.getId());
                }

            }
        });

        Button btnHistorico = (Button) mainView.findViewById(R.id.artista_historico);
        btnHistorico.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(getContext(), HistoricoEventosActivity.class);
                intent.putExtra(AppData.FROM__TAG, AppData.FROM_ARTISTAS);
                intent.putExtra(AppData.ARG_ITEM_ID, artista.getId());
                getContext().startActivity(intent);
            }
        });

        return mainView;
    }


    private void cambiarFavorito(boolean hacer,final ImageButton ib, int idArtista){//Si hacer = true, lo inserta en la bbdd sinó lo elimina
        Map<String, String> postData = new HashMap<>();
        if(hacer){
            postData.put("hacer", "1");
        }else{
            postData.put("hacer", "0");
        }
        postData.put("token",AppData.CURRENT_USER.getToken());
        PostAsync task = new PostAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject result) {

            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                if(data != null){
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            ib.setSelected(!ib.isSelected());
                            artista.setEsFavorito(ib.isSelected());
                        }
                    }catch (JSONException je){
                        Log.e("EVENT_LIST",je.getLocalizedMessage());
                    }
                }
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        }, postData);
        task.execute("favorito/usuario/artista/"+idArtista);
    }


}
