package onthestage.es.onthestage.fragments;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.content.Context;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;
import android.widget.TextView;

import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;

import onthestage.es.onthestage.R;
import onthestage.es.onthestage.Service.GetAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.adapters.BusquedasAdapter;
import onthestage.es.onthestage.model.FiltroContent;
import onthestage.es.onthestage.model.TipoEvento;
import onthestage.es.onthestage.utils.AppData;


/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * {@link BusquedaFragment.OnFragmentInteractionListener} interface
 * to handle interaction events.
 * Use the {@link BusquedaFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class BusquedaFragment extends Fragment {
   private RecyclerView recyclerView;
   private ProgressBar progressBar;
   private TextView tvNoBusquesdas;

    private OnFragmentInteractionListener mListener;

    public BusquedaFragment() {
        // Required empty public constructor
    }

    public static BusquedaFragment newInstance() {
        BusquedaFragment fragment = new BusquedaFragment();
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View rootView =  inflater.inflate(R.layout.fragment_busqueda, container, false);

        FiltroContent.filtros = FiltroContent.getFiltros();
        tvNoBusquesdas = (TextView) rootView.findViewById(R.id.no_saved_search);
        progressBar = (ProgressBar) rootView.findViewById(R.id.busqueda_pb);
        if(FiltroContent.filtros.size()>0){

            recyclerView = (RecyclerView) rootView.findViewById(R.id.recycler_busquedas);


            BusquedasAdapter busquedasAdapter = new BusquedasAdapter(getContext(), getActivity());
            recyclerView.setAdapter(busquedasAdapter);

            recyclerView.setLayoutManager(new LinearLayoutManager(getContext()));
        }else{
            tvNoBusquesdas.setVisibility(View.VISIBLE);
        }
        progressBar.setVisibility(View.GONE);




        return rootView;
    }

    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        if (context instanceof OnFragmentInteractionListener) {
            mListener = (OnFragmentInteractionListener) context;
        } else {
            throw new RuntimeException(context.toString()
                    + " must implement OnFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener {
        // TODO: Update argument type and name
        void onFragmentInteraction(Uri uri);
    }
}
