package onthestage.es.onthestage.fragments;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/

import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.support.v4.app.Fragment;
import android.support.v7.app.AlertDialog;
import android.support.v7.widget.GridLayoutManager;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import onthestage.es.onthestage.R;

import onthestage.es.onthestage.adapters.EventListAdapter;
import onthestage.es.onthestage.model.EventosContent;
import onthestage.es.onthestage.utils.AppData;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * A fragment representing a list of Items.
 * <p/>
 * interface.
 */
public class EventListFragment extends Fragment {

    RecyclerView mRecyclerView;
    EventListAdapter ela;
    int tipoFragment=0;

    public EventListFragment() {
    }

    public static EventListFragment getInstance(int mTipoFragment) {
        EventListFragment fragment = new EventListFragment();
        Bundle bundle = new Bundle();
        bundle.putInt(AppData.TAG_FRAGMENT_EVENT_LIST,mTipoFragment);
        fragment.setArguments(bundle);
        return fragment;
    }

    public interface OnFragmentInteractionListener {
        // TODO: Update argument type and name
        void onFragmentInteraction(Uri uri);
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        Log.i("TEST","Entra Oncreate Fragment");
        super.onCreate(savedInstanceState);
        if (getArguments().containsKey( AppData.TAG_FRAGMENT_EVENT_LIST )) {
            tipoFragment = getArguments().getInt(AppData.TAG_FRAGMENT_EVENT_LIST);
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        Log.i("TEST","Entra Oncreate View Fragment Artista");
        View mainView = null;
        mainView = inflater.inflate(R.layout.fragment_events_list, container, false);

        mRecyclerView = (RecyclerView) mainView.findViewById(R.id.event_recycle_view);
        showViews();


        return mainView;
    }

    private void showViews() {

        if(tipoFragment==AppData.LISTA_EVENTO_PRIMARY){
            ela = new EventListAdapter(getContext(),getActivity(),AppData.EVENTOS_MIN);
            ela.notifyDataSetChanged();
            mRecyclerView.setAdapter(ela);
            final GridLayoutManager llm = new GridLayoutManager(getContext(),1,GridLayoutManager.VERTICAL, false);
            mRecyclerView.setLayoutManager(llm);
            Runnable r = new Runnable(){
                @Override
                public void run() {
                        llm.scrollToPositionWithOffset(0,0);
                }
            };

            Handler handler = new Handler();
            handler.postDelayed(r,250);

        }
    }

}
