package onthestage.es.onthestage.fragments;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.util.TypedValue;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

import onthestage.es.onthestage.R;
import onthestage.es.onthestage.Service.PostAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.utils.AppData;

public class EventoFragment extends Fragment {
    private static final String ARG_SECTION_NUMBER = "section_number";


    public EventoFragment() {
    }

    /**
     * Returns a new instance of this fragment for the given section
     * number.
     */
    public static EventoFragment newInstance(int sectionNumber) {
        EventoFragment eventoFragment = new EventoFragment();
        Bundle args = new Bundle();
        args.putInt(ARG_SECTION_NUMBER, sectionNumber);
        eventoFragment.setArguments(args);
        return eventoFragment;
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.evento_info, container, false);

        ImageView foto = (ImageView) rootView.findViewById(R.id.evento_foto);
        AppData.getGlide(getContext(),AppData.EVENTO.getFoto(),foto);

        TextView nevento = (TextView) rootView.findViewById(R.id.evento_nombre);
        if(AppData.EVENTO.getNombre().length()>=18){
            nevento.setTextSize(TypedValue.COMPLEX_UNIT_SP,12);
            nevento.setText(AppData.EVENTO.getNombre().toUpperCase());//.substring(0,30)+"...");
        }else{
            nevento.setText(AppData.EVENTO.getNombre().toUpperCase());
        }

        TextView precio = (TextView) rootView.findViewById(R.id.evento_precio);
        precio.setText(""+AppData.EVENTO.getPrecio());

        TextView tevento = (TextView) rootView.findViewById(R.id.evento_tipo);
        String tipo_evento = AppData.EVENTO.getTipo().get(0).getDescripcion();
        int idEvento = AppData.EVENTO.getTipo().get(0).getId();
        if(idEvento>100){
            tipo_evento = getString(R.string.live_music);
        }
        tevento.setText(AppData.ucFirst(tipo_evento.toLowerCase())+": ");

        TextView mes = (TextView) rootView.findViewById(R.id.evento_mes);
        mes.setText(AppData.EVENTO.getMonth(getContext()));

        ImageView compartir = (ImageView) rootView.findViewById(R.id.evento_share);
        compartir.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                AppData.compartirEvento(getContext(),  null,AppData.EVENTO);
            }
        });

        TextView dia = (TextView) rootView.findViewById(R.id.evento_dia);
        dia.setText(AppData.EVENTO.getDay(getContext()));

        TextView fecha_completa = (TextView) rootView.findViewById(R.id.evento_fecha_completa);
        fecha_completa.setText(AppData.EVENTO.getFullDate(getContext())+", "+getContext().getString(R.string.a_las)+ " "+AppData.EVENTO.getHora());

        TextView descripcion = (TextView) rootView.findViewById(R.id.evento_descripcion);
        descripcion.setText(AppData.EVENTO.getDescripcion());

        TextView complet_dir = (TextView) rootView.findViewById(R.id.evento_direccion_local);
        String sDireccion = AppData.ucFirst(AppData.EVENTO.getLocal().getDireccion().trim().toLowerCase())+", "+AppData.ucFirst(AppData.EVENTO.getLocal().getLocalidad().getDescripcion().toLowerCase());
        complet_dir.setText(sDireccion);

        TextView observaciones = (TextView) rootView.findViewById(R.id.evento_observaciones);
        observaciones.setText(AppData.EVENTO.getOfertas());

        TextView nLocal = (TextView) rootView.findViewById(R.id.evento_nombre_local);
        nLocal.setText(AppData.EVENTO.getLocal().getNlocal());

        Button telefono = (Button) rootView.findViewById(R.id.evento_telefono);
        String sTelefono =AppData.EVENTO.getLocal().getTelf();
        sTelefono = AppData.formatPhoneNumber(sTelefono,getContext());
        telefono.setText(sTelefono);

        telefono.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(Intent.ACTION_DIAL);
                String sTelefono = AppData.EVENTO.getLocal().getTelf();
                intent.setData(Uri.parse("tel:"+sTelefono.replace(" ","")));
                getContext().startActivity(intent);
            }
        });

        Button asistir = (Button) rootView.findViewById(R.id.evento_asistencia);
        asistir.setSelected(false);
        asistir.setText(""+AppData.EVENTO.getAsistentes());
        asistir.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                Button ib = (Button)v;
                if(ib.isSelected()){
                    cambiarAsistencia(false,ib,AppData.EVENTO.getId());
                }else{
                    cambiarAsistencia(true,ib,AppData.EVENTO.getId());
                }

            }
        });

        Button favorito =(Button) rootView.findViewById(R.id.evento_favorito);
        favorito.setSelected(AppData.EVENTO.getEsFavorito());
        favorito.setText(""+AppData.EVENTO.getNumFavoritos());
        favorito.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    cambiarFavorito(false,(Button) v,AppData.EVENTO.getId());
                }else{
                    cambiarFavorito(true,(Button) v,AppData.EVENTO.getId());
                }
            }
        });

        ImageButton navegar = (ImageButton) rootView.findViewById(R.id.evento_navegar);
        navegar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                // Create a Uri from an intent string. Use the result to create an Intent.
                //Uri gmmIntentUri = Uri.parse("google.streetview:cbll="+e.getLatitud()+","+e.getLongitud());
                Uri gmmIntentUri = Uri.parse("geo:"+AppData.EVENTO.getLocal().getLatitud()+","+AppData.EVENTO.getLocal().getLongitud()+"?z=19&q="+Uri.encode(AppData.EVENTO.getLocal().getNlocal()));

                // Create an Intent from gmmIntentUri. Set the action to ACTION_VIEW
                Intent mapIntent = new Intent(Intent.ACTION_VIEW, gmmIntentUri);
                // Make the Intent explicit by setting the Google Maps package
                mapIntent.setPackage("com.google.android.apps.maps");

                // Attempt to start an activity that can handle the Intent
                getContext().startActivity(mapIntent);
            }
        });

        ImageButton ticket = (ImageButton) rootView.findViewById(R.id.evento_ticket);
        if(AppData.EVENTO.getTickets() == null || AppData.EVENTO.getTickets().equals("")){
            ticket.setSelected(false);
        }else{
            ticket.setSelected(true);
        }

        ticket.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    String url = AppData.EVENTO.getTickets();
                    try{
                        startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
                    }catch (Exception e){
                        Toast.makeText(getContext(),getString(R.string.something_was_wrong),Toast.LENGTH_SHORT).show();
                        Log.e("EVENTLISTADAPTER", e.getLocalizedMessage());

                    }

                }
            }
        });

        return rootView;
    }



    private void cambiarFavorito(boolean hacer,final Button ib, int idEvento){//Si hacer = true, lo inserta en la bbdd sinó lo elimina
        Map<String, String> postData = new HashMap<>();
        if(hacer){
            postData.put("hacer", "1");
        }else{
            postData.put("hacer", "0");
        }
        postData.put("token",AppData.CURRENT_USER.getToken());
        PostAsync task = new PostAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject result) {

            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                if(data != null){
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            ib.setSelected(!ib.isSelected());
                            int nFav = (int) data.get("COUNT");
                            AppData.EVENTO.setEsFavorito(ib.isSelected());
                            AppData.EVENTO.setNumFavoritos(nFav);
                            ib.setText(""+nFav);
                        }
                    }catch (JSONException je){
                        Log.e("EVENT_LIST",je.getLocalizedMessage());
                    }
                }
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        }, postData);
        task.execute("favorito/usuario/evento/"+idEvento);
    }


    private void cambiarAsistencia(boolean hacer,final Button ib, int idEvento){//Si hacer = true, lo inserta en la bbdd sinó lo elimina
        Map<String, String> postData = new HashMap<>();
        if(hacer){
            postData.put("hacer", "1");
        }else{
            postData.put("hacer", "0");
        }
        postData.put("token",AppData.CURRENT_USER.getToken());
        PostAsync task = new PostAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject result) {

            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                if(data != null){
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            ib.setSelected(!ib.isSelected());
                            int nAsist = (int) data.get("COUNT");
                            AppData.EVENTO.setAsistira(ib.isSelected());
                            AppData.EVENTO.setAsistentes(nAsist);
                            ib.setText(""+nAsist);

                        }
                    }catch (JSONException je){
                        Log.e("EVENT_LIST",je.getLocalizedMessage());
                    }
                }
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        }, postData);
        task.execute("asistencia/usuario/evento/"+idEvento);
    }
}