package onthestage.es.onthestage.fragments;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.design.widget.Snackbar;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import onthestage.es.onthestage.R;
import onthestage.es.onthestage.Service.GetAsync;
import onthestage.es.onthestage.Service.PostAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.adapters.ArtistaMinAdapter;
import onthestage.es.onthestage.model.Artista;
import onthestage.es.onthestage.model.ArtistaMin;
import onthestage.es.onthestage.model.EventosContent;
import onthestage.es.onthestage.utils.AppData;

public class FavoritoArtistaFragment extends Fragment {

    ProgressBar progressBar;
    RecyclerView recyclerView;
    View mView;
    TextView noFav;

    private List<ArtistaMin> artistas;



    public FavoritoArtistaFragment() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *

     * @return A new instance of fragment FavoritoArtistaFragment.
     */

    public static FavoritoArtistaFragment newInstance() {
        FavoritoArtistaFragment fragment = new FavoritoArtistaFragment();
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {

        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        //AppData.context = getParentFragment().getContext();
        View view = inflater.inflate(R.layout.fragment_favorito_artista, container, false);
        mView = view;
        recyclerView = (RecyclerView) view.findViewById(R.id.favorito_artista_recycle_view);
        progressBar = (ProgressBar) view.findViewById(R.id.progressBarLogin);
        noFav = (TextView) view.findViewById(R.id.tvNoFav);
        noFav.setVisibility(View.GONE);

        getArtistasFavoritos();

        return view;
    }


    private void getArtistasFavoritos() {
        GetAsync task = new GetAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject result) {
                if(result != null){
                    try {
                        String status = (String) result.get("STATUS");
                        if (status.equals("OK")) {
                            artistas = new ArrayList<ArtistaMin>();
                            Gson gson = new Gson();
                            JSONArray jsonArray = result.getJSONArray("DATA");
                            for (int i = 0; i < jsonArray.length(); i++) {
                                JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                                JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                                ArtistaMin am = gson.fromJson(element, ArtistaMin.class);
                                artistas.add(am);
                            }

                            startViews();

                        }
                    }catch (JSONException je){
                        Log.e("EVENT_LIST",je.getLocalizedMessage());
                    }
                }
            }

            @Override
            public boolean taskServicePost(JSONObject data) {

                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        }, AppData.CURRENT_USER.getToken());
        task.execute("favorito/usuario/artistas");
    }

    private void startViews() {
        ArtistaMinAdapter ama = new ArtistaMinAdapter(getContext(),getActivity(),artistas,AppData.AMIN_FROM_FAVORITOS);
        progressBar.setVisibility(View.GONE);

        recyclerView.setAdapter(ama);

        recyclerView.setLayoutManager(new LinearLayoutManager(getContext()));
        if(artistas==null || artistas.size()==0){
            noFav.setVisibility(View.VISIBLE);
        }
    }

    }
