package onthestage.es.onthestage.fragments;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.graphics.Bitmap;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ProgressBar;
import android.widget.TextView;

import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

import onthestage.es.onthestage.R;
import onthestage.es.onthestage.Service.GetAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.adapters.LocalMinAdapter;
import onthestage.es.onthestage.model.LocalMin;
import onthestage.es.onthestage.utils.AppData;

public class FavoritoLocalFragment extends Fragment {
    ProgressBar progressBar;
    RecyclerView recyclerView;
    View mView;
    TextView noFav;

    private List<LocalMin> locales;

    public FavoritoLocalFragment() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *

     * @return A new instance of fragment FavoritoLocalFragment.
     */
    // TODO: Rename and change types and number of parameters
    public static FavoritoLocalFragment newInstance() {
        FavoritoLocalFragment fragment = new FavoritoLocalFragment();
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {

        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        //AppData.context = getParentFragment().getContext();
        View view = inflater.inflate(R.layout.fragment_favorito_local, container, false);
        mView = view;
        recyclerView = (RecyclerView) view.findViewById(R.id.favorito_local_recycle_view);
        progressBar = (ProgressBar) view.findViewById(R.id.progressBarLogin);
        noFav = (TextView) view.findViewById(R.id.tvNoFavLoc);
        noFav.setVisibility(View.GONE);

        getLocalesFavoritos();

        return view;
    }

    private void getLocalesFavoritos() {
        GetAsync task = new GetAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject result) {
                if(result != null){
                    try {
                        String status = (String) result.get("STATUS");
                        if (status.equals("OK")) {
                            locales = new ArrayList<LocalMin>();
                            Gson gson = new Gson();
                            JSONArray jsonArray = result.getJSONArray("DATA");
                            for (int i = 0; i < jsonArray.length(); i++) {
                                JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                                JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                                LocalMin lm = gson.fromJson(element, LocalMin.class);
                                locales.add(lm);
                            }

                            startViews();

                        }
                    }catch (JSONException je){
                        Log.e("EVENT_LIST",je.getLocalizedMessage());
                    }
                }
            }

            @Override
            public boolean taskServicePost(JSONObject data) {

                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        }, AppData.CURRENT_USER.getToken());
        task.execute("favorito/usuario/locales");
    }


    private void startViews() {
        LocalMinAdapter ama = new LocalMinAdapter(getContext(),getActivity(),locales,AppData.AMIN_FROM_FAVORITOS);
        progressBar.setVisibility(View.GONE);

        recyclerView.setAdapter(ama);

        recyclerView.setLayoutManager(new LinearLayoutManager(getContext()));
        if(locales==null || locales.size()==0){
            noFav.setVisibility(View.VISIBLE);
        }
    }
}
