package onthestage.es.onthestage.fragments;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.support.v4.view.ViewPager;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.VideoView;

import com.google.gson.Gson;
import com.google.gson.JsonElement;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import onthestage.es.onthestage.HistoricoEventosActivity;
import onthestage.es.onthestage.R;
import onthestage.es.onthestage.Service.GetAsync;
import onthestage.es.onthestage.Service.PostAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.adapters.ArtistaPagerAdapter;
import onthestage.es.onthestage.adapters.LocalPagerAdapter;
import onthestage.es.onthestage.model.ArtistaMin;
import onthestage.es.onthestage.model.Local;
import onthestage.es.onthestage.utils.AppData;

import static android.text.Layout.JUSTIFICATION_MODE_INTER_WORD;

public class LocalFragment extends Fragment {
    private int from;
    private int idLocal = -1;




    private ViewPager viewPager;
    private LocalPagerAdapter localPagerAdapter;
    private TextView nlocal;
    private Button btn_opiniones;
    private ImageButton ibFacebook;
    private ImageButton ibTwitter;
    private ImageButton ibInstagram;
    private ImageButton ibCompartir;
    private ImageButton ibFavorito;
    private ImageButton navegar;
    private ImageButton ibPweb;
    private TextView descripcion;

    List<String> fotos;

    Local local=null;

    public LocalFragment() {
    }

    public static LocalFragment newInstance(int from, int idlocal) {
        LocalFragment localFragment = new LocalFragment();

        Bundle args = new Bundle();
        args.putInt(AppData.FROM, from);
        args.putInt(AppData.ID_LOCAL, idlocal);
        localFragment.setArguments(args);
        return localFragment;
    }
    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if(getArguments().containsKey(AppData.FROM)){
            this.from = getArguments().getInt(AppData.FROM,-1);
        }
        if(getArguments().containsKey(AppData.ID_LOCAL)){
            this.idLocal = getArguments().getInt(AppData.ID_LOCAL, -1);
        }
        localPagerAdapter = new LocalPagerAdapter(getActivity().getSupportFragmentManager(),new ArrayList<String>());
    }

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.local_info, container, false);

        viewPager = (ViewPager) rootView.findViewById(R.id.local_fotos_container);
        viewPager.setAdapter(localPagerAdapter);
        nlocal = (TextView) rootView.findViewById(R.id.local_nlocal);
        btn_opiniones = (Button) rootView.findViewById(R.id.local_btn_opiniones);
        ibFacebook = (ImageButton) rootView.findViewById(R.id.local_facebook);
        ibTwitter = (ImageButton) rootView.findViewById(R.id.local_twitter);
        ibInstagram = (ImageButton) rootView.findViewById(R.id.local_instagram);
        ibCompartir = (ImageButton) rootView.findViewById(R.id.local_share);
        ibFavorito = (ImageButton) rootView.findViewById(R.id.local_favorito);
        navegar = (ImageButton) rootView.findViewById(R.id.local_navegar);
        descripcion = (TextView) rootView.findViewById(R.id.local_descripcion);
        ibPweb = (ImageButton) rootView.findViewById(R.id.local_web);

        if(from == AppData.LF_FROM_EVENTO){
            local = AppData.EVENTO.getLocal();
            setViews();
        }else{
            getLocal();
        }


        AppData.context = getContext();



        return rootView;
    }




    private void setViews() {
        String puntos ="";
        int longitud = 50;


        fotos = new ArrayList<String>(local.fotosToStringArray());
        localPagerAdapter.setFotos(fotos);

        longitud=30;
        if(local.getNlocal().length()>longitud){
            puntos="...";
        }else{
            longitud = local.getNlocal().length();
        }
        nlocal.setText(local.getNlocal().toUpperCase().substring(0,longitud)+puntos);

        btn_opiniones.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(getContext(), HistoricoEventosActivity.class);
                intent.putExtra(AppData.FROM__TAG, AppData.FROM_LOCALES);
                intent.putExtra(AppData.ARG_ITEM_ID, local.getId());
                getContext().startActivity(intent);
            }
        });


        ibFacebook.setSelected(false);
        if(local.getFacebook()!=null && !local.getFacebook().equals("")){
            ibFacebook.setSelected(true);
        }

        ibFacebook.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    String url = local.getFacebook();
                    startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
                }
            }
        });

        ibPweb.setSelected(false);
        if(local.getWeb()!=null && !local.getWeb().equals("")){
            ibPweb.setSelected(true);
        }

        ibPweb.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    String url = local.getWeb();
                    startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
                }
            }
        });


        ibTwitter.setSelected(false);
        if(local.getTwitter()!=null && !local.getTwitter().equals("")){
            ibTwitter.setSelected(true);
        }
        ibTwitter.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    String url = local.getTwitter();
                    startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
                }
            }
        });

        ibInstagram.setSelected(false);
        if(local.getInstagram()!=null && !local.getInstagram().equals("")){
            ibInstagram.setSelected(true);
        }
        ibInstagram.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    String url = local.getInstagram();
                    startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(url)));
                }
            }
        });

        ibCompartir.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

            }
        });

        ibFavorito.setSelected(local.getEsFavorito());

        ibFavorito.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(v.isSelected()){
                    cambiarFavorito(false,(ImageButton) v, local.getId());
                }else{
                    cambiarFavorito(true,(ImageButton) v, local.getId());
                }

            }
        });

        navegar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                // Create a Uri from an intent string. Use the result to create an Intent.
                //Uri gmmIntentUri = Uri.parse("google.streetview:cbll="+e.getLatitud()+","+e.getLongitud());
                Uri gmmIntentUri = Uri.parse("geo:"+AppData.EVENTO.getLocal().getLatitud()+","+AppData.EVENTO.getLocal().getLongitud()+"?z=19&q="+Uri.encode(AppData.EVENTO.getLocal().getNlocal()));

                // Create an Intent from gmmIntentUri. Set the action to ACTION_VIEW
                Intent mapIntent = new Intent(Intent.ACTION_VIEW, gmmIntentUri);
                // Make the Intent explicit by setting the Google Maps package
                mapIntent.setPackage("com.google.android.apps.maps");

                // Attempt to start an activity that can handle the Intent
                getContext().startActivity(mapIntent);
            }
        });

        longitud=1000;
        puntos="";
        if(local.getDescripcion().length()>longitud){
            puntos="...";
        }else{
            longitud = local.getDescripcion().length();
        }
        descripcion.setText(local.getDescripcion().substring(0,longitud)+puntos);
        if(Build.VERSION.SDK_INT >= 26)
            descripcion.setJustificationMode(JUSTIFICATION_MODE_INTER_WORD);

    }


    private void cambiarFavorito(boolean hacer, final ImageButton ib, int idLocal){//Si hacer = true, lo inserta en la bbdd sinó lo elimina
        Map<String, String> postData = new HashMap<>();
        if(hacer){
            postData.put("hacer", "1");
        }else{
            postData.put("hacer", "0");
        }
        postData.put("token", AppData.CURRENT_USER.getToken());
        PostAsync task = new PostAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject result) {

            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                if(data != null){
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            ib.setSelected(!ib.isSelected());
                            local.setEsFavorito(ib.isSelected());
                        }
                    }catch (JSONException je){
                        Log.e("EVENT_LIST",je.getLocalizedMessage());
                    }
                }
                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        }, postData);
        task.execute("favorito/usuario/local/"+idLocal);
    }

    private void getLocal() {
        GetAsync task = new GetAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject result) {
                if(result != null){
                    try {
                        String status = (String) result.get("STATUS");
                        if (status.equals("OK")) {
                            Gson gson = new Gson();
                            JSONArray jsonArray = result.getJSONArray("DATA");
                            JSONObject jsonObject = (JSONObject) jsonArray.get(0);
                            JsonElement element = gson.fromJson(jsonObject.toString(), JsonElement.class);
                            local = gson.fromJson(element, Local.class);

                            setViews();
                        }
                    }catch (JSONException je){
                        Log.e("EVENT_LIST",je.getLocalizedMessage());
                    }
                }
            }

            @Override
            public boolean taskServicePost(JSONObject data) {

                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        }, AppData.CURRENT_USER.getToken());
        task.execute("local/"+idLocal);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
    }

    @Override
    public void onStop() {
        super.onStop();
        //localPagerAdapter = null;
        this.onDestroy();
    }
}