package onthestage.es.onthestage.fragments;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import onthestage.es.onthestage.R;
import onthestage.es.onthestage.utils.AppData;

public class LocalPagerFragment extends Fragment {
    static String FOTO = "FOTO";
    static String SIZE = "SIZE";
    static String POSITION = "POSITION";
    String foto;
    int size=0;
    int position=0;

    public LocalPagerFragment() {
    }

    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        ViewGroup rootView = (ViewGroup) inflater.inflate(
                R.layout.slider_artista, container, false);

        ImageView ivFotoArtista = (ImageView) rootView.findViewById(R.id.image);
        TextView tvNumPage = (TextView) rootView.findViewById(R.id.tvNumFoto);
        tvNumPage.setText(""+(position+1)+"/"+size);
        AppData.getGlide(AppData.context, foto, ivFotoArtista);
        return rootView;
    }

    public static  LocalPagerFragment getInstance(String foto, int size, int pos){
        LocalPagerFragment localPagerFragment = new LocalPagerFragment();
        Bundle args = new Bundle();
        args.putString(FOTO, foto);
        args.putInt(SIZE, size);
        args.putInt(POSITION, pos);
        localPagerFragment.setArguments(args);
        return localPagerFragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments().containsKey( FOTO )) {
            this.foto = getArguments().getString(FOTO);
        }else{
            this.foto = AppData.NO_IMAGE;
        }
        if (getArguments().containsKey( SIZE )) {
            this.size = getArguments().getInt(SIZE);
        }else{
            this.size = 0;
        }
        if (getArguments().containsKey( POSITION )) {
            this.position = getArguments().getInt(POSITION);
        }else{
            this.position = 0;
        }
    }
}
