package onthestage.es.onthestage.menu;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.app.Activity;
import android.content.ClipData;
import android.content.ClipboardManager;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Environment;
import android.support.annotation.NonNull;
import android.support.v4.content.FileProvider;
import android.support.v7.app.ActionBarDrawerToggle;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.ImageView;
import android.widget.Toast;

import com.facebook.login.LoginManager;
import com.google.android.gms.auth.api.Auth;
import com.google.android.gms.common.api.ResultCallback;
import com.google.android.gms.common.api.Status;
import com.mikepenz.materialdrawer.AccountHeader;
import com.mikepenz.materialdrawer.AccountHeaderBuilder;
import com.mikepenz.materialdrawer.Drawer;
import com.mikepenz.materialdrawer.DrawerBuilder;
import com.mikepenz.materialdrawer.model.DividerDrawerItem;
import com.mikepenz.materialdrawer.model.PrimaryDrawerItem;
import com.mikepenz.materialdrawer.model.ProfileDrawerItem;
import com.mikepenz.materialdrawer.model.interfaces.IDrawerItem;
import com.mikepenz.materialdrawer.model.interfaces.IProfile;
import com.mikepenz.materialize.holder.ImageHolder;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

import onthestage.es.onthestage.EditProfileActivity;
import onthestage.es.onthestage.FavoritosBusquedasActivity;
import onthestage.es.onthestage.MainActivity;
import onthestage.es.onthestage.Presentation;
import onthestage.es.onthestage.R;
import onthestage.es.onthestage.UserSearch;
import onthestage.es.onthestage.model.CurrentUser;
import onthestage.es.onthestage.model.Local;
import onthestage.es.onthestage.utils.AppData;


public class Menu{
    private Activity mActivity;
    private Context context;
    private Drawer mDrawer;
    private Toolbar toolbar;
    private ProfileDrawerItem profileDrawe;
    private AccountHeader accountHeader;
    private final long PROFILE_IDENTIFIER  = 0;
    //private final int COMPARTIR  = 1;
    private final int BUSCAR_EVENTO  = 1;
    private final int VER_FAVORITOS  = 2;
    private final int VER_BUSQUEDAS  = 3;
    private final int EDITAR_PERFIL  = 4;
    private final int SALIR  = 5;






    public Menu(final Activity activity, Toolbar tb){
        this.mActivity = activity;
        context = mActivity;
        this.toolbar = tb;
        //Creating items
        //PrimaryDrawerItem item1 = new PrimaryDrawerItem().withIdentifier(COMPARTIR).withName(context.getResources().getString(R.string.compartir)).withIcon(android.R.drawable.ic_menu_share);
        PrimaryDrawerItem item1 = new PrimaryDrawerItem().withIdentifier(BUSCAR_EVENTO).withName(mActivity.getString(R.string.buscar_evento)).withIcon(R.drawable.events);
        PrimaryDrawerItem item2 = new PrimaryDrawerItem().withIdentifier(VER_FAVORITOS).withName(mActivity.getString(R.string.ver_favoritos)).withIcon(R.drawable.favoritooff);
        PrimaryDrawerItem item3 = new PrimaryDrawerItem().withIdentifier(VER_BUSQUEDAS).withName(mActivity.getString(R.string.ver_busquedas)).withIcon(R.drawable.search);
        PrimaryDrawerItem item4 = new PrimaryDrawerItem().withIdentifier(EDITAR_PERFIL).withName(mActivity.getString(R.string.edit_profile)).withIcon(R.drawable.editprofile);
        PrimaryDrawerItem item5 = new PrimaryDrawerItem().withIdentifier(SALIR).withName(context.getResources().getString(R.string.menu_exit)).withIcon(R.drawable.ic_menu_exit);


        /*Creating menu*/
        accountHeader =createMenuHeader();
        mDrawer = new DrawerBuilder()
                .withAccountHeader(accountHeader)
                .withActivity(this.mActivity)
                .withToolbar(toolbar)
                .withTranslucentStatusBar(false)
                .withActionBarDrawerToggle(true) //Set true for showing burguer icon
                .withDrawerGravity(Gravity.START) //Menu is shown by left side
                .addDrawerItems(
                        item1,
                        new DividerDrawerItem(),
                        item2,
                        new DividerDrawerItem(),
                        item3,
                        new DividerDrawerItem(),
                        item4,
                        new DividerDrawerItem(),
                        item5
                )
                .withOnDrawerItemClickListener(new Drawer.OnDrawerItemClickListener() {
                    @Override
                    public boolean onItemClick(View view, int position, IDrawerItem drawerItem) {
                        // do something with the clicked item :D
                        switch ((int)drawerItem.getIdentifier()){
                            case BUSCAR_EVENTO:
                                if(!UserSearch.estoy)
                                    buscarEvento();
                                break;
                            case VER_FAVORITOS:
                                if(!FavoritosBusquedasActivity.estoyFavoritos)
                                    verFavoritos();
                                break;
                            case VER_BUSQUEDAS:
                                if(!FavoritosBusquedasActivity.estoyBusquedas)
                                    verBusquedas();
                                break;
                            case EDITAR_PERFIL:
                                editProfile();
                                break;
                            case SALIR:
                                logout();
                                break;
                            default:
                                break;

                        }
                        return true;
                    }
                })
                .withOnDrawerListener(new Drawer.OnDrawerListener() {
                    @Override
                    public void onDrawerOpened(View drawerView) {
                        refreshIcon();
                    }

                    @Override
                    public void onDrawerClosed(View drawerView) {

                    }

                    @Override
                    public void onDrawerSlide(View drawerView, float slideOffset) {

                    }
                })
                .build();

        mDrawer.setSelection(0);

        //Coying file from getResources to shared
//        if(!copyFile()){
//            Log.e("ICON", "Error copiando el ICONO");
//        }
    }

    private void verBusquedas() {
        Intent intent2 = new Intent(AppData.context,FavoritosBusquedasActivity.class);
        intent2.putExtra(AppData.FAVORITOS_O_BUSQUEDA, AppData.OPEN_BUSQUEDA);
        mActivity.startActivity(intent2);
    }

    private void buscarEvento() {
        Intent intent = new Intent(context, UserSearch.class);
        mActivity.startActivity(intent);
    }

    private void verFavoritos() {
        Intent intent = new Intent(AppData.context,FavoritosBusquedasActivity.class);
        intent.putExtra(AppData.FAVORITOS_O_BUSQUEDA, AppData.OPEN_FAVORITOS);
        mActivity.startActivity(intent);
    }

    private void editProfile() {
        if(AppData.CURRENT_USER.getProcedencia()==AppData.FROM_OTS){
            Intent intent = new Intent(context, EditProfileActivity.class);
            context.startActivity(intent);
        }else{
            Toast.makeText(context,context.getString(R.string.cant_edit_profile), Toast.LENGTH_LONG).show();
        }

    }


    // Create the AccountHeader
    private AccountHeader createMenuHeader(){
        String nombre = (AppData.CURRENT_USER.getNombre()==null || AppData.CURRENT_USER.getNombre().equals(""))?"":AppData.CURRENT_USER.getNombre()+" ";
        if(AppData.CURRENT_USER.getProcedencia() == AppData.FROM_OTS)
            nombre += (AppData.CURRENT_USER.getApellidos()==null || AppData.CURRENT_USER.getApellidos().equals(""))?"":AppData.CURRENT_USER.getApellidos();


        profileDrawe = new ProfileDrawerItem();
        profileDrawe.withName(nombre);
        profileDrawe.withEmail(AppData.CURRENT_USER.getEmail());

        Bitmap bmp = AppData.CURRENT_USER.getFotoPerfilBmp(context);
        if(bmp==null){
            bmp = BitmapFactory.decodeResource(context.getResources(),R.drawable.noimage);
        }
        profileDrawe.withIcon(bmp);
        ImageHolder img = profileDrawe.getIcon();

        //TODO: rellenar todo el hueco de la imagen


        AccountHeader headerResult = new AccountHeaderBuilder()
                .withActivity(this.mActivity)
                .withHeaderBackground(R.drawable.com_facebook_button_login_background)
                .addProfiles(profileDrawe)
                .withOnAccountHeaderListener(new AccountHeader.OnAccountHeaderListener() {
                    @Override
                    public boolean onProfileChanged(View view, IProfile profile, boolean currentProfile) {
                        return false;
                    }
                })
                .build();

        return headerResult;
    }

    /*
    * Allow user to open target app for sharing data
    * */
    private void menuShare(){
        boolean isWhatsapp = false;
        Intent sendIntent = prepareIntent(isWhatsapp);

        //mActivity.startActivity(Intent.createChooser(sendIntent, mActivity.getResources().getText(R.string.menu_share)));

        showToast("Sharing");
    }

    /*
    * Copy a predefined text into clipboard
    * */
    private void menuCopy(){
        ClipboardManager clipboard = (ClipboardManager) mActivity.getSystemService(Context.CLIPBOARD_SERVICE);
        //ClipData clip = ClipData.newPlainText("AppInfo", mActivity.getResources().getString(R.string.shared_text));
       // clipboard.setPrimaryClip(clip);
        showToast("Text copied");
    }

    /*
    * Try to share text and image with Whatsapp app
    * */
    private void menuWhatsapp(){
        boolean isWhatsapp = true;
        Intent sendIntent = prepareIntent(isWhatsapp);


        try {
            mActivity.startActivity(sendIntent);

            showToast("Whatsapp");
        }catch (android.content.ActivityNotFoundException ex) {
            //showToast(mActivity.getResources().getText(R.string.no_whatsapp).toString());
        }

    }

    /*
    * Function that return app icon Uri
    * */
    private boolean copyFile(){
        boolean error = true;
        File dir = new File(mActivity.getFilesDir()+"/shared/", "");
        dir.mkdirs();
        File destination = new File(mActivity.getFilesDir()+"/shared/", "imagen.png");
        //Getting drawable ICON
        Drawable drawable = mActivity.getResources().getDrawable(R.mipmap.ic_launcher);
        try {
            destination.createNewFile();
        }catch(IOException ioe){
            ioe.getStackTrace();
            error = false;
        }

        if (drawable != null) {
            Bitmap src = ((BitmapDrawable) drawable).getBitmap();
            FileOutputStream out = null;
            try {
                out = new FileOutputStream(destination);
                src.compress(Bitmap.CompressFormat.PNG, 100, out); // bmp is your Bitmap instance
                // PNG is a lossless format, the compression factor (100) is ignored
            } catch (Exception e) {
                e.printStackTrace();
                error = false;
            } finally {
                try {
                    if (out != null) {
                        out.close();
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                    error = false;
                }
            }
        }
        return error;
    }

    /*
    * Helper Toast
    * */
    private void showToast(String texto){
        Toast.makeText(mActivity,texto, Toast.LENGTH_SHORT).show();
    }

    /*
    * Function that return a prepared intent to start
    * */
    private Intent prepareIntent(boolean forWhatsapp){
        File imageFile = new File(mActivity.getFilesDir()+"/shared/", "imagen.png");
        Uri contentUri = FileProvider.getUriForFile(mActivity, "tarazonacarlos.android.uoc.edu.pec4.sharedprovider", imageFile);

        //Creating Intent
        Intent sendIntent = new Intent();
        sendIntent.setAction(Intent.ACTION_SEND);

        if(forWhatsapp){
            sendIntent.setPackage("com.whatsapp");
        }

        //Give permission for reading
        sendIntent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
        sendIntent.setType("image/*");


        //adding text to intent
        //sendIntent.putExtra(Intent.EXTRA_TEXT, mActivity.getResources().getText(R.string.shared_text));
        //Adding icon from Uri
        sendIntent.putExtra(Intent.EXTRA_STREAM, contentUri);

        return sendIntent;
    }

    /*
    * Returns true if it's opened
    * Created for Test
    * */
    public boolean isMenuOpen(){
        return mDrawer.isDrawerOpen();
    }

    private void logout(){
        switch (AppData.CURRENT_USER.getProcedencia()){
            case AppData.FROM_FACEBOOK:

                break;
            case AppData.FROM_GOOGLE:
                break;
            case AppData.FROM_OTS:
                break;
            default:
                AppData.CURRENT_USER.deleteAllFotos(context);
                CurrentUser.delete(CurrentUser.class);
                break;
        }


        if(AppData.CURRENT_USER.deleteAllFotos(context)){
            int a = 4;
            a = a+4;
        }
        AppData.CURRENT_USER.delete();

        Intent intent = new Intent(context, Presentation.class);
        intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK);
        context.startActivity(intent);


    }

    public void refreshIcon(){
        String nombre = (AppData.CURRENT_USER.getNombre()==null || AppData.CURRENT_USER.getNombre().equals(""))?"":AppData.CURRENT_USER.getNombre()+" ";
        nombre += (AppData.CURRENT_USER.getApellidos()==null || AppData.CURRENT_USER.getApellidos().equals(""))?"":AppData.CURRENT_USER.getApellidos();


        profileDrawe = new ProfileDrawerItem();
        profileDrawe.withName(nombre);
        profileDrawe.withEmail(AppData.CURRENT_USER.getEmail());


        Bitmap bmp = AppData.CURRENT_USER.getFotoPerfilBmp(context);
        if(bmp==null){
            bmp = BitmapFactory.decodeResource(context.getResources(),R.drawable.noimage);
        }
        profileDrawe.withIcon(bmp);
        accountHeader.updateProfile(profileDrawe);
    }

    public void showMenu(){
        mDrawer.openDrawer();
    }


}
