package onthestage.es.onthestage.model;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.os.Parcelable;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by Carlos Tarazona on 20/02/2018.
 */

public class Artista implements User {

    public static final int MAX_FOTOS = 6; //Max number of uploaded photos

    private int id; // Primary Key
    private String email;
    private String nombre;
    private String m_pass;
    private String apellidos;
    private String fotoperfil;
    private String nartista;
    private String foto1;
    private String foto2;
    private String foto3;
    private String foto4;
    private String foto5;
    private String foto6;

    private String facebook;
    private String twitter;
    private String instagram;

    private TipoEvento tipo_espectaculo;
    private Localidad localidad;
    private int integrantes;
    private String desc_espectaculo;
    private boolean destacado;
    private boolean activado;
    private boolean registrado;
    private boolean recursos;
    private String video;
    private String pweb;
    private boolean premium;

    private float cache;
    private int tipousuario;
    private boolean esFavorito;

    public Artista() {

    }

    //Constructor for non exiting users
    public Artista(String nartista, String pweb) {
        this.nartista = nartista;
        this.pweb = pweb;
        this.recursos = false;
        this.destacado = false;
        this.premium = false;
        this.registrado = false;
        this.activado = false;
    }

    public Artista(int id, String email, String nombre, String m_pass, String apellidos, String fotoperfil,
                   String nartista, String foto1, String foto2, String foto3, String foto4, String foto5,
                   String foto6, String facebook, String twitter, String instagram, TipoEvento tipo_espectaculo,
                   Localidad localidad, int integrantes, String desc_espectaculo, boolean destacado, boolean activado,
                   boolean registrado, boolean recursos, String video, String pweb, boolean premium, float cache,
                   int tipousuario, boolean esFavorito) {
        this.id = id;
        this.email = email;
        this.nombre = nombre;
        this.m_pass = m_pass;
        this.apellidos = apellidos;
        this.fotoperfil = fotoperfil;
        this.nartista = nartista;
        this.foto1 = foto1;
        this.foto2 = foto2;
        this.foto3 = foto3;
        this.foto4 = foto4;
        this.foto5 = foto5;
        this.foto6 = foto6;
        this.facebook = facebook;
        this.twitter = twitter;
        this.instagram = instagram;
        this.tipo_espectaculo = tipo_espectaculo;
        this.localidad = localidad;
        this.integrantes = integrantes;
        this.desc_espectaculo = desc_espectaculo;
        this.destacado = destacado;
        this.activado = activado;
        this.registrado = registrado;
        this.recursos = recursos;
        this.video = video;
        this.pweb = pweb;
        this.premium = premium;
        this.cache = cache;
        this.tipousuario = tipousuario;
        this.esFavorito = esFavorito;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public String getM_pass() {
        return m_pass;
    }

    public void setM_pass(String m_pass) {
        this.m_pass = m_pass;
    }

    public String getApellidos() {
        return apellidos;
    }

    public void setApellidos(String apellidos) {
        this.apellidos = apellidos;
    }

    public String getFotoperfil() {
        return fotoperfil;
    }

    public void setFotoperfil(String fotoperfil) {
        this.fotoperfil = fotoperfil;
    }

    public String getNarnista() {
        return nartista;
    }

    public void setNarnista(String nartista) {
        this.nartista = nartista;
    }

    public String getFoto1() {
        return foto1;
    }

    public void setFoto1(String foto1) {
        this.foto1 = foto1;
    }

    public String getFoto2() {
        return foto2;
    }

    public void setFoto2(String foto2) {
        this.foto2 = foto2;
    }

    public String getFoto3() {
        return foto3;
    }

    public void setFoto3(String foto3) {
        this.foto3 = foto3;
    }

    public String getFoto4() {
        return foto4;
    }

    public void setFoto4(String foto4) {
        this.foto4 = foto4;
    }

    public String getFoto5() {
        return foto5;
    }

    public void setFoto5(String foto5) {
        this.foto5 = foto5;
    }

    public String getFoto6() {
        return foto6;
    }

    public void setFoto6(String foto6) {
        this.foto6 = foto6;
    }

    public TipoEvento getTipo_espectaculo() {
        return tipo_espectaculo;
    }

    public void setTipo_espectaculo(TipoEvento tipo_espectaculo) {
        this.tipo_espectaculo = tipo_espectaculo;
    }

    public Localidad getLocalidad() {
        return localidad;
    }

    public void setLocalidad(Localidad localidad) {
        this.localidad = localidad;
    }

    public int getIntegrantes() {
        return integrantes;
    }

    public void setIntegrantes(int integrantes) {
        this.integrantes = integrantes;
    }

    public String getDesc_espectaculo() {
        return desc_espectaculo;
    }

    public void setDesc_espectaculo(String desc_espectaculo) {
        this.desc_espectaculo = desc_espectaculo;
    }

    public boolean isDestacado() {
        return destacado;
    }

    public void setDestacado(boolean destacado) {
        this.destacado = destacado;
    }

    public boolean isActivado() {
        return activado;
    }

    public void setActivado(boolean activado) {
        this.activado = activado;
    }

    public boolean isRegistrado() {
        return registrado;
    }

    public void setRegistrado(boolean registrado) {
        this.registrado = registrado;
    }

    public boolean isRecursos() {
        return recursos;
    }

    public void setRecursos(boolean recursos) {
        this.recursos = recursos;
    }

    public String getVideo() {
        return video;
    }

    public void setVideo(String video) {
        this.video = video;
    }

    public String getPweb() {
        return pweb;
    }

    public void setPweb(String pweb) {
        this.pweb = pweb;
    }

    public boolean isPremium() {
        return premium;
    }

    public void setPremium(boolean premium) {
        this.premium = premium;
    }

    public float getCache() {
        return cache;
    }

    public void setCache(float cache) {
        this.cache = cache;
    }

    public int getTipousuario() {
        return tipousuario;
    }

    public void setTipousuario(int tipousuario) {
        this.tipousuario = tipousuario;
    }

    public boolean getEsFavorito() {
        return esFavorito;
    }

    public void setEsFavorito(boolean esFavorito) {
        this.esFavorito = esFavorito;
    }

    @Override
    public void getUserInfo() {

    }

    @Override
    public void signIn() {

    }

    @Override
    public void signUp() {

    }

    @Override
    public void modifyData() {

    }

    @Override
    public void getEvents(List<FiltroContent.Filtro> filtros) {

    }

    public String getNartista() {
        return nartista;
    }

    public void setNartista(String nartista) {
        this.nartista = nartista;
    }

    public String getFacebook() {
        return facebook;
    }

    public void setFacebook(String facebook) {
        this.facebook = facebook;
    }

    public String getTwitter() {
        return twitter;
    }

    public void setTwitter(String twitter) {
        this.twitter = twitter;
    }

    public String getInstagram() {
        return instagram;
    }

    public void setInstagram(String instagram) {
        this.instagram = instagram;
    }

    public List<String> fotosToStringArray(){
        List<String> mFotos = new ArrayList<String>();
        if(this.getFoto1()!=null && !this.getFoto1().equals(""))
        {
            mFotos.add(this.getFoto1());
        }
        if(this.getFoto2()!=null && !this.getFoto2().equals(""))
        {
            mFotos.add(this.getFoto2());
        }
        if(this.getFoto3()!=null && !this.getFoto3().equals(""))
        {
            mFotos.add(this.getFoto3());
        }
        if(this.getFoto4()!=null && !this.getFoto4().equals(""))
        {
            mFotos.add(this.getFoto4());
        }
        if(this.getFoto5()!=null && !this.getFoto5().equals(""))
        {
            mFotos.add(this.getFoto5());
        }
        if(this.getFoto6()!=null && !this.getFoto6().equals(""))
        {
            mFotos.add(this.getFoto6());
        }

        return mFotos;

    }

    public Artista duplicar(){
        Artista artista = new Artista(this.id, this.email, this.nombre, this.m_pass, this.apellidos, this.fotoperfil,
                this.nartista, this.foto1, this.foto2, this.foto3, this.foto4, this.foto5,
                this.foto6, this.facebook, this.twitter, this.instagram, this.tipo_espectaculo.duplicar(),
                this.localidad.duplicar(), this.integrantes, this.desc_espectaculo, this.destacado, this.activado,
        this.registrado, this.recursos, this.video, this.pweb, this.premium, this.cache,
        this.tipousuario, this.esFavorito);

        return artista;
    }


}
