package onthestage.es.onthestage.model;
/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/
import android.content.Context;
import android.content.ContextWrapper;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.media.MediaScannerConnection;
import android.net.Uri;
import android.os.Environment;
import android.util.Log;
import android.widget.Toast;

import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.google.gson.JsonElement;
import com.orm.SugarRecord;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutionException;

import onthestage.es.onthestage.R;
import onthestage.es.onthestage.Service.MyCallBack;
import onthestage.es.onthestage.Service.PostAsync;
import onthestage.es.onthestage.Service.TaskDelegateService;
import onthestage.es.onthestage.utils.AppData;

import static com.facebook.FacebookSdk.getApplicationContext;


public class CurrentUser extends SugarRecord{

    private int tipousuario; //Standar, local
    private int procedencia; //facebook, google, onthestage
    private int mid;
    private String nombre;
    private String nartista;
    private String nlocal;
    private String apellidos;
    private String email;
    private String token;
    private String fotoperfil;
    private String foto1;
    private String foto2;
    private String foto3;
    private String foto4;
    private String foto5;
    private String foto6;
    private int tipo_espectaculo;
    private String localidad;
    private String pweb;
    private String desc_espectaculo; //Artista
    private String descripcion; //Local
    private String integrantes;
    private int cache;
    private String video;
    private int recursos;
    private int destacado;
    private int premium;
    private int activado;
    private int registrado;
    private String horario; //Local
    private String direccion; //Local
    private double latitud; //Local
    private double longitud; //Local






    public CurrentUser() {
    }




    public CurrentUser(int tipousuario, int procedencia, int mid, String nombre, String nartista, String nlocal, String apellidos, String email, String token, String fotoperfil, String foto1, String foto2, String foto3, String foto4, String foto5, String foto6, int tipo_espectaculo, String localidad, String pweb, String desc_espectaculo, String descripcion, String integrantes, int cache, String video, int recursos, int destacado, int premium, int activado, int registrado, String horario, String direccion, double latitud, double longitud) {
        this.tipousuario = tipousuario;
        this.procedencia = procedencia;
        this.mid = mid;
        this.nombre = nombre;
        this.nartista = nartista;
        this.nlocal = nlocal;
        this.apellidos = apellidos;
        this.email = email;
        this.token = token;
        this.fotoperfil = fotoperfil;
        this.foto1 = foto1;
        this.foto2 = foto2;
        this.foto3 = foto3;
        this.foto4 = foto4;
        this.foto5 = foto5;
        this.foto6 = foto6;
        this.tipo_espectaculo = tipo_espectaculo;
        this.localidad = localidad;
        this.pweb = pweb;
        this.desc_espectaculo = desc_espectaculo;
        this.descripcion = descripcion;
        this.integrantes = integrantes;
        this.cache = cache;
        this.video = video;
        this.recursos = recursos;
        this.destacado = destacado;
        this.premium = premium;
        this.activado = activado;
        this.registrado = registrado;
        this.horario = horario;
        this.direccion = direccion;
        this.latitud = latitud;
        this.longitud = longitud;
    }

    public int getTipousuario() {
        return tipousuario;
    }

    public static CurrentUser findByTipo(int tipo){
        List<CurrentUser> currentUsers = CurrentUser.find(CurrentUser.class,"tipousuario = ?",Integer.toString(tipo));
        if(currentUsers.size()<=0){
            return null;
        }else{
            return currentUsers.get(0);
        }
    }

    public void setTipousuario(int tipousuario) {
        this.tipousuario = tipousuario;
    }

    public int getProcedencia() {
        return procedencia;
    }

    public void setProcedencia(int procedencia) {
        this.procedencia = procedencia;
    }

    public int getMid() {
        return mid;
    }

    public void setMid(int mid) {
        this.mid = mid;
    }

    public String getNombre() {
        return nombre;
    }

    public void setNombre(String nombre) {
        this.nombre = nombre;
    }

    public String getNartista() {
        return nartista;
    }

    public void setNartista(String nartista) {
        this.nartista = nartista;
    }

    public String getNlocal() {
        return nlocal;
    }

    public void setNlocal(String nlocal) {
        this.nlocal = nlocal;
    }

    public String getApellidos() {
        return apellidos;
    }

    public void setApellidos(String apellidos) {
        this.apellidos = apellidos;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public String getFotoperfil() {
        return fotoperfil;
    }

    public void setFotoperfil(String fotoperfil) {
        this.fotoperfil = fotoperfil;
    }

    public String getFoto1() {
        return foto1;
    }

    public void setFoto1(String foto1) {
        this.foto1 = foto1;
    }

    public String getFoto2() {
        return foto2;
    }

    public void setFoto2(String foto2) {
        this.foto2 = foto2;
    }

    public String getFoto3() {
        return foto3;
    }

    public void setFoto3(String foto3) {
        this.foto3 = foto3;
    }

    public String getFoto4() {
        return foto4;
    }

    public void setFoto4(String foto4) {
        this.foto4 = foto4;
    }

    public String getFoto5() {
        return foto5;
    }

    public void setFoto5(String foto5) {
        this.foto5 = foto5;
    }

    public String getFoto6() {
        return foto6;
    }

    public void setFoto6(String foto6) {
        this.foto6 = foto6;
    }

    public int getTipo_espectaculo() {
        return tipo_espectaculo;
    }

    public void setTipo_espectaculo(int tipo_espectaculo) {
        this.tipo_espectaculo = tipo_espectaculo;
    }

    public String getLocalidad() {
        return localidad;
    }

    public void setLocalidad(String localidad) {
        this.localidad = localidad;
    }

    public String getPweb() {
        return pweb;
    }

    public void setPweb(String pweb) {
        this.pweb = pweb;
    }

    public String getDesc_espectaculo() {
        return desc_espectaculo;
    }

    public void setDesc_espectaculo(String desc_espectaculo) {
        this.desc_espectaculo = desc_espectaculo;
    }

    public String getDescripcion() {
        return descripcion;
    }

    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }

    public String getIntegrantes() {
        return integrantes;
    }

    public void setIntegrantes(String integrantes) {
        this.integrantes = integrantes;
    }

    public int getCache() {
        return cache;
    }

    public void setCache(int cache) {
        this.cache = cache;
    }

    public String getVideo() {
        return video;
    }

    public void setVideo(String video) {
        this.video = video;
    }

    public int getRecursos() {
        return recursos;
    }

    public void setRecursos(int recursos) {
        this.recursos = recursos;
    }

    public int isDestacado() {
        return destacado;
    }

    public void setDestacado(int destacado) {
        this.destacado = destacado;
    }

    public int isPremium() {
        return premium;
    }

    public void setPremium(int premium) {
        this.premium = premium;
    }

    public int isActivado() {
        return activado;
    }

    public void setActivado(int activado) {
        this.activado = activado;
    }

    public int isRegistrado() {
        return registrado;
    }

    public void setRegistrado(int registrado) {
        this.registrado = registrado;
    }

    public String getHorario() {
        return horario;
    }

    public void setHorario(String horario) {
        this.horario = horario;
    }

    public String getDireccion() {
        return direccion;
    }

    public void setDireccion(String direccion) {
        this.direccion = direccion;
    }

    public double getLatitud() {
        return latitud;
    }

    public void setLatitud(double latitud) {
        this.latitud = latitud;
    }

    public double getLongitud() {
        return longitud;
    }

    public void setLongitud(double longitud) {
        this.longitud = longitud;
    }

    private boolean saveImage(Context context, Bitmap ImageToSave, int numPhoto) {

        boolean result = true;
        int maxFoto = 0;


        final Context TheThis = context;
        String NameOfFolder = "/"+AppData.APPNAME;
        String NameOfFile = "imagen";
        switch (this.getTipousuario()){
            case AppData.USER_ARTISTA:
                NameOfFolder += "/artista";
                maxFoto=6;
                break;
            case AppData.USER_LOCAL:
                NameOfFolder += "/local";
                maxFoto=4;
                break;
            case AppData.USER_ADMIN:
                NameOfFolder += "/admin";
                maxFoto=0;
                break;
            default:
                NameOfFolder += "/user";
                maxFoto=0;
                break;
        }

        if(numPhoto<0 || numPhoto>maxFoto){
            return false;
        }

        NameOfFile = "foto" + numPhoto;

        if(AppData.isExternalStorageWritable() == false){
            return false;
        }
        //String file_path = getApplicationContext().getFilesDir().getPath() + NameOfFolder;
        String file_path = context.getExternalFilesDir(Environment.getDataDirectory().getAbsolutePath()).getAbsolutePath() + NameOfFolder;
        File dir = new File(file_path);

        boolean escrito=true;
        if (!dir.exists()) {
            escrito = dir.mkdirs();
        }
        escrito = true;

        File file = new File(dir, NameOfFile + ".png");

        try {
            FileOutputStream fOut = new FileOutputStream(file);

            ImageToSave.compress(Bitmap.CompressFormat.PNG, 100, fOut);
            fOut.flush();
            fOut.close();
            MakeSureFileWasCreatedThenMakeAvabile(file, context);
            AbleToSave(context);
        }

        catch(FileNotFoundException e) {
            UnableToSave(context);
        }
        catch(IOException e) {
            UnableToSave(context);
        }

        return result;

    }

    private void MakeSureFileWasCreatedThenMakeAvabile(File file,Context TheThis){
        MediaScannerConnection.scanFile(TheThis,
                new String[] { file.toString() } , null,
                new MediaScannerConnection.OnScanCompletedListener() {

                    public void onScanCompleted(String path, Uri uri) {
                    }
                });
    }

    private String getCurrentDateAndTime() {
        Calendar c = Calendar.getInstance();
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd-HH-mm-­ss");
        String formattedDate = df.format(c.getTime());
        return formattedDate;
    }

    private void UnableToSave(Context TheThis) {
        Toast.makeText(TheThis, "¡No se ha podido guardar la imagen!", Toast.LENGTH_SHORT).show();
    }

    private void AbleToSave(Context TheThis) {
        //Toast.makeText(TheThis, "Imagen guardada en la galería.", Toast.LENGTH_SHORT).show();
        Log.i("IMAGEN_GUARDADA", "IMAGEN GUARDADA");
    }

    public Bitmap getFotoPerfilBmp(Context context){
        return getFotoBmp(context, 0);
    }

    public Bitmap getFoto1Bmp(Context context){
        return getFotoBmp(context, 1);
    }

    public Bitmap getFoto2Bmp(Context context){
        return getFotoBmp(context, 2);
    }

    public Bitmap getFoto3Bmp(Context context){
        return getFotoBmp(context, 3);
    }

    public Bitmap getFoto4Bmp(Context context){
        return getFotoBmp(context, 4);
    }

    public Bitmap getFoto5Bmp(Context context){
        return getFotoBmp(context, 5);
    }

    public Bitmap getFoto6Bmp(Context context){
        return getFotoBmp(context, 6);
    }

    public boolean saveFotoPerfilBmp(Context context, Bitmap ImageToSave){
        return saveImage(context, ImageToSave, 0);
    }

    public boolean saveFoto1Bmp(Context context, Bitmap ImageToSave){
        return saveImage(context, ImageToSave, 1);
    }

    public boolean saveFoto2Bmp(Context context, Bitmap ImageToSave){
        return saveImage(context, ImageToSave, 2);
    }

    public boolean saveFoto3Bmp(Context context, Bitmap ImageToSave){
        return saveImage(context, ImageToSave, 3);
    }

    public boolean saveFoto4Bmp(Context context, Bitmap ImageToSave){
        return saveImage(context, ImageToSave, 4);
    }

    public boolean saveFoto5Bmp(Context context, Bitmap ImageToSave){
        return saveImage(context, ImageToSave, 5);
    }

    public boolean saveFoto6Bmp(Context context, Bitmap ImageToSave){
        return saveImage(context, ImageToSave, 6);
    }

    private Bitmap getFotoBmp(Context context, int numFoto) {
        Bitmap bmp = null;
        int maxFoto = 0;
        if (AppData.isExternalStorageWritable()) {
            //String fotoPerfil = getApplicationContext().getFilesDir().getPath()+"/"+AppData.APPNAME;
            String fotoPerfil = context.getExternalFilesDir(Environment.getDataDirectory().getAbsolutePath()).getAbsolutePath()+"/"+AppData.APPNAME;
            switch (AppData.CURRENT_USER.getTipousuario()) {
                case AppData.USER_ARTISTA:
                    fotoPerfil += "/artista";
                    maxFoto = 6;
                    break;
                case AppData.USER_LOCAL:
                    fotoPerfil += "/local";
                    maxFoto = 4;
                    break;
                case AppData.USER_ADMIN:
                    fotoPerfil += "/admin";
                    maxFoto = 0;
                    break;
                default:
                    fotoPerfil += "/user";
                    maxFoto = 0;
                    break;
            }

            if(numFoto<0 || numFoto > maxFoto){
                bmp = null;
            }else{
                fotoPerfil += "/foto"+numFoto+".png";
                File fp = new File(fotoPerfil);
                if (fp.exists()) {
                    bmp = BitmapFactory.decodeFile(fotoPerfil);
//                    try {
//                        bmp= Glide.with(context).load(fotoPerfil).asBitmap().into(-1, -1).get();
//                    }catch (ExecutionException ee){
//                        Log.e("ERROR_GETTIN_PICTURE", ee.getLocalizedMessage());
//                    }catch (InterruptedException ie){
//                        Log.e("ERROR_GETTIN_PICTURE", ie.getLocalizedMessage());
//                    }
                }
            }
        }else{
            bmp = null;
        }
        return bmp;
    }

    private boolean deleteFoto(Context context, int numFoto){
        int maxFoto = 0;
        boolean borrada = false;
        if (AppData.isExternalStorageWritable()) {
            //String fotoPerfil = getApplicationContext().getFilesDir().getPath()+"/"+AppData.APPNAME;
            String fotoPerfil = context.getExternalFilesDir(Environment.getDataDirectory().getAbsolutePath()).getAbsolutePath()+"/"+AppData.APPNAME;
            switch (AppData.CURRENT_USER.getTipousuario()) {
                case AppData.USER_ARTISTA:
                    fotoPerfil += "/artista";
                    maxFoto = 6;
                    break;
                case AppData.USER_LOCAL:
                    fotoPerfil += "/local";
                    maxFoto = 4;
                    break;
                case AppData.USER_ADMIN:
                    fotoPerfil += "/admin";
                    maxFoto = 0;
                    break;
                default:
                    fotoPerfil += "/user";
                    maxFoto = 0;
                    break;
            }

            if(numFoto<0 || numFoto > maxFoto){
                return false;
            }else{
                fotoPerfil += "/foto"+numFoto+".png";
                File fdelete = new File(fotoPerfil);
                if (fdelete.exists()) {
                    if (fdelete.delete()) {
                        borrada = true;
                        System.out.println("file Deleted :" + fotoPerfil);
                    } else {
                        System.out.println("file not Deleted :" + fotoPerfil);
                    }
                }else{ //Not exists
                    borrada = true;
                }
            }
        }

        return borrada;

    }
    public boolean deleteFotoPerfil(Context context){
        return deleteFoto(context,0);
    }

    public boolean deleteFoto1(Context context){
        return deleteFoto(context,1);
    }

    public boolean deleteFoto2(Context context){
        return deleteFoto(context,2);
    }

    public boolean deleteFoto3(Context context){
        return deleteFoto(context,3);
    }

    public boolean deleteFoto4(Context context){
        return deleteFoto(context,4);
    }

    public boolean deleteFoto5(Context context){
        return deleteFoto(context,5);
    }
    public boolean deleteFoto6(Context context){
        return deleteFoto(context,6);
    }

    public boolean deleteAllFotos(Context context){
        return deleteFotoPerfil(context) &&
                deleteFoto1(context) &&
                deleteFoto2(context) &&
                deleteFoto3(context) &&
                deleteFoto4(context) &&
                deleteFoto5(context) &&
                deleteFoto6(context);
    }


    public void guardarUsuarioEnBDWeb(final MyCallBack myCallBack){
        Map<String, String> postData = new HashMap<>();
        String email = this.email;
        postData.put("email", email);
//        String nombre = this.nombre;
//        postData.put("nombre", nombre);
//        String apellidos = this.apellidos;
//        postData.put("apellidos", apellidos);
//        postData.put("foto", this.fotoperfil);

        new PostAsync(new TaskDelegateService() {
            @Override
            public void taskServiceCompleted(JSONObject result) {

            }

            @Override
            public boolean taskServicePost(JSONObject data) {
                if(data != null){
                    try {
                        String status = (String) data.get("STATUS");
                        if (status.equals("OK")) {
                            JSONObject jsData = data.getJSONObject("DATA");
                            String token = jsData.getString("token");
                            AppData.CURRENT_USER.setToken(token);
                            AppData.CURRENT_USER.save();

                            if(myCallBack!=null)
                                myCallBack.callbackCall();
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                    return true;
                }

                return false;
            }

            @Override
            public void taskGetImage(Bitmap bm) {

            }
        }, postData).execute("signinup");


    }
}
