package onthestage.es.onthestage.model;

import android.content.Context;
import android.util.Log;

import java.sql.Time;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Locale;

/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/

public class EventosContent {

    public static List<Evento> Eventos = new ArrayList<>();

    public static boolean exists(Evento e){
        boolean existe = false;
        for(int i = 0; i< Eventos.size();i++){
            if(e.getId() == Eventos.get(i).getId()){
                existe = true;
                break;
            }
        }
        return existe;
    }

    public static class Evento {
        private int id; // Primary Key
        private String dia;
        private String hora;
        private String foto;
        private String nombre;
        private int numFavoritos;
        private boolean destacado;
        private float precio;
        private int edad_minima;
        private String ofertas;
        private int asistentes;
        private Local local;
        private List<TipoEvento> tipo;
        private String descripcion;
        private List<Artista> artistas;
        private boolean esFavorito;
        private boolean asistira;
        private String tickets;

        public Evento() {
        }


        public Evento(int id, String dia, String hora, String foto, String nombre, int numFavoritos,
                      boolean destacado, float precio, int edad_minima, String ofertas, int asistentes,
                      Local local, List<TipoEvento> tipo, String descripcion, List<Artista> artistas,
                      boolean esFavorito, boolean asistira, String tickets) {
            this.id = id;
            this.dia = dia;
            this.hora = hora;
            this.foto = foto;
            this.nombre = nombre;
            this.numFavoritos = numFavoritos;
            this.destacado = destacado;
            this.precio = precio;
            this.edad_minima = edad_minima;
            this.ofertas = ofertas;
            this.asistentes = asistentes;
            this.local = local;
            this.tipo = tipo;
            this.descripcion = descripcion;
            this.artistas = artistas;
            this.esFavorito = esFavorito;
            this.asistira = asistira;
            this.tickets = tickets;
        }


        public int getId() {
            return id;
        }

        public void setId(int id) {
            this.id = id;
        }

        public String getDia() {
            return dia;
        }

        public void setDia(String dia) {
            this.dia = dia;
        }

        public String getHora() {
            return hora;
        }

        public void setHora(String hora) {
            this.hora = hora;
        }

        public String getFoto() {
            return foto;
        }

        public void setFoto(String foto) {
            this.foto = foto;
        }

        public String getNombre() {
            return nombre;
        }

        public void setNombre(String nombre) {
            this.nombre = nombre;
        }

        public int getNumFavoritos() {
            return numFavoritos;
        }

        public void setNumFavoritos(int numFavoritos) {
            this.numFavoritos = numFavoritos;
        }

        public boolean isDestacado() {
            return destacado;
        }

        public void setDestacado(boolean destacado) {
            this.destacado = destacado;
        }

        public float getPrecio() {
            return precio;
        }

        public void setPrecio(float precio) {
            this.precio = precio;
        }

        public int getEdad_minima() {
            return edad_minima;
        }

        public void setEdad_minima(int edad_minima) {
            this.edad_minima = edad_minima;
        }

        public String getOfertas() {
            return ofertas;
        }

        public void setOfertas(String ofertas) {
            this.ofertas = ofertas;
        }

        public int getAsistentes() {
            return asistentes;
        }

        public void setAsistentes(int asistentes) {
            this.asistentes = asistentes;
        }

        public Local getLocal() {
            return local;
        }

        public void setLocal(Local local) {
            this.local = local;
        }

        public List<TipoEvento> getTipo() {
            return tipo;
        }

        public void setTipo(List<TipoEvento> tipo) {
            this.tipo = tipo;
        }

        public String getDescripcion() {
            return descripcion;
        }

        public void setDescripcion(String descripcion) {
            this.descripcion = descripcion;
        }

        public List<Artista> getArtistas() {
            return artistas;
        }

        public void setArtistas(List<Artista> artistas) {
            this.artistas = artistas;
        }
        public boolean getEsFavorito() {
            return esFavorito;
        }

        public void setEsFavorito(boolean esFavorito) {
            this.esFavorito = esFavorito;
        }

        public boolean isAsistira() {
            return asistira;
        }

        public void setAsistira(boolean asistira) {
            this.asistira = asistira;
        }

        public String getTickets() {
            return tickets;
        }

        public void setTickets(String tickets) {
            this.tickets = tickets;
        }

        public String getMonth(Context context) {
            Locale spanish = context.getResources().getConfiguration().locale;
            SimpleDateFormat month_date = new SimpleDateFormat("MMM", spanish);
            SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy");
            Date date = new Date();
            try {
                date = sdf.parse(this.getDia());
            } catch (ParseException pe) {
                Log.e("EVENTO_ERROR", "Error en la fecha");
            }


            String month_name = month_date.format(date);
            return month_name;
        }

        public String getDay(Context context) {
            Locale spanish = context.getResources().getConfiguration().locale;
            SimpleDateFormat month_date = new SimpleDateFormat("dd", spanish);
            SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy");
            Date date = new Date();
            try {
                date = sdf.parse(this.getDia());
            } catch (ParseException pe) {
                Log.e("EVENTO_ERROR", "Error en la fecha");
            }


            String month_name = month_date.format(date);
            return month_name;
        }

        public String getFullDate(Context context) {
            Locale spanish = context.getResources().getConfiguration().locale;
            SimpleDateFormat month_date = new SimpleDateFormat("E, dd MMM", spanish);
            SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy");
            Date date = new Date();
            try {
                date = sdf.parse(this.getDia());
            } catch (ParseException pe) {
                Log.e("EVENTO_ERROR", "Error en la fecha");
            }


            String month_name = month_date.format(date);
            return month_name;
        }
    }


    public static class EventoMin{
        private int id; // Primary Key
        private String dia;
        private String hora;
        private String foto;
        private String nombre;
        private String telefono;
        private float distancia;
        private float latitud;
        private float longitud;
        private float precio;
        private String local;
        private List<String> artistas;
        private boolean esFavorito;
        private int numFavoritos;
        private int tipoevento;
        private String descripcion;
        private String tickets;

        public EventoMin() {
        }

        public EventoMin(int id, String dia, String hora, String foto, String nombre, String telefono,
                         float distancia, float latitud, float longitud, float precio, String local,
                         List<String> artistas, boolean esFavorito, int numFavoritos, int tipoevento,
                         String descripcion, String tickets) {
            this.id = id;
            this.dia = dia;
            this.hora = hora;
            this.foto = foto;
            this.nombre = nombre;
            this.telefono = telefono;
            this.distancia = distancia;
            this.latitud = latitud;
            this.longitud = longitud;
            this.precio = precio;
            this.local = local;
            this.artistas = artistas;
            this.esFavorito = esFavorito;
            this.numFavoritos = numFavoritos;
            this.tipoevento = tipoevento;
            this.descripcion = descripcion;
            this.tickets = tickets;
        }

        public int getId() {
            return id;
        }

        public void setId(int id) {
            this.id = id;
        }

        public String getDia() {
            return dia;
        }

        public void setDia(String dia) {
            this.dia = dia;
        }

        public String getHora() {
            return hora;
        }

        public void setHora(String hora) {
            this.hora = hora;
        }

        public String getFoto() {
            return foto;
        }

        public void setFoto(String foto) {
            this.foto = foto;
        }

        public String getNombre() {
            return nombre;
        }

        public void setNombre(String nombre) {
            this.nombre = nombre;
        }

        public float getDistancia() {
            return distancia;
        }

        public void setDistancia(float distancia) {
            this.distancia = distancia;
        }

        public String getTelefono() {
            return telefono;
        }

        public void setTelefono(String telefono) {
            this.telefono = telefono;
        }

        public float getPrecio() {
            return precio;
        }

        public void setPrecio(float precio) {
            this.precio = precio;
        }

        public String getLocal() {
            return local;
        }

        public void setLocal(String local) {
            this.local = local;
        }

        public boolean getEsFavorito() {
            return esFavorito;
        }

        public void setEsFavorito(boolean esFavorito) {
            this.esFavorito = esFavorito;
        }

        public float getLatitud() {
            return latitud;
        }

        public void setLatitud(float latitud) {
            this.latitud = latitud;
        }

        public float getLongitud() {
            return longitud;
        }

        public void setLongitud(float longitud) {
            this.longitud = longitud;
        }

        public int getTipoevento() {
            return tipoevento;
        }

        public void setTipoevento(int tipoevento) {
            this.tipoevento = tipoevento;
        }

        public int getNumFavoritos() {
            return numFavoritos;
        }

        public void setNumFavoritos(int numFavoritos) {
            this.numFavoritos = numFavoritos;
        }

        public String getDescripcion() {
            return descripcion;
        }

        public void setDescripcion(String descripcion) {
            this.descripcion = descripcion;
        }

        public List<String> getArtistas() {
            return artistas;
        }

        public void setArtistas(List<String> artistas) {
            this.artistas = artistas;
        }


        public String getTickets() {
            return tickets;
        }

        public void setTickets(String tickets) {
            this.tickets = tickets;
        }

        public String getMonth(Context context) {
            Locale spanish = context.getResources().getConfiguration().locale;
            SimpleDateFormat month_date = new SimpleDateFormat("MMM", spanish);
            SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy");
            Date date = new Date();
            try {
                date = sdf.parse(this.getDia());
            } catch (ParseException pe) {
                Log.e("EVENTO_ERROR", "Error en la fecha");
            }


            String month_name = month_date.format(date);
            return month_name;
        }

        public String getDay(Context context) {
            Locale spanish = context.getResources().getConfiguration().locale;
            SimpleDateFormat month_date = new SimpleDateFormat("dd", spanish);
            SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy");
            Date date = new Date();
            try {
                date = sdf.parse(this.getDia());
            } catch (ParseException pe) {
                Log.e("EVENTO_ERROR", "Error en la fecha");
            }


            String month_name = month_date.format(date);
            return month_name;
        }
    }
}