package onthestage.es.onthestage.model;

import com.orm.SugarRecord;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import onthestage.es.onthestage.utils.AppData;

/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/

public class FiltroContent {
    public static List<Filtro> filtros = new ArrayList<Filtro>();;

    public static List<Filtro> getFiltros(){
         List<Filtro> savedFiltros = Filtro.find(Filtro.class, null);
         filtros = new ArrayList<Filtro>();

        for (Filtro filtro: savedFiltros) {
            if(filtro.getIduser()==AppData.CURRENT_USER.getMid()){
                filtros.add(filtro.modificarCuando());
            }

        }

        return filtros;
    }

    public static List<Filtro>startFiltros(){
        List<Filtro> savedFiltros = Filtro.find(Filtro.class, null);
        List<Filtro> mfiltros = new ArrayList<Filtro>();

        for (Filtro filtro: savedFiltros) {
            if(filtro.getIduser()==AppData.CURRENT_USER.getMid()){
                mfiltros.add(filtro.modificarCuando());
            }

        }

        return mfiltros;
    }

    public static boolean existsFilter(String mQuery){
        boolean existe = false;
        List<Filtro> mFiltros = getFiltros();
        int id = AppData.CURRENT_USER.getMid();
        for(Filtro filtro : mFiltros){
            if(filtro.getQuery().toLowerCase().equals(mQuery.toLowerCase()) && filtro.getIduser()==id){
                existe = true;
                break;
            }
        }
        return existe;
    }

    public static boolean existsFilter(Filtro mFiltro){
        boolean existe = false;
        List<Filtro> mFiltros = getFiltros();
        for(Filtro filtro : mFiltros){
            if(filtro.getQuery().toLowerCase().equals(mFiltro.getQuery().toLowerCase())){
                existe = true;
                break;
            }
        }
        return existe;
    }


    public static class Filtro extends SugarRecord {
        int iduser;
        String query;
        String nombre;
        int sumarCuando;
        boolean notificaciones;
        String quien;
        String ques;
        String precios;
        String cuando;

        public Filtro(int iduser, String query, String nombre, int sumarCuando, boolean notificaciones, String quien, String ques, String precios, String cuando) {
            this.iduser = iduser;
            this.query = query;
            this.nombre = nombre;
            this.sumarCuando = sumarCuando;
            this.notificaciones = notificaciones;
            this.quien = quien;
            this.ques = ques;
            this.precios = precios;
            this.cuando = cuando;
        }

        public Filtro() {
        }



        public int getIduser() {
            return iduser;
        }

        public void setIduser(int iduser) {
            this.iduser = iduser;
        }

        public String getQuery() {
            return query;
        }

        public void setQuery(String query) {
            this.query = query;
        }

        public String getNombre() {
            return nombre;
        }

        public void setNombre(String nombre) {
            this.nombre = nombre;
        }

        public int getSumarCuando() {
            return sumarCuando;
        }

        public void setSumarCuando(int sumarCuando) {
            this.sumarCuando = sumarCuando;
        }

        public boolean getNotificaciones() {
            return notificaciones;
        }

        public void setNotificaciones(boolean notificaciones) {
            this.notificaciones = notificaciones;
        }

        public String getQuien() {
            return quien;
        }

        public void setQuien(String quien) {
            this.quien = quien;
        }

        public String getQues() {
            return ques;
        }

        public void setQues(String ques) {
            this.ques = ques;
        }

        public String getPrecios() {
            return precios;
        }

        public void setPrecios(String precios) {
            this.precios = precios;
        }

        public String getCuando() {
            return cuando;
        }

        public void setCuando(String cuando) {
            this.cuando = cuando;
        }

        public Filtro modificarCuando() {
            if(this.query.toLowerCase().contains("when") && this.sumarCuando>=0){
                String[] splitedString = this.query.toLowerCase().split("when=");
                if(splitedString.length==2){
                    String[] fechaSplited = splitedString[1].split(AppData.SEPARATOR_FILTER);
                    String fecha=fechaSplited[0];
                    String nuevaFecha = AppData.sumarDiasAFechaBBDD(null,sumarCuando);
                    String[] nSplited = this.query.toLowerCase().split(fecha);
                    String nuevaQuery = nSplited[0]+nuevaFecha+nSplited[1];
                    this.setQuery(nuevaQuery);
                }
            }
            return  this;
        }


    }
}
