package onthestage.es.onthestage.sliders;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import android.content.Intent;

import onthestage.es.onthestage.ArtistaInfo;
import onthestage.es.onthestage.EventoArtistaLocal;
import onthestage.es.onthestage.R;
import onthestage.es.onthestage.utils.AppData;

/*
        Autor: Carlos Tarazona Tárrega.
        Licencia: Copyright 2018. Se permite el estudio y modificación del fichero citando las fuentes
*/

public class SliderFragment extends Fragment {
    public static String POSICION ="Titulo33";
    public static String TIPO_SLIDER ="TipoSlider";
    public static String SIZE ="NumPages";

    private int posicion;
    private int tipoSlider;
    private int size;


    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        ViewGroup rootView = (ViewGroup) inflater.inflate(
                R.layout.slider_destacado, container, false);

        TextView tvTitulo = (TextView) rootView.findViewById(R.id.txt_slider_destacado);
        ImageView imgView = (ImageView) rootView.findViewById(R.id.image);

        TextView tvNumPage = (TextView) rootView.findViewById(R.id.tvNumFoto);
        tvNumPage.setText(""+(posicion+1)+"/"+size);

        switch (tipoSlider){
            case AppData.IS_DESTACADO:
                if(this.posicion<0 || this.posicion>= AppData.EVENTOS_DESTACADOS.size() || this.posicion>= AppData.EVENTOS_DESTACADOS.size()){
                    tvTitulo.setText(getString(R.string.no_title));
                    imgView.setImageDrawable(getResources().getDrawable(R.drawable.noimageslider));
                }else{
                    tvTitulo.setText(AppData.EVENTOS_DESTACADOS.get(posicion).getNombre());
                    String url = AppData.EVENTOS_DESTACADOS.get(posicion).getFoto();
                    if(url==null || url.equals("")){
                        url = AppData.NO_IMAGE;
                    }
                    AppData.getGlide(AppData.context,url,imgView);
                 }
                break;
            case  AppData.IS_PREMIUM:
                if(this.posicion<0 || this.posicion>= AppData.ARTISTAS_PREMIUM.size() || this.posicion>=AppData.ARTISTAS_PREMIUM.size()){
                    tvTitulo.setText(getString(R.string.no_title));
                    imgView.setImageDrawable(getResources().getDrawable(R.drawable.noimageslider));
                }else{
                    String nombre = AppData.ARTISTAS_PREMIUM.get(posicion).getNarnista();
                    tvTitulo.setText(nombre);
                    String url = AppData.ARTISTAS_PREMIUM.get(posicion).getFotoperfil();
                    if(url==null || url.equals("")){
                        url = AppData.NO_IMAGE;
                    }
                    AppData.getGlide(AppData.context,url,imgView);
                }
                break;
            default:
                break;
        }

        rootView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String texto ="";
                switch (tipoSlider){
                    case AppData.IS_DESTACADO:
                        Intent intent2 = new Intent(AppData.context,EventoArtistaLocal.class);
                        intent2.putExtra(AppData.ARG_ID_EVENTO,AppData.EVENTOS_DESTACADOS.get(posicion).getId());
                        startActivity(intent2);
                        break;
                    case  AppData.IS_PREMIUM:
                        Intent intent = new Intent(AppData.context,ArtistaInfo.class);
                        intent.putExtra(AppData.ARG_ITEM_ID,posicion);
                        startActivity(intent);
                        break;
                    default:
                        break;
                }

            }
        });

        return rootView;
    }

    public static SliderFragment newSliderFragment(int posicion, int tipoSlider, int size) {
        SliderFragment fragment = new SliderFragment();
        Bundle args = new Bundle();
        args.putInt(POSICION, posicion);
        args.putInt(TIPO_SLIDER, tipoSlider);
        args.putInt(SIZE, size);

        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        Log.i("TEST","Entra Oncreate Fragment");
        super.onCreate(savedInstanceState);
        if (getArguments().containsKey( POSICION )) {
            this.posicion = getArguments().getInt(POSICION);
        }else{
            this.posicion = -1;
        }
        if (getArguments().containsKey( TIPO_SLIDER )) {
            this.tipoSlider = getArguments().getInt(TIPO_SLIDER);
        }else{
            this.tipoSlider = -1;
        }

        if (getArguments().containsKey( SIZE )) {
            this.size = getArguments().getInt(SIZE);
        }else{
            this.size = -1;
        }

    }
}
