package onthestage.es.onthestage.utils;

import android.app.Activity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.Build;
import android.os.Environment;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.ShareCompat;
import android.support.v4.content.FileProvider;
import android.support.v4.view.PagerAdapter;
import android.support.v7.app.AlertDialog;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.ListAdapter;
import android.widget.TextView;
import android.widget.Toast;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.model.GlideUrl;
import com.bumptech.glide.load.model.Headers;
import com.bumptech.glide.load.model.LazyHeaders;
import com.bumptech.glide.request.RequestOptions;
import com.bumptech.glide.request.target.BaseTarget;
import com.bumptech.glide.request.target.SizeReadyCallback;

import com.bumptech.glide.request.transition.Transition;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import onthestage.es.onthestage.R;
import onthestage.es.onthestage.model.Artista;
import onthestage.es.onthestage.model.ArtistaMin;
import onthestage.es.onthestage.model.Comunidad;
import onthestage.es.onthestage.model.CurrentUser;
import onthestage.es.onthestage.model.EventosContent;
import onthestage.es.onthestage.model.Localidad;
import onthestage.es.onthestage.model.Provincia;
import onthestage.es.onthestage.model.TipoEvento;

import static java.lang.Math.asin;
import static java.lang.Math.cos;
import static java.lang.Math.min;
import static java.lang.Math.round;
import static java.lang.Math.sin;
import static java.lang.Math.sqrt;

/**
 * Created by monxi on 26/2/18.
 */

public class AppData{
    public static final int USER_STANDARD = 0;
    public static final int FROM_GOOGLE = 10;
    public static final int FROM_FACEBOOK = 20;
    public static final int FROM_OTS = 30;

    public static final int USER_REGISTERED = 1;
    public static final int USER_PREMIUM = 2;
    public static final int USER_ADMIN = 5;
    public static final int USER_LOCAL = 4;
    public static final int USER_ARTISTA = 3;

    public final static String SEPARATOR_FILTER = ";;";

    public static final int FOTO_PERFIL = 0;
    public static final int FOTO1 = 1;
    public static final int FOTO2 = 2;
    public static final int FOTO3 = 3;
    public static final int FOTO4 = 4;
    public static final int FOTO5 = 5;
    public static final int FOTO6 = 6;
    public static final int FOTO_EVENTO_SHARE = 7;
    public static final int LISTA_EVENTO_PRIMARY = 0;
    public static final int LISTA_EVENTO_SECONDARY = 2;

    //Para el adapterMin
    public static final int AMIN_FROM_SEARCH = 0;
    public static final int AMIN_FROM_FAVORITOS = 1;

    //Para LocalFragment
    public static final int LF_FROM_EVENTO = 0;
    public static final int LF_FROM_FAVORITOS = 1;
    final static public String FROM = "FROM";
    final static public String ID_LOCAL = "ID_LOCAL";

    //Para EventMinAdapter
    public static final int FROM_FAVORITOS = 0;
    public static final int FROM_ARTISTAS = 1;
    public static final int FROM_LOCALES = 2;
    public static final String FROM__TAG = "FROM_LOCALES_ARTISTAS_FAV";


    //Paso de parametros de main activity a FavoritosBusqueda
    public static final String FAVORITOS_O_BUSQUEDA = "FavoritosOBusqueda";
    public static final int OPEN_HOME = 0;
    public static final int OPEN_FAVORITOS = 1;
    public static final int OPEN_BUSQUEDA = 2;


    public static List<Artista> ARTISTAS_PREMIUM = new ArrayList<Artista>();
    public static List<EventosContent.Evento> EVENTOS_DESTACADOS = new ArrayList<EventosContent.Evento>();

    public static List<EventosContent.EventoMin> EVENTOS_MIN = new ArrayList<EventosContent.EventoMin>();
    public static EventosContent.Evento EVENTO = new EventosContent.Evento();
    public static Artista ARTISTA = new Artista();

    public static String EVENT_FILE_PICTURE = "eventfile.png";

    public static final String APPNAME = "OnTheStage";


    public static final String SERVER_BASE_URI = "https://onthestage.es/";
    public static final String NO_USER_IMAGE = SERVER_BASE_URI+"img/nouser.png";
    public static final String NO_IMAGE = SERVER_BASE_URI+"img/noimage.png";
    public static final String REST_BASE_URI = SERVER_BASE_URI + "restapi/v1/";

    private static AppData app = null;

    public static List<Comunidad> COMUNIDADES = new ArrayList<Comunidad>();
    public static List<Provincia> PROVINCIAS = new ArrayList<Provincia>();
    public static List<Localidad> LOCALIDADES = new ArrayList<Localidad>();
    public static List<TipoEvento> GENEROSEVENTOS = new ArrayList<TipoEvento>();
    public static List<TipoEvento> MUSICAEVENTOS = new ArrayList<TipoEvento>();
    public static List<ArtistaMin> ARTISTAMIN = new ArrayList<ArtistaMin>();



    public static final String ARG_ITEM_ID = "ArtistaIdentificadorPremium";
    public static final String ARG_ITEM_ID_OTROS = "ArtistaIdentificadorOtros";
    public static final String ARG_ID_EVENTO = "IdEvento";
    public static final String SEARCH_QUERY = "SearchQuery";
    public static final String TAG_FRAGMENT_EVENT_LIST = "FragmentEventList";



    public static final int IS_DESTACADO = 0;
    public static final int IS_PREMIUM = 1;

    private static boolean isWhatsapp=false;


    public static CurrentUser CURRENT_USER=null;

    public static Context context;
    public static AppData getInstance(){
        if(app == null){
            app = new AppData();
        }
        return app;
    }

    public AppData(){
        //Log.d("ENTRA EN APPDATA", "ENTRA");
    }

    public void init() {
//        getAllComunidades();
//        getAllProvincias();
//        getAllLocalidades();
        CURRENT_USER = CurrentUser.findByTipo(AppData.USER_STANDARD);
    }

//    public void getAllComunidades() {
//        GetAsync ga = new GetAsync(new HandlerComunidades());
//        ga.execute("allcomunidades");
//    }
//
//    public void getAllProvincias() {
//        GetAsync ga = new GetAsync(new HandlerProvincias());
//        ga.execute("allprovincias");
//    }
//
//    public void getAllLocalidades() {
//        GetAsync ga = new GetAsync(new HandlerLocalidades());
//        ga.execute("alllocalidades");
//    }

    /* Checks if external storage is available for read and write */
    public static boolean isExternalStorageWritable() {
        String state = Environment.getExternalStorageState();
        if (Environment.MEDIA_MOUNTED.equals(state)) {
            return true;
        }
        return false;
    }

    /* Checks if external storage is available to at least read */
    public static boolean isExternalStorageReadable() {
        String state = Environment.getExternalStorageState();
        if (Environment.MEDIA_MOUNTED.equals(state) ||
                Environment.MEDIA_MOUNTED_READ_ONLY.equals(state)) {
            return true;
        }
        return false;
    }

    public static boolean getGlide(Context context,String mUrl, ImageView imageView){
        try{
            Headers headers = new LazyHeaders.Builder().addHeader("Authorization", AppData.CURRENT_USER.getToken()).build();
            String mmUrl = mUrl;
            if(mmUrl==null || mmUrl.equals("")){
                mmUrl=AppData.NO_IMAGE;
            }
            GlideUrl url = new GlideUrl(mmUrl, headers);

            Glide.with(context)
                    .load(url)
                    .apply(new RequestOptions().placeholder(R.drawable.loading).error(R.drawable.notfound).centerCrop())
                    .into(imageView);

        }catch (Exception e){
            Log.e("ERROR-GLIDE",e.getLocalizedMessage());
            Toast.makeText(context,  context.getString(R.string.load_picture_error),Toast.LENGTH_SHORT).show();
        }

        return true;
    }

    public static void glideSaveBMPinLocal(final Context context, String mUrl, final int numImage){
        Headers headers = new LazyHeaders.Builder().addHeader("Authorization", AppData.CURRENT_USER.getToken()).build();
        String mmUrl = mUrl;
        if(mmUrl==null || mmUrl.equals("")){
            mmUrl=AppData.NO_IMAGE;
        }
        GlideUrl url = new GlideUrl(mmUrl, headers);
        BaseTarget target = new BaseTarget<BitmapDrawable>() {
            @Override
            public void onLoadFailed(@Nullable Drawable errorDrawable) {
                super.onLoadFailed(errorDrawable);
                Log.e("GLIDE_ERROR","Error al cargar la foto");
            }

            @Override
            public void onResourceReady(BitmapDrawable bitmap, Transition<? super BitmapDrawable> transition) {
                // do something with the bitmap
                // for demonstration purposes, let's set it to an imageview
                switch (numImage){
                    case FOTO_PERFIL:
                        AppData.CURRENT_USER.saveFotoPerfilBmp(context,bitmap.getBitmap());
                        break;
                    case FOTO1:
                        AppData.CURRENT_USER.saveFoto1Bmp(context,bitmap.getBitmap());
                        break;
                    case FOTO2:
                        AppData.CURRENT_USER.saveFoto2Bmp(context,bitmap.getBitmap());
                        break;
                    case FOTO3:
                        AppData.CURRENT_USER.saveFoto3Bmp(context,bitmap.getBitmap());
                        break;
                    case FOTO4:
                        AppData.CURRENT_USER.saveFoto4Bmp(context,bitmap.getBitmap());
                        break;
                    case FOTO5:
                        AppData.CURRENT_USER.saveFoto5Bmp(context,bitmap.getBitmap());
                        break;
                    case FOTO6:
                        AppData.CURRENT_USER.saveFoto6Bmp(context,bitmap.getBitmap());
                        break;
                }

            }

            @Override
            public void getSize(SizeReadyCallback cb) {
                cb.onSizeReady(SIZE_ORIGINAL, SIZE_ORIGINAL);
            }

            @Override
            public void removeCallback(SizeReadyCallback cb) {}
        };

        Glide
                .with(context)
                .load(url)
                .into(target);

    }

    public static void glideSaveExternalBMPinLocal(final Context context, String mUrl, final int numImage){
        String mmUrl = mUrl;
        if(mmUrl==null || mmUrl.equals("")){
            mmUrl=AppData.NO_IMAGE;
        }
        GlideUrl url = new GlideUrl(mmUrl);
        BaseTarget target = new BaseTarget<BitmapDrawable>() {
            @Override
            public void onLoadFailed(@Nullable Drawable errorDrawable) {
                super.onLoadFailed(errorDrawable);
                Log.e("GLIDE_ERROR","Error al cargar la foto");
            }

            @Override
            public void onResourceReady(BitmapDrawable bitmap, Transition<? super BitmapDrawable> transition) {
                // do something with the bitmap
                // for demonstration purposes, let's set it to an imageview
                switch (numImage){
                    case FOTO_PERFIL:
                        AppData.CURRENT_USER.saveFotoPerfilBmp(context,bitmap.getBitmap());
                        break;
                    case FOTO1:
                        AppData.CURRENT_USER.saveFoto1Bmp(context,bitmap.getBitmap());
                        break;
                    case FOTO2:
                        AppData.CURRENT_USER.saveFoto2Bmp(context,bitmap.getBitmap());
                        break;
                    case FOTO3:
                        AppData.CURRENT_USER.saveFoto3Bmp(context,bitmap.getBitmap());
                        break;
                    case FOTO4:
                        AppData.CURRENT_USER.saveFoto4Bmp(context,bitmap.getBitmap());
                        break;
                    case FOTO5:
                        AppData.CURRENT_USER.saveFoto5Bmp(context,bitmap.getBitmap());
                        break;
                    case FOTO6:
                        AppData.CURRENT_USER.saveFoto6Bmp(context,bitmap.getBitmap());
                        break;
                    case FOTO_EVENTO_SHARE:
                        if(!copyFile((Activity)context,bitmap.getBitmap())){
                            Toast.makeText(context,context.getString(R.string.error_sharing),Toast.LENGTH_SHORT).show();
                        }
                        break;
                }

            }

            @Override
            public void getSize(SizeReadyCallback cb) {
                cb.onSizeReady(SIZE_ORIGINAL, SIZE_ORIGINAL);
            }

            @Override
            public void removeCallback(SizeReadyCallback cb) {}
        };

        Glide
                .with(context)
                .load(url)
                .into(target);

    }
    public static String sumarDiasAFechaUser(Date fecha, int dias){
        Date mFecha = fecha;
        if(mFecha == null){
            mFecha = new Date();
        }
        DateFormat df = new SimpleDateFormat("dd-MM-yyyy");
        if (dias==0) return df.format(mFecha);
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(mFecha);
        calendar.add(Calendar.DAY_OF_YEAR, dias);
        return df.format(calendar.getTime());
    }

    public static String sumarDiasAFechaUser(String fecha, int dias){
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd");
        DateFormat df2 = new SimpleDateFormat("dd-MM-yyyy");
        Date fech;
        String sFecha ="NO DATE";
        Calendar calendar = Calendar.getInstance();
        boolean error=false;
        try{
            fech = df.parse(fecha);

            calendar.setTime(fech);
            calendar.add(Calendar.DAY_OF_YEAR, dias);

        }catch (ParseException pe){
            Log.e("AppDataERROR","Error convirtiendo fechas " + pe.getLocalizedMessage());
        }
        if(!error)
            sFecha = df2.format(calendar.getTime());

        return sFecha;
    }

    public static String sumarDiasAFechaBBDD(Date fecha, int dias){
        Date mFecha = fecha;
        if(mFecha == null){
            mFecha = new Date();
        }
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd");
        if (dias==0) return df.format(mFecha);
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(mFecha);
        calendar.add(Calendar.DAY_OF_YEAR, dias);
        return df.format(calendar.getTime());
    }

    public static String formatPhoneNumber(String telf,Context context){
        if(telf == null || telf.equals("")){
            return context.getString(R.string.sin_informacion);
        }
        char numeros[] = telf.replace(" ","").toCharArray();
        String telefono="";
        String posiciones = "357";
        int cont=1;
        for (char numero:numeros) {
            if(posiciones.indexOf(""+cont)>=0){
                telefono+=numero+" ";
            }else{
                telefono+=numero;
            }
            cont++;

        }
        return telefono;
    }

    public static double getDistancia(double lat1, double long1, double lat2, double long2){
        double earth = 6371*1000; //km change accordingly
        //earth = 3960; //miles

        //Point 1 cords
        lat1 = Math.toRadians(lat1);
        long1= Math.toRadians(long1);

        //Point 2 cords
        lat2 = Math.toRadians(lat2);
        long2= Math.toRadians(long2);

        //Haversine Formula
        double dlong=long2-long1;
        double dlat=lat2-lat1;

        double sinlat=sin(dlat/2);
        double sinlong=sin(dlong/2);

        double a=(sinlat*sinlat)+cos(lat1)*cos(lat2)*(sinlong*sinlong);

        double c=2*asin(min(1,sqrt(a)));

        double d=round(earth*c);

        return d;
    }

    public static String ucFirst(String str) {
        if (str == null || str.isEmpty()) {
            return str;
        } else {
            return str.substring(0, 1).toUpperCase() + str.substring(1);
        }
    }

    static  public String getDescripcionEvento(List<TipoEvento> eventos, int id){
        if(eventos==null) return "";
        String descripcion = "";
        for(int i = 0; i<eventos.size();i++){
            if(eventos.get(i).getId()==id){
                descripcion = eventos.get(i).getDescripcion();
                break;
            }
        }
        return descripcion;
    }


    static public void compartirEvento(final Context context, final EventosContent.EventoMin eventoMin, final EventosContent.Evento evento){
        //Copiamos la Foto a shared
        String foto=AppData.NO_IMAGE;
        if(evento!=null){
            foto = evento.getFoto();
        }else
        if(eventoMin!=null){
            foto = eventoMin.getFoto();
        }
        if(foto == null || foto.equals("")){
            foto= AppData.NO_IMAGE;
        }

        AppData.glideSaveExternalBMPinLocal(context,foto,AppData.FOTO_EVENTO_SHARE);

        final Item[] items = {
                new Item(context.getString(R.string.whatsapp), R.drawable.whatsapp),
                new Item(context.getString(R.string.otros), android.R.drawable.ic_menu_share),
        };

        ListAdapter adapter = new ArrayAdapter<Item>(context,android.R.layout.select_dialog_item,
                android.R.id.text1,items){
            public View getView(int position, View convertView, ViewGroup parent) {
                //Use super class to create the View
                View v = super.getView(position, convertView, parent);
                TextView tv = (TextView)v.findViewById(android.R.id.text1);
                if(Build.VERSION.SDK_INT >= 23)
                    tv.setTextColor(context.getColor(R.color.colorFacebook));

                tv.setTextSize(15);

                //Put the image on the TextView
                tv.setCompoundDrawablesWithIntrinsicBounds(items[position].icon, 0, 0, 0);

                //Add margin between image and text (support various screen densities)
                int dp5 = (int) (5 * context.getResources().getDisplayMetrics().density + 0.5f);
                tv.setCompoundDrawablePadding(dp5);

                return v;
            }
        };

        AlertDialog.Builder builder = new AlertDialog.Builder(context,R.style.TemaDialog);
        builder.setTitle(context.getResources().getString(R.string.compartir_con));
        //builder.setIcon(android.R.drawable.ic_menu_share);

        builder.setAdapter(adapter, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int which) {
                        switch (which){
                            case 0:
                                compartirWhatsApp(context,eventoMin,evento);
                                break;
                            case 1:
                                compartirCorreo(context,eventoMin,evento);
                                break;
                            default:
                                break;
                        }
                    }
                });

//        CharSequence ordenes[] = new CharSequence[] {
//                context.getResources().getString(R.string.whatsapp),      //0
//                context.getResources().getString(R.string.otros)};   // 1



        builder.setNegativeButton(context.getString(R.string.cancel), new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.show();




    }

    private static void compartirCorreo(Context context, EventosContent.EventoMin eventoMin, EventosContent.Evento evento) {
        if(evento == null && eventoMin == null){
            Toast.makeText(context,context.getString(R.string.error_sharing),Toast.LENGTH_SHORT).show();
            return;
        }

        String texto="";
        String foto="";
        if(evento!=null){
            texto = evento.getNombre() + " "+ evento.getDia() + "\n" + evento.getDescripcion();
            foto = evento.getFoto();
        }else
            if(eventoMin!=null){
                texto = eventoMin.getNombre() + " "+ eventoMin.getDia() + "\n" + eventoMin.getDescripcion();
                foto = eventoMin.getFoto();
            }
        if(foto == null || foto.equals("")){
            foto= AppData.NO_IMAGE;
        }
        Activity activity = (Activity) context;

        boolean isWhatsapp = false;

        Intent sendIntent = prepareIntent(isWhatsapp,(Activity) context, texto);

        context.startActivity(Intent.createChooser(sendIntent, context.getResources().getText(R.string.menu_share)));
    }

    private static void compartirWhatsApp(Context context, EventosContent.EventoMin eventoMin, EventosContent.Evento evento) {
        if(evento == null && eventoMin == null){
            Toast.makeText(context,context.getString(R.string.error_sharing),Toast.LENGTH_SHORT).show();
            return;
        }

        String texto="";
        if(evento!=null){
            texto = evento.getNombre() + " "+ evento.getDia() + "\n" + evento.getDescripcion();

        }else
        if(eventoMin!=null){
            texto = eventoMin.getNombre() + " "+ eventoMin.getDia() + "\n" + eventoMin.getDescripcion();

        }


        boolean isWhatsapp = true;
        Intent sendIntent = prepareIntent(isWhatsapp, (Activity) context, texto);
        try {
            context.startActivity(sendIntent);
        }catch (android.content.ActivityNotFoundException ex) {
            Toast.makeText(context, context.getText(R.string.no_whatsapp),Toast.LENGTH_SHORT).show();
        }
    }





    /*
     * Function that return a prepared intent to start
     * */
    private static Intent prepareIntent(boolean forWhatsapp, Activity mActivity,String shared_text){
        File imageFile = new File(mActivity.getFilesDir()+"/shared/", AppData.EVENT_FILE_PICTURE);
        Uri contentUri = FileProvider.getUriForFile(mActivity, "onthestage.es.onthestage.sharedprovider", imageFile);

        //Creating Intent
        Intent sendIntent = new Intent();
        sendIntent.setAction(Intent.ACTION_SEND);

        if(forWhatsapp){
            sendIntent.setPackage("com.whatsapp");
        }

        //Give permission for reading
        sendIntent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
        sendIntent.setType("image/*");


        //adding text to intent
        sendIntent.putExtra(Intent.EXTRA_TEXT, shared_text);
        //Adding icon from Uri
        sendIntent.putExtra(Intent.EXTRA_STREAM, contentUri);

        return sendIntent;
    }


    /*
     * Function that return app icon Uri
     * */
    private static boolean copyFile(Activity mActivity, Bitmap src){
        boolean error = true;
        File dir = new File(mActivity.getFilesDir()+"/shared/", "");
        dir.mkdirs();
        File destination = new File(mActivity.getFilesDir()+"/shared/", AppData.EVENT_FILE_PICTURE);
        //Getting drawable ICON
        //Drawable drawable = mActivity.getResources().getDrawable(R.mipmap.ic_launcher);
        try {
            destination.createNewFile();
        }catch(IOException ioe){
            ioe.getStackTrace();
            error = false;
        }


            FileOutputStream out = null;
            try {
                out = new FileOutputStream(destination);
                src.compress(Bitmap.CompressFormat.PNG, 100, out); // bmp is your Bitmap instance
                // PNG is a lossless format, the compression factor (100) is ignored
            } catch (Exception e) {
                e.printStackTrace();
                error = false;
            } finally {
                try {
                    if (out != null) {
                        out.close();
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                    error = false;
                }
            }
        return error;
    }


    /*Class for dialogs*/
    public static class Item{
        public final String text;
        public final int icon;
        public Item(String text, Integer icon) {
            this.text = text;
            this.icon = icon;
        }
        @Override
        public String toString() {
            return text;
        }
    }

}
